package pwc.taxtech.atms.common.util;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;
import pwc.taxtech.atms.dao.FormulaAdminMapper;
import pwc.taxtech.atms.dao.OrganizationMapper;
import pwc.taxtech.atms.dao.ProjectMapper;
import pwc.taxtech.atms.dao.ProjectServiceTypeMapper;
import pwc.taxtech.atms.dao.ProjectDao;
import pwc.taxtech.atms.service.impl.DistributedIDService;
import pwc.taxtech.atms.vat.dao.*;
import pwc.taxtech.atms.vat.dao.InputVatInvoiceDao;
import pwc.taxtech.atms.vat.dao.VatEnterpriseAccountDao;

//用来获取spring托管的bean
@Component
public class SpringContextUtil implements ApplicationContextAware {

    private static ApplicationContext webApplicationContext;

    public static FormulaProjectMapper formulaProjectMapper;
    public static FormulaAdminMapper formulaAdminMapper;
    public static ReportMapper reportMapper;
    public static CellDataMapper cellDataMapper;
    public static DistributedIDService distributedIDService;
    public static PeriodFormulaBlockMapper formulaBlockMapper;
    public static PeriodCellTemplateMapper periodCellTemplateMapper;
    public static ProjectServiceTypeMapper projectServiceTypeMapper;
    public static PeriodTemplateMapper periodTemplateMapper;
    public static VatStandardAccountMapper vatStandardAccountMapper;
    public static ProjectDao projectDao;
    public static BalanceMapper balanceMapper;
    public static DataSourceMapper dataSourceMapper;
    public static DataSourceDetailMapper dataSourceDetailMapper;
    public static PeriodFormulaBlockMapper periodFormulaBlockMapper;
    public static VatEnterpriseAccountDao vatEnterpriseAccountDao;
    public static VatEnterpriseAccountMapper vatEnterpriseAccountMapper;
    public static BalanceStdManualMapper balanceStdManualMapper;
    public static OutputVATInvoiceMapper outputVATInvoiceMapper;
    public static PeriodTaxRuleSettingMapper periodTaxRuleSettingMapper;
    public static InputVatInvoiceDao inputVatInvoiceDao;
    public static InputVATInvoiceMapper inputVATInvoiceMapper;
    public static AssetsListMapper assetsListMapper;
    public static ProjectMapper projectMapper;
    public static CellDataSourceMapper cellDataSourceMapper;
    public static OrganizationMapper organizationMapper;

    /**
     * 获取bean
     *
     * @param requiredType
     * @param <T>
     * @return
     */
    public static <T> T getBean(Class<T> requiredType) {
        return SpringContextUtil.webApplicationContext.getBean(requiredType);
    }

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        webApplicationContext = applicationContext;
        formulaProjectMapper = webApplicationContext.getBean(FormulaProjectMapper.class);
        formulaAdminMapper = webApplicationContext.getBean(FormulaAdminMapper.class);
        reportMapper = webApplicationContext.getBean(ReportMapper.class);
        cellDataMapper = webApplicationContext.getBean(CellDataMapper.class);
        distributedIDService = webApplicationContext.getBean(DistributedIDService.class);
        formulaBlockMapper = webApplicationContext.getBean(PeriodFormulaBlockMapper.class);
        periodCellTemplateMapper = webApplicationContext.getBean(PeriodCellTemplateMapper.class);
        projectServiceTypeMapper = webApplicationContext.getBean(ProjectServiceTypeMapper.class);
        periodTemplateMapper = webApplicationContext.getBean(PeriodTemplateMapper.class);
        vatStandardAccountMapper = webApplicationContext.getBean(VatStandardAccountMapper.class);
        projectDao = webApplicationContext.getBean(ProjectDao.class);
        balanceMapper = webApplicationContext.getBean(BalanceMapper.class);
        dataSourceMapper = webApplicationContext.getBean(DataSourceMapper.class);
        dataSourceDetailMapper = webApplicationContext.getBean(DataSourceDetailMapper.class);
        periodFormulaBlockMapper = webApplicationContext.getBean(PeriodFormulaBlockMapper.class);
        vatEnterpriseAccountDao = webApplicationContext.getBean(VatEnterpriseAccountDao.class);
        vatEnterpriseAccountMapper = webApplicationContext.getBean(VatEnterpriseAccountMapper.class);
        balanceStdManualMapper = webApplicationContext.getBean(BalanceStdManualMapper.class);
        outputVATInvoiceMapper = webApplicationContext.getBean(OutputVATInvoiceMapper.class);
        periodTaxRuleSettingMapper = webApplicationContext.getBean(PeriodTaxRuleSettingMapper.class);
        inputVatInvoiceDao = webApplicationContext.getBean(InputVatInvoiceDao.class);
        inputVATInvoiceMapper = webApplicationContext.getBean(InputVATInvoiceMapper.class);
        assetsListMapper = webApplicationContext.getBean(AssetsListMapper.class);
        projectMapper = webApplicationContext.getBean(ProjectMapper.class);
        cellDataSourceMapper = webApplicationContext.getBean(CellDataSourceMapper.class);
        organizationMapper = webApplicationContext.getBean(OrganizationMapper.class);
    }
}
