package pwc.taxtech.atms.dao;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.entity.AccountMappingManual;
import pwc.taxtech.atms.entity.AccountMappingManualExample;

import java.util.List;
import java.util.Optional;

@Service
public class AccountMappingManualDao {
    @Autowired
    AccountMappingManualMapper mapper;

    public Optional<List<AccountMappingManual>> getAll() {
        AccountMappingManualExample example = new AccountMappingManualExample();
        return Optional.ofNullable(mapper.selectByExample(example));
    }

    public void delMapping(String fullName,String epAccountSetID,String orgID,String industryID){
        AccountMappingManualExample example = new AccountMappingManualExample();
        AccountMappingManualExample.Criteria criteria = example.createCriteria();
        criteria.andFullNameEqualTo(fullName);
        criteria.andEnterpriseAccountSetIDEqualTo(epAccountSetID);
        criteria.andOrganizationIDEqualTo(StringUtils.defaultString(orgID));
        criteria.andIndustryIDEqualTo(StringUtils.defaultString(industryID));
        mapper.deleteByExample(example);
    }
}
