package pwc.taxtech.atms.service;

import java.util.List;

import pwc.taxtech.atms.dto.VMRegionDevTreeData;
import pwc.taxtech.atms.dto.navtree.DevTreeDto;
import pwc.taxtech.atms.dto.navtree.IvhTreeDto;
import pwc.taxtech.atms.entity.Region;

public interface RegionService {

	/**
	 * Generate Area and Region Tree
	 * @return List<DevTreeDto>
	 */
	public List<DevTreeDto<VMRegionDevTreeData>> getRegionAreaTree();
	
	/**
	 * Generate Region and City Tree 
	 * @return
	 */
	public List<DevTreeDto<IvhTreeDto<Region>>> getProvinceAndCityTreeList();
	
	@SuppressWarnings("rawtypes")
    List<DevTreeDto> getAreaRegionTreeByNodeID(String areaID);
	
}
