package pwc.taxtech.atms.vat.dao;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.vat.dao.InputVATInvoiceMapper;
import pwc.taxtech.atms.vat.entity.InputVATInvoice;
import pwc.taxtech.atms.vat.entity.InputVATInvoiceExample;

import java.util.List;

@Service
public class InputVatInvoiceDao {
    @Autowired
    InputVATInvoiceMapper inputVATInvoiceMapper;

    public List<InputVATInvoice> getInputVATInvoice(Integer period, Integer invoiceType, String checkPass, String scanPass,String notPass) {
        InputVATInvoiceExample example = new InputVATInvoiceExample();
        InputVATInvoiceExample.Criteria criteria = example.createCriteria();
        InputVATInvoiceExample.Criteria criteria1 = example.createCriteria();

        if (period != null) {

            criteria.andPeriodIDEqualTo(period);
            criteria1.andPeriodIDEqualTo(period);
        }
        if (invoiceType != null) {
            criteria.andInvoiceTypeEqualTo(invoiceType);
            criteria1.andInvoiceTypeEqualTo(invoiceType);
        }

        if(StringUtils.isNotBlank(notPass)){
            criteria.andCertificationResultEqualTo(notPass);
            criteria1.andCertificationResultEqualTo(notPass);
        }
        else if(StringUtils.isNotBlank(checkPass)&&StringUtils.isNotBlank(scanPass)){
            criteria.andCertificationResultEqualTo(checkPass);
            criteria.andCertificationResultEqualTo(scanPass);
            example.or(criteria1);
        }

        return inputVATInvoiceMapper.selectByExample(example);
    }
}
