package pwc.taxtech.atms.controller;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;
import pwc.taxtech.atms.dpo.OrganizationDto;
import pwc.taxtech.atms.dto.navtree.NavTreeDto;
import pwc.taxtech.atms.dto.organization.DimensionRoleDto;
import pwc.taxtech.atms.service.OrganizationService;
import pwc.taxtech.atms.service.UserRoleService;
import pwc.taxtech.atms.service.UserService;

import java.util.ArrayList;
import java.util.List;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

@RunWith(MockitoJUnitRunner.class)
public class OrganizationControllerTest {

    @Mock
    private OrganizationService organizationService;
    
    @Mock
    private UserRoleService userRoleService;
    
    @Mock
    private UserService userService;

    @InjectMocks
    private OrganizationController organizationController = new OrganizationController();

    @Test
    public void getOrganizationFilterListTest() {
        List<OrganizationDto> organizationDtoList = new ArrayList<>();

        when(organizationService.getOrganizationFilterList()).thenReturn(organizationDtoList);
        assertThat(organizationController.getOrganizationFilterList()).isNotNull();
    }

    @Test
    public void getOrgListToJsonTest() {
        List<NavTreeDto> navTreeDtos = new ArrayList<>();
        Integer useType = 0;
        when(organizationService.getOrgListToJson(useType)).thenReturn(navTreeDtos);
        assertThat(organizationController.getOrgListToJson(useType)).isNotNull();
    }

    @Test
    public void getOrgListTest() {
        List<OrganizationDto> organizationDtos = new ArrayList<>();
        Integer useType = 0;
        when(organizationService.getOrgList(useType)).thenReturn(organizationDtos);
        assertThat(organizationController.getOrgList(useType)).isNotNull();
    }
    
    @Test
    public void getOrgBuAreaIndustryUserTest() {
        List<DimensionRoleDto> dimensionRoleDtos = new ArrayList<>();
        when(userRoleService.getOrgBuAreaIndustryUser("userID")).thenReturn(dimensionRoleDtos);
        assertThat(organizationController.getOrgBuAreaIndustryUser("userID")).isNotNull();
    }
    
    @Test
    public void deleteUserDimensionValueTest() {
        DimensionRoleDto dto = new DimensionRoleDto();
        assertThat(organizationController.deleteUserDimensionValue(dto, "userID")).isNotNull();
    }
}
