package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "ACCOUNT_MAPPING", schema = PROJECT_ADMIN, catalog = "")
public class AccountMapping {
    private String id;
    private String enterpriseAccountCode;
    private String standardAccountCode;
    private String enterpriseAccountSetId;
    private String organizationId;
    private String industryId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ENTERPRISE_ACCOUNT_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEnterpriseAccountCode() {
        return enterpriseAccountCode;
    }

    public void setEnterpriseAccountCode(String enterpriseAccountCode) {
        this.enterpriseAccountCode = enterpriseAccountCode;
    }

    @Basic
    @Column(name = "STANDARD_ACCOUNT_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getStandardAccountCode() {
        return standardAccountCode;
    }

    public void setStandardAccountCode(String standardAccountCode) {
        this.standardAccountCode = standardAccountCode;
    }

    @Basic
    @Column(name = "ENTERPRISE_ACCOUNT_SET_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEnterpriseAccountSetId() {
        return enterpriseAccountSetId;
    }

    public void setEnterpriseAccountSetId(String enterpriseAccountSetId) {
        this.enterpriseAccountSetId = enterpriseAccountSetId;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "INDUSTRY_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndustryId() {
        return industryId;
    }

    public void setIndustryId(String industryId) {
        this.industryId = industryId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AccountMapping that = (AccountMapping) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(enterpriseAccountCode, that.enterpriseAccountCode) &&
                Objects.equals(standardAccountCode, that.standardAccountCode) &&
                Objects.equals(enterpriseAccountSetId, that.enterpriseAccountSetId) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(industryId, that.industryId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, enterpriseAccountCode, standardAccountCode, enterpriseAccountSetId, organizationId, industryId);
    }
}
