package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ASSET_DETAIL_GROUP", schema = PROJECT_ADMIN, catalog = "")
public class AssetDetailGroup {
    private String id;
    private String assetGroupId;
    private String detailGroupName;
    private Integer assetGroupType;
    private Integer groupYear;
    private Date createTime;
    private Date updateTime;
    private Integer detailGroupType;
    private String keyValues;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ASSET_GROUP_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAssetGroupId() {
        return assetGroupId;
    }

    public void setAssetGroupId(String assetGroupId) {
        this.assetGroupId = assetGroupId;
    }

    @Basic
    @Column(name = "DETAIL_GROUP_NAME", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDetailGroupName() {
        return detailGroupName;
    }

    public void setDetailGroupName(String detailGroupName) {
        this.detailGroupName = detailGroupName;
    }

    @Basic
    @Column(name = "ASSET_GROUP_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAssetGroupType() {
        return assetGroupType;
    }

    public void setAssetGroupType(Integer assetGroupType) {
        this.assetGroupType = assetGroupType;
    }

    @Basic
    @Column(name = "GROUP_YEAR", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getGroupYear() {
        return groupYear;
    }

    public void setGroupYear(Integer groupYear) {
        this.groupYear = groupYear;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "DETAIL_GROUP_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDetailGroupType() {
        return detailGroupType;
    }

    public void setDetailGroupType(Integer detailGroupType) {
        this.detailGroupType = detailGroupType;
    }

    @Basic
    @Column(name = "KEY_VALUES", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getKeyValues() {
        return keyValues;
    }

    public void setKeyValues(String keyValues) {
        this.keyValues = keyValues;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AssetDetailGroup that = (AssetDetailGroup) o;
        return assetGroupType == that.assetGroupType &&
                groupYear == that.groupYear &&
                detailGroupType == that.detailGroupType &&
                Objects.equals(id, that.id) &&
                Objects.equals(assetGroupId, that.assetGroupId) &&
                Objects.equals(detailGroupName, that.detailGroupName) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(keyValues, that.keyValues);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, assetGroupId, detailGroupName, assetGroupType, groupYear, createTime, updateTime, detailGroupType, keyValues);
    }
}
