package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "CACHE", schema = PROJECT_ADMIN, catalog = "")
public class Cache {
    private String id;
    private String cacheKey;
    private String lastModifyTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CACHE_KEY", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCacheKey() {
        return cacheKey;
    }

    public void setCacheKey(String cacheKey) {
        this.cacheKey = cacheKey;
    }

    @Basic
    @Column(name = "LAST_MODIFY_TIME", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getLastModifyTime() {
        return lastModifyTime;
    }

    public void setLastModifyTime(String lastModifyTime) {
        this.lastModifyTime = lastModifyTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Cache cache = (Cache) o;
        return Objects.equals(id, cache.id) &&
                Objects.equals(cacheKey, cache.cacheKey) &&
                Objects.equals(lastModifyTime, cache.lastModifyTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, cacheKey, lastModifyTime);
    }
}
