package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "CELL_TEMPLATE", schema = PROJECT_ADMIN, catalog = "")
public class CellTemplate {
    private Long id;
    private Long reportTemplateId;
    private Integer rowIndex;
    private String rowName;
    private Integer columnIndex;
    private String columnName;
    private String comment;
    private Date createTime;
    private Date updateTime;
    private Long copyFromId;
    private Integer dataType;
    private Boolean isReadOnly;
    private String createBy;
    private String updateBy;

    @Id
    @Column(name = "ID", nullable = false)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "REPORT_TEMPLATE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getReportTemplateId() {
        return reportTemplateId;
    }

    public void setReportTemplateId(Long reportTemplateId) {
        this.reportTemplateId = reportTemplateId;
    }

    @Basic
    @Column(name = "ROW_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getRowIndex() {
        return rowIndex;
    }

    public void setRowIndex(Integer rowIndex) {
        this.rowIndex = rowIndex;
    }

    @Basic
    @Column(name = "ROW_NAME", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRowName() {
        return rowName;
    }

    public void setRowName(String rowName) {
        this.rowName = rowName;
    }

    @Basic
    @Column(name = "COLUMN_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getColumnIndex() {
        return columnIndex;
    }

    public void setColumnIndex(Integer columnIndex) {
        this.columnIndex = columnIndex;
    }

    @Basic
    @Column(name = "COLUMN_NAME", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getColumnName() {
        return columnName;
    }

    public void setColumnName(String columnName) {
        this.columnName = columnName;
    }

    @Basic
    @Column(name = B_Delimiter + "COMMENT" + E_Delimiter, nullable = false, length = 3000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "COPY_FROM_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getCopyFromId() {
        return copyFromId;
    }

    public void setCopyFromId(Long copyFromId) {
        this.copyFromId = copyFromId;
    }

    @Basic
    @Column(name = "DATA_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDataType() {
        return dataType;
    }

    public void setDataType(Integer dataType) {
        this.dataType = dataType;
    }

    @Basic
    @Column(name = "IS_READ_ONLY", nullable = false)
    public Boolean getIsReadOnly() {
        return isReadOnly;
    }

    public void setIsReadOnly(Boolean isReadOnly) {
        this.isReadOnly = isReadOnly;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CellTemplate that = (CellTemplate) o;
        return id == that.id &&
                reportTemplateId == that.reportTemplateId &&
                rowIndex == that.rowIndex &&
                columnIndex == that.columnIndex &&
                copyFromId == that.copyFromId &&
                dataType == that.dataType &&
                isReadOnly == that.isReadOnly &&
                Objects.equals(rowName, that.rowName) &&
                Objects.equals(columnName, that.columnName) &&
                Objects.equals(comment, that.comment) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(createBy, that.createBy) &&
                Objects.equals(updateBy, that.updateBy);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, reportTemplateId, rowIndex, rowName, columnIndex, columnName, comment, createTime, updateTime, copyFromId, dataType, isReadOnly, createBy, updateBy);
    }
}
