package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "CELL_TEMPLATE_CONFIG", schema = PROJECT_ADMIN, catalog = "")
public class CellTemplateConfig {
    private Long id;
    private Long cellTemplateId;
    private Long reportTemplateId;
    private Integer dataSourceType;
    private String formula;
    private String formulaDescription;
    private String accountCodes;
    private Integer invoiceType;
    private String taxRate;
    private Integer invoiceAmountType;
    private String modelIds;
    private String createBy;
    private Date createTime;
    private String updateBy;
    private Date updateTime;
    private String invoiceCategory;
    private String formulaDataSource;
    private String validation;
    private String validationDescription;
    private String voucherKeyword;

    @Id
    @Column(name = "ID", nullable = false)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CELL_TEMPLATE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getCellTemplateId() {
        return cellTemplateId;
    }

    public void setCellTemplateId(Long cellTemplateId) {
        this.cellTemplateId = cellTemplateId;
    }

    @Basic
    @Column(name = "REPORT_TEMPLATE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getReportTemplateId() {
        return reportTemplateId;
    }

    public void setReportTemplateId(Long reportTemplateId) {
        this.reportTemplateId = reportTemplateId;
    }

    @Basic
    @Column(name = "DATA_SOURCE_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDataSourceType() {
        return dataSourceType;
    }

    public void setDataSourceType(Integer dataSourceType) {
        this.dataSourceType = dataSourceType;
    }

    @Basic
    @Column(name = "FORMULA", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFormula() {
        return formula;
    }

    public void setFormula(String formula) {
        this.formula = formula;
    }

    @Basic
    @Column(name = "FORMULA_DESCRIPTION", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFormulaDescription() {
        return formulaDescription;
    }

    public void setFormulaDescription(String formulaDescription) {
        this.formulaDescription = formulaDescription;
    }

    @Basic
    @Column(name = "ACCOUNT_CODES", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAccountCodes() {
        return accountCodes;
    }

    public void setAccountCodes(String accountCodes) {
        this.accountCodes = accountCodes;
    }

    @Basic
    @Column(name = "INVOICE_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getInvoiceType() {
        return invoiceType;
    }

    public void setInvoiceType(Integer invoiceType) {
        this.invoiceType = invoiceType;
    }

    @Basic
    @Column(name = "TAX_RATE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxRate() {
        return taxRate;
    }

    public void setTaxRate(String taxRate) {
        this.taxRate = taxRate;
    }

    @Basic
    @Column(name = "INVOICE_AMOUNT_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getInvoiceAmountType() {
        return invoiceAmountType;
    }

    public void setInvoiceAmountType(Integer invoiceAmountType) {
        this.invoiceAmountType = invoiceAmountType;
    }

    @Basic
    @Column(name = "MODEL_IDS", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelIds() {
        return modelIds;
    }

    public void setModelIds(String modelIds) {
        this.modelIds = modelIds;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "INVOICE_CATEGORY", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceCategory() {
        return invoiceCategory;
    }

    public void setInvoiceCategory(String invoiceCategory) {
        this.invoiceCategory = invoiceCategory;
    }

    @Basic
    @Column(name = "FORMULA_DATA_SOURCE", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFormulaDataSource() {
        return formulaDataSource;
    }

    public void setFormulaDataSource(String formulaDataSource) {
        this.formulaDataSource = formulaDataSource;
    }

    @Basic
    @Column(name = "VALIDATION", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getValidation() {
        return validation;
    }

    public void setValidation(String validation) {
        this.validation = validation;
    }

    @Basic
    @Column(name = "VALIDATION_DESCRIPTION", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getValidationDescription() {
        return validationDescription;
    }

    public void setValidationDescription(String validationDescription) {
        this.validationDescription = validationDescription;
    }

    @Basic
    @Column(name = "VOUCHER_KEYWORD", nullable = true, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVoucherKeyword() {
        return voucherKeyword;
    }

    public void setVoucherKeyword(String voucherKeyword) {
        this.voucherKeyword = voucherKeyword;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CellTemplateConfig that = (CellTemplateConfig) o;
        return id == that.id &&
                cellTemplateId == that.cellTemplateId &&
                reportTemplateId == that.reportTemplateId &&
                dataSourceType == that.dataSourceType &&
                invoiceType == that.invoiceType &&
                invoiceAmountType == that.invoiceAmountType &&
                Objects.equals(formula, that.formula) &&
                Objects.equals(formulaDescription, that.formulaDescription) &&
                Objects.equals(accountCodes, that.accountCodes) &&
                Objects.equals(taxRate, that.taxRate) &&
                Objects.equals(modelIds, that.modelIds) &&
                Objects.equals(createBy, that.createBy) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateBy, that.updateBy) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(invoiceCategory, that.invoiceCategory) &&
                Objects.equals(formulaDataSource, that.formulaDataSource) &&
                Objects.equals(validation, that.validation) &&
                Objects.equals(validationDescription, that.validationDescription) &&
                Objects.equals(voucherKeyword, that.voucherKeyword);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, cellTemplateId, reportTemplateId, dataSourceType, formula, formulaDescription, accountCodes, invoiceType, taxRate, invoiceAmountType, modelIds, createBy, createTime, updateBy, updateTime, invoiceCategory, formulaDataSource, validation, validationDescription, voucherKeyword);
    }
}
