package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "CUSTOMER", schema = PROJECT_ADMIN, catalog = "")
public class Customer {
    private String id;
    private String code;
    private String name;
    private String enterPriseAccountId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "ENTER_PRISE_ACCOUNT_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEnterPriseAccountId() {
        return enterPriseAccountId;
    }

    public void setEnterPriseAccountId(String enterPriseAccountId) {
        this.enterPriseAccountId = enterPriseAccountId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Customer customer = (Customer) o;
        return Objects.equals(id, customer.id) &&
                Objects.equals(code, customer.code) &&
                Objects.equals(name, customer.name) &&
                Objects.equals(enterPriseAccountId, customer.enterPriseAccountId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, code, name, enterPriseAccountId);
    }
}
