package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "DICTIONARY", schema = PROJECT_ADMIN, catalog = "")
public class Dictionary {
    private String id;
    private String code;
    private String dictKey;
    private String dictValue;
    private String parentCode;
    private Integer orderIndex;
    private Boolean isActive;
    private Date createTime;
    private Date updateTime;
    private String remark;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "DICT_KEY", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDictKey() {
        return dictKey;
    }

    public void setDictKey(String dictKey) {
        this.dictKey = dictKey;
    }

    @Basic
    @Column(name = "DICT_VALUE", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getDictValue() {
        return dictValue;
    }

    public void setDictValue(String dictValue) {
        this.dictValue = dictValue;
    }

    @Basic
    @Column(name = "PARENT_CODE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParentCode() {
        return parentCode;
    }

    public void setParentCode(String parentCode) {
        this.parentCode = parentCode;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Integer orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "REMARK", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Dictionary that = (Dictionary) o;
        return orderIndex == that.orderIndex &&
                isActive == that.isActive &&
                Objects.equals(id, that.id) &&
                Objects.equals(code, that.code) &&
                Objects.equals(dictKey, that.dictKey) &&
                Objects.equals(dictValue, that.dictValue) &&
                Objects.equals(parentCode, that.parentCode) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(remark, that.remark);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, code, dictKey, dictValue, parentCode, orderIndex, isActive, createTime, updateTime, remark);
    }
}
