package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "DIMENSION", schema = PROJECT_ADMIN, catalog = "")
public class Dimension {
    private String id;
    private String name;
    private String attributeId;
    private Boolean orderIndex;
    private Boolean isMandatory;
    private Boolean isActive;
    private Boolean isSystemDimension;
    private String createBy;
    private String updateBy;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "ATTRIBUTE_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAttributeId() {
        return attributeId;
    }

    public void setAttributeId(String attributeId) {
        this.attributeId = attributeId;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = false)
    public Boolean getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Boolean orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Basic
    @Column(name = "IS_MANDATORY", nullable = false)
    public Boolean getIsMandatory() {
        return isMandatory;
    }

    public void setIsMandatory(Boolean isMandatory) {
        this.isMandatory = isMandatory;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Basic
    @Column(name = "IS_SYSTEM_DIMENSION", nullable = false)
    public Boolean getIsSystemDimension() {
        return isSystemDimension;
    }

    public void setIsSystemDimension(Boolean isSystemDimension) {
        this.isSystemDimension = isSystemDimension;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Dimension dimension = (Dimension) o;
        return orderIndex == dimension.orderIndex &&
                isMandatory == dimension.isMandatory &&
                isActive == dimension.isActive &&
                isSystemDimension == dimension.isSystemDimension &&
                Objects.equals(id, dimension.id) &&
                Objects.equals(name, dimension.name) &&
                Objects.equals(attributeId, dimension.attributeId) &&
                Objects.equals(createBy, dimension.createBy) &&
                Objects.equals(updateBy, dimension.updateBy) &&
                Objects.equals(createTime, dimension.createTime) &&
                Objects.equals(updateTime, dimension.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, attributeId, orderIndex, isMandatory, isActive, isSystemDimension, createBy, updateBy, createTime, updateTime);
    }
}
