package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ENTERPRISE_ACCOUNT_SET_ORG", schema = PROJECT_ADMIN, catalog = "")
public class EnterpriseAccountSetOrg {
    private String id;
    private String enterpriseAccountSetId;
    private String organizationId;
    private Date effectiveDate;
    private Date expiredDate;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ENTERPRISE_ACCOUNT_SET_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEnterpriseAccountSetId() {
        return enterpriseAccountSetId;
    }

    public void setEnterpriseAccountSetId(String enterpriseAccountSetId) {
        this.enterpriseAccountSetId = enterpriseAccountSetId;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "EFFECTIVE_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getEffectiveDate() {
        return effectiveDate;
    }

    public void setEffectiveDate(Date effectiveDate) {
        this.effectiveDate = effectiveDate;
    }

    @Basic
    @Column(name = "EXPIRED_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getExpiredDate() {
        return expiredDate;
    }

    public void setExpiredDate(Date expiredDate) {
        this.expiredDate = expiredDate;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        EnterpriseAccountSetOrg that = (EnterpriseAccountSetOrg) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(enterpriseAccountSetId, that.enterpriseAccountSetId) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(effectiveDate, that.effectiveDate) &&
                Objects.equals(expiredDate, that.expiredDate);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, enterpriseAccountSetId, organizationId, effectiveDate, expiredDate);
    }
}
