package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "FORMULA_CONFIG", schema = PROJECT_ADMIN, catalog = "")
public class FormulaConfig {
    private String id;
    private String formulaName;
    private String description;
    private Integer calculateStatus;
    private Integer dataSourceType;
    private String dataSourceName;
    private String chineseName;
    private String englishName;
    private String serviceType;
    private String industry;
    private Integer requiredParamNum;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "FORMULA_NAME", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getFormulaName() {
        return formulaName;
    }

    public void setFormulaName(String formulaName) {
        this.formulaName = formulaName;
    }

    @Basic
    @Column(name = "DESCRIPTION", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Basic
    @Column(name = "CALCULATE_STATUS", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getCalculateStatus() {
        return calculateStatus;
    }

    public void setCalculateStatus(Integer calculateStatus) {
        this.calculateStatus = calculateStatus;
    }

    @Basic
    @Column(name = "DATA_SOURCE_TYPE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDataSourceType() {
        return dataSourceType;
    }

    public void setDataSourceType(Integer dataSourceType) {
        this.dataSourceType = dataSourceType;
    }

    @Basic
    @Column(name = "DATA_SOURCE_NAME", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getDataSourceName() {
        return dataSourceName;
    }

    public void setDataSourceName(String dataSourceName) {
        this.dataSourceName = dataSourceName;
    }

    @Basic
    @Column(name = "CHINESE_NAME", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getChineseName() {
        return chineseName;
    }

    public void setChineseName(String chineseName) {
        this.chineseName = chineseName;
    }

    @Basic
    @Column(name = "ENGLISH_NAME", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getEnglishName() {
        return englishName;
    }

    public void setEnglishName(String englishName) {
        this.englishName = englishName;
    }

    @Basic
    @Column(name = "SERVICE_TYPE", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getServiceType() {
        return serviceType;
    }

    public void setServiceType(String serviceType) {
        this.serviceType = serviceType;
    }

    @Basic
    @Column(name = "INDUSTRY", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndustry() {
        return industry;
    }

    public void setIndustry(String industry) {
        this.industry = industry;
    }

    @Basic
    @Column(name = "REQUIRED_PARAM_NUM", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getRequiredParamNum() {
        return requiredParamNum;
    }

    public void setRequiredParamNum(Integer requiredParamNum) {
        this.requiredParamNum = requiredParamNum;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        FormulaConfig that = (FormulaConfig) o;
        return calculateStatus == that.calculateStatus &&
                Objects.equals(id, that.id) &&
                Objects.equals(formulaName, that.formulaName) &&
                Objects.equals(description, that.description) &&
                Objects.equals(dataSourceType, that.dataSourceType) &&
                Objects.equals(dataSourceName, that.dataSourceName) &&
                Objects.equals(chineseName, that.chineseName) &&
                Objects.equals(englishName, that.englishName) &&
                Objects.equals(serviceType, that.serviceType) &&
                Objects.equals(industry, that.industry) &&
                Objects.equals(requiredParamNum, that.requiredParamNum);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, formulaName, description, calculateStatus, dataSourceType, dataSourceName, chineseName, englishName, serviceType, industry, requiredParamNum);
    }
}
