package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "FORMULA_PARAM_CONFIG", schema = PROJECT_ADMIN, catalog = "")
public class FormulaParamConfig {
    private String id;
    private String name;
    private String displayFormat;
    private Integer paramType;
    private Integer paramDataType;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "NAME", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "DISPLAY_FORMAT", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getDisplayFormat() {
        return displayFormat;
    }

    public void setDisplayFormat(String displayFormat) {
        this.displayFormat = displayFormat;
    }

    @Basic
    @Column(name = "PARAM_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getParamType() {
        return paramType;
    }

    public void setParamType(Integer paramType) {
        this.paramType = paramType;
    }

    @Basic
    @Column(name = "PARAM_DATA_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getParamDataType() {
        return paramDataType;
    }

    public void setParamDataType(Integer paramDataType) {
        this.paramDataType = paramDataType;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        FormulaParamConfig that = (FormulaParamConfig) o;
        return paramType == that.paramType &&
                paramDataType == that.paramDataType &&
                Objects.equals(id, that.id) &&
                Objects.equals(name, that.name) &&
                Objects.equals(displayFormat, that.displayFormat);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, displayFormat, paramType, paramDataType);
    }
}
