package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "FORMULA_PARAM_MAPPING", schema = PROJECT_ADMIN, catalog = "")
public class FormulaParamMapping {
    private String id;
    private String formulaId;
    private String formulaParamId;
    private Integer paramIndex;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "FORMULA_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFormulaId() {
        return formulaId;
    }

    public void setFormulaId(String formulaId) {
        this.formulaId = formulaId;
    }

    @Basic
    @Column(name = "FORMULA_PARAM_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFormulaParamId() {
        return formulaParamId;
    }

    public void setFormulaParamId(String formulaParamId) {
        this.formulaParamId = formulaParamId;
    }

    @Basic
    @Column(name = "PARAM_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getParamIndex() {
        return paramIndex;
    }

    public void setParamIndex(Integer paramIndex) {
        this.paramIndex = paramIndex;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        FormulaParamMapping that = (FormulaParamMapping) o;
        return paramIndex == that.paramIndex &&
                Objects.equals(id, that.id) &&
                Objects.equals(formulaId, that.formulaId) &&
                Objects.equals(formulaParamId, that.formulaParamId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, formulaId, formulaParamId, paramIndex);
    }
}
