package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "FORMULA_PARAM_OPTION", schema = PROJECT_ADMIN, catalog = "")
public class FormulaParamOption {
    private String id;
    private String formulaParamId;
    private String value;
    private String name;
    private String shortName;
    private Integer optionIndex;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "FORMULA_PARAM_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFormulaParamId() {
        return formulaParamId;
    }

    public void setFormulaParamId(String formulaParamId) {
        this.formulaParamId = formulaParamId;
    }

    @Basic
    @Column(name = "VALUE", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @Basic
    @Column(name = "NAME", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "SHORT_NAME", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getShortName() {
        return shortName;
    }

    public void setShortName(String shortName) {
        this.shortName = shortName;
    }

    @Basic
    @Column(name = "OPTION_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getOptionIndex() {
        return optionIndex;
    }

    public void setOptionIndex(Integer optionIndex) {
        this.optionIndex = optionIndex;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        FormulaParamOption that = (FormulaParamOption) o;
        return optionIndex == that.optionIndex &&
                Objects.equals(id, that.id) &&
                Objects.equals(formulaParamId, that.formulaParamId) &&
                Objects.equals(value, that.value) &&
                Objects.equals(name, that.name) &&
                Objects.equals(shortName, that.shortName);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, formulaParamId, value, name, shortName, optionIndex);
    }
}
