package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "KEY_VALUE_CONFIG", schema = PROJECT_ADMIN, catalog = "")
public class KeyValueConfig {
    private String id;
    private String keyCode;
    private String name;
    private Integer keyValueType;
    private String formula;
    private Integer isConstant;
    private Integer calculateStatus;
    private Integer resultType;
    private String serviceTypeIDs;
    private String industryIDs;
    private String description;
    private String creator;
    private Date createTime;
    private String updator;
    private Date updateTime;
    private String dataSource;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "KEY_CODE", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getKeyCode() {
        return keyCode;
    }

    public void setKeyCode(String keyCode) {
        this.keyCode = keyCode;
    }

    @Basic
    @Column(name = "NAME", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "KEY_VALUE_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getKeyValueType() {
        return keyValueType;
    }

    public void setKeyValueType(Integer keyValueType) {
        this.keyValueType = keyValueType;
    }

    @Basic
    @Column(name = "FORMULA", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getFormula() {
        return formula;
    }

    public void setFormula(String formula) {
        this.formula = formula;
    }

    @Basic
    @Column(name = "IS_CONSTANT", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsConstant() {
        return isConstant;
    }

    public void setIsConstant(Integer isConstant) {
        this.isConstant = isConstant;
    }

    @Basic
    @Column(name = "CALCULATE_STATUS", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getCalculateStatus() {
        return calculateStatus;
    }

    public void setCalculateStatus(Integer calculateStatus) {
        this.calculateStatus = calculateStatus;
    }

    @Basic
    @Column(name = "RESULT_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getResultType() {
        return resultType;
    }

    public void setResultType(Integer resultType) {
        this.resultType = resultType;
    }

    @Basic
    @Column(name = "SERVICE_TYPE_IDS", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getServiceTypeIDs() {
        return serviceTypeIDs;
    }

    public void setServiceTypeIDs(String serviceTypeIDs) {
        this.serviceTypeIDs = serviceTypeIDs;
    }

    @Basic
    @Column(name = "INDUSTRY_IDS", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndustryIDs() {
        return industryIDs;
    }

    public void setIndustryIDs(String industryIDs) {
        this.industryIDs = industryIDs;
    }

    @Basic
    @Column(name = "DESCRIPTION", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Basic
    @Column(name = "CREATOR", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATOR", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdator() {
        return updator;
    }

    public void setUpdator(String updator) {
        this.updator = updator;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "DATA_SOURCE", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDataSource() {
        return dataSource;
    }

    public void setDataSource(String dataSource) {
        this.dataSource = dataSource;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        KeyValueConfig that = (KeyValueConfig) o;
        return keyValueType == that.keyValueType &&
                isConstant == that.isConstant &&
                calculateStatus == that.calculateStatus &&
                resultType == that.resultType &&
                Objects.equals(id, that.id) &&
                Objects.equals(keyCode, that.keyCode) &&
                Objects.equals(name, that.name) &&
                Objects.equals(formula, that.formula) &&
                Objects.equals(serviceTypeIDs, that.serviceTypeIDs) &&
                Objects.equals(industryIDs, that.industryIDs) &&
                Objects.equals(description, that.description) &&
                Objects.equals(creator, that.creator) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updator, that.updator) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(dataSource, that.dataSource);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, keyCode, name, keyValueType, formula, isConstant, calculateStatus, resultType, serviceTypeIDs, industryIDs, description, creator, createTime, updator, updateTime, dataSource);
    }
}
