package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "KEY_VALUE_REFERENCE", schema = PROJECT_ADMIN, catalog = "")
public class KeyValueReference {
    private String id;
    private String keyValueConfigId;
    private Integer scope;
    private Long cellTemplateId;
    private String modelId;
    private String organizationId;
    private String industryId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "KEY_VALUE_CONFIG_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getKeyValueConfigId() {
        return keyValueConfigId;
    }

    public void setKeyValueConfigId(String keyValueConfigId) {
        this.keyValueConfigId = keyValueConfigId;
    }

    @Basic
    @Column(name = "SCOPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getScope() {
        return scope;
    }

    public void setScope(Integer scope) {
        this.scope = scope;
    }

    @Basic
    @Column(name = "CELL_TEMPLATE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getCellTemplateId() {
        return cellTemplateId;
    }

    public void setCellTemplateId(Long cellTemplateId) {
        this.cellTemplateId = cellTemplateId;
    }

    @Basic
    @Column(name = "MODEL_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelId() {
        return modelId;
    }

    public void setModelId(String modelId) {
        this.modelId = modelId;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "INDUSTRY_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndustryId() {
        return industryId;
    }

    public void setIndustryId(String industryId) {
        this.industryId = industryId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        KeyValueReference that = (KeyValueReference) o;
        return scope == that.scope &&
                cellTemplateId == that.cellTemplateId &&
                Objects.equals(id, that.id) &&
                Objects.equals(keyValueConfigId, that.keyValueConfigId) &&
                Objects.equals(modelId, that.modelId) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(industryId, that.industryId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, keyValueConfigId, scope, cellTemplateId, modelId, organizationId, industryId);
    }
}
