package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "MENU", schema = PROJECT_ADMIN, catalog = "")
public class Menu {
    private String id;
    private String name;
    private String routeStateName;
    private String navigationUrl;
    private String iconClassName;
    private String parentId;
    private Integer orderIndex;
    private Boolean isActive;
    private Boolean isVisible;
    private String serviceTypeId;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "ROUTE_STATE_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRouteStateName() {
        return routeStateName;
    }

    public void setRouteStateName(String routeStateName) {
        this.routeStateName = routeStateName;
    }

    @Basic
    @Column(name = "NAVIGATION_URL", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getNavigationUrl() {
        return navigationUrl;
    }

    public void setNavigationUrl(String navigationUrl) {
        this.navigationUrl = navigationUrl;
    }

    @Basic
    @Column(name = "ICON_CLASS_NAME", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getIconClassName() {
        return iconClassName;
    }

    public void setIconClassName(String iconClassName) {
        this.iconClassName = iconClassName;
    }

    @Basic
    @Column(name = "PARENT_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Integer orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Basic
    @Column(name = "IS_VISIBLE", nullable = false)
    public Boolean getIsVisible() {
        return isVisible;
    }

    public void setIsVisible(Boolean isVisible) {
        this.isVisible = isVisible;
    }

    @Basic
    @Column(name = "SERVICE_TYPE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getServiceTypeId() {
        return serviceTypeId;
    }

    public void setServiceTypeId(String serviceTypeId) {
        this.serviceTypeId = serviceTypeId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Menu menu = (Menu) o;
        return orderIndex == menu.orderIndex &&
                isActive == menu.isActive &&
                isVisible == menu.isVisible &&
                Objects.equals(id, menu.id) &&
                Objects.equals(name, menu.name) &&
                Objects.equals(routeStateName, menu.routeStateName) &&
                Objects.equals(navigationUrl, menu.navigationUrl) &&
                Objects.equals(iconClassName, menu.iconClassName) &&
                Objects.equals(parentId, menu.parentId) &&
                Objects.equals(serviceTypeId, menu.serviceTypeId) &&
                Objects.equals(createTime, menu.createTime) &&
                Objects.equals(updateTime, menu.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, routeStateName, navigationUrl, iconClassName, parentId, orderIndex, isActive, isVisible, serviceTypeId, createTime, updateTime);
    }
}
