package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "MODEL", schema = PROJECT_ADMIN, catalog = "")
public class Model {
    private String id;
    private Integer ruleType;
    private String code;
    private String name;
    private Integer type;
    private Integer isStatus;
    private String description;
    private Integer feature;
    private Integer isFilter;
    private String monthJudge;
    private String monthExplain;
    private String yearJudge;
    private String yearExplain;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "RULE_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getRuleType() {
        return ruleType;
    }

    public void setRuleType(Integer ruleType) {
        this.ruleType = ruleType;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 20)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    @Basic
    @Column(name = "IS_STATUS", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsStatus() {
        return isStatus;
    }

    public void setIsStatus(Integer isStatus) {
        this.isStatus = isStatus;
    }

    @Basic
    @Column(name = "DESCRIPTION", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Basic
    @Column(name = "FEATURE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getFeature() {
        return feature;
    }

    public void setFeature(Integer feature) {
        this.feature = feature;
    }

    @Basic
    @Column(name = "IS_FILTER", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsFilter() {
        return isFilter;
    }

    public void setIsFilter(Integer isFilter) {
        this.isFilter = isFilter;
    }

    @Basic
    @Column(name = "MONTH_JUDGE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMonthJudge() {
        return monthJudge;
    }

    public void setMonthJudge(String monthJudge) {
        this.monthJudge = monthJudge;
    }

    @Basic
    @Column(name = "MONTH_EXPLAIN", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMonthExplain() {
        return monthExplain;
    }

    public void setMonthExplain(String monthExplain) {
        this.monthExplain = monthExplain;
    }

    @Basic
    @Column(name = "YEAR_JUDGE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getYearJudge() {
        return yearJudge;
    }

    public void setYearJudge(String yearJudge) {
        this.yearJudge = yearJudge;
    }

    @Basic
    @Column(name = "YEAR_EXPLAIN", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getYearExplain() {
        return yearExplain;
    }

    public void setYearExplain(String yearExplain) {
        this.yearExplain = yearExplain;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Model model = (Model) o;
        return ruleType == model.ruleType &&
                type == model.type &&
                isStatus == model.isStatus &&
                feature == model.feature &&
                isFilter == model.isFilter &&
                Objects.equals(id, model.id) &&
                Objects.equals(code, model.code) &&
                Objects.equals(name, model.name) &&
                Objects.equals(description, model.description) &&
                Objects.equals(monthJudge, model.monthJudge) &&
                Objects.equals(monthExplain, model.monthExplain) &&
                Objects.equals(yearJudge, model.yearJudge) &&
                Objects.equals(yearExplain, model.yearExplain) &&
                Objects.equals(createTime, model.createTime) &&
                Objects.equals(updateTime, model.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, ruleType, code, name, type, isStatus, description, feature, isFilter, monthJudge, monthExplain, yearJudge, yearExplain, createTime, updateTime);
    }
}
