package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "MODEL_CATEGORY", schema = PROJECT_ADMIN, catalog = "")
public class ModelCategory {
    private String id;
    private String clientCode;
    private String organizationId;
    private String category;
    private String parentId;
    private Integer sort;
    private Integer quantity;
    private Date createTime;
    private Date updateTime;
    private String industryId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CLIENT_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getClientCode() {
        return clientCode;
    }

    public void setClientCode(String clientCode) {
        this.clientCode = clientCode;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "CATEGORY", nullable = false, length = 10)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    @Basic
    @Column(name = "PARENT_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    @Basic
    @Column(name = "SORT", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    @Basic
    @Column(name = "QUANTITY", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getQuantity() {
        return quantity;
    }

    public void setQuantity(Integer quantity) {
        this.quantity = quantity;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "INDUSTRY_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndustryId() {
        return industryId;
    }

    public void setIndustryId(String industryId) {
        this.industryId = industryId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ModelCategory that = (ModelCategory) o;
        return sort == that.sort &&
                quantity == that.quantity &&
                Objects.equals(id, that.id) &&
                Objects.equals(clientCode, that.clientCode) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(category, that.category) &&
                Objects.equals(parentId, that.parentId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(industryId, that.industryId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, clientCode, organizationId, category, parentId, sort, quantity, createTime, updateTime, industryId);
    }
}
