package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ORGANIZATION", schema = PROJECT_ADMIN, catalog = "")
public class Organization {
    private String id;
    private String clientCode;
    private String name;
    private String code;
    private String parentId;
    private String taxPayerNumber;
    private String regionId;
    private String structureId;
    private String industryId;
    private String businessUnitId;
    private Boolean isActive;
    private Integer pLevel;
    private Date createTime;
    private Date updateTime;
    private String areaId;
    private String englishName;
    private String abbreviation;
    private String invoiceType;
    private String legalPersonName;
    private String manufactureAddress;
    private String registerAddress;
    private String bankAccountName;
    private String bankAccountNumber;
    private String phoneNumber;
    private String registrationType;
    private String remark;
    private String vehicleroutinglocation;
    private String ratepayer;
    private String address;
    private Date foundationDate;
    private Date registrationDate;
    private String registrationLocation;
    private String registrationCapital;
    private Date businessAllottedTimeFrom;
    private Date businessAllottedTimeTo;
    private String legalCode;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CLIENT_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getClientCode() {
        return clientCode;
    }

    public void setClientCode(String clientCode) {
        this.clientCode = clientCode;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "PARENT_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    @Basic
    @Column(name = "TAX_PAYER_NUMBER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxPayerNumber() {
        return taxPayerNumber;
    }

    public void setTaxPayerNumber(String taxPayerNumber) {
        this.taxPayerNumber = taxPayerNumber;
    }

    @Basic
    @Column(name = "REGION_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRegionId() {
        return regionId;
    }

    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    @Basic
    @Column(name = "STRUCTURE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getStructureId() {
        return structureId;
    }

    public void setStructureId(String structureId) {
        this.structureId = structureId;
    }

    @Basic
    @Column(name = "INDUSTRY_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndustryId() {
        return industryId;
    }

    public void setIndustryId(String industryId) {
        this.industryId = industryId;
    }

    @Basic
    @Column(name = "BUSINESS_UNIT_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBusinessUnitId() {
        return businessUnitId;
    }

    public void setBusinessUnitId(String businessUnitId) {
        this.businessUnitId = businessUnitId;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Basic
    @Column(name = "P_LEVEL", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getpLevel() {
        return pLevel;
    }

    public void setpLevel(Integer pLevel) {
        this.pLevel = pLevel;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "AREA_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAreaId() {
        return areaId;
    }

    public void setAreaId(String areaId) {
        this.areaId = areaId;
    }

    @Basic
    @Column(name = "ENGLISH_NAME", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getEnglishName() {
        return englishName;
    }

    public void setEnglishName(String englishName) {
        this.englishName = englishName;
    }

    @Basic
    @Column(name = "ABBREVIATION", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAbbreviation() {
        return abbreviation;
    }

    public void setAbbreviation(String abbreviation) {
        this.abbreviation = abbreviation;
    }

    @Basic
    @Column(name = "INVOICE_TYPE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceType() {
        return invoiceType;
    }

    public void setInvoiceType(String invoiceType) {
        this.invoiceType = invoiceType;
    }

    @Basic
    @Column(name = "LEGAL_PERSON_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getLegalPersonName() {
        return legalPersonName;
    }

    public void setLegalPersonName(String legalPersonName) {
        this.legalPersonName = legalPersonName;
    }

    @Basic
    @Column(name = "MANUFACTURE_ADDRESS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getManufactureAddress() {
        return manufactureAddress;
    }

    public void setManufactureAddress(String manufactureAddress) {
        this.manufactureAddress = manufactureAddress;
    }

    @Basic
    @Column(name = "REGISTER_ADDRESS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getRegisterAddress() {
        return registerAddress;
    }

    public void setRegisterAddress(String registerAddress) {
        this.registerAddress = registerAddress;
    }

    @Basic
    @Column(name = "BANK_ACCOUNT_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBankAccountName() {
        return bankAccountName;
    }

    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName;
    }

    @Basic
    @Column(name = "BANK_ACCOUNT_NUMBER", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBankAccountNumber() {
        return bankAccountNumber;
    }

    public void setBankAccountNumber(String bankAccountNumber) {
        this.bankAccountNumber = bankAccountNumber;
    }

    @Basic
    @Column(name = "PHONE_NUMBER", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    @Basic
    @Column(name = "REGISTRATION_TYPE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRegistrationType() {
        return registrationType;
    }

    public void setRegistrationType(String registrationType) {
        this.registrationType = registrationType;
    }

    @Basic
    @Column(name = "REMARK", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Basic
    @Column(name = "VEHICLEROUTINGLOCATION", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVehicleroutinglocation() {
        return vehicleroutinglocation;
    }

    public void setVehicleroutinglocation(String vehicleroutinglocation) {
        this.vehicleroutinglocation = vehicleroutinglocation;
    }

    @Basic
    @Column(name = "RATEPAYER", nullable = true, length = 10)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRatepayer() {
        return ratepayer;
    }

    public void setRatepayer(String ratepayer) {
        this.ratepayer = ratepayer;
    }

    @Basic
    @Column(name = "ADDRESS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    @Basic
    @Column(name = "FOUNDATION_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getFoundationDate() {
        return foundationDate;
    }

    public void setFoundationDate(Date foundationDate) {
        this.foundationDate = foundationDate;
    }

    @Basic
    @Column(name = "REGISTRATION_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getRegistrationDate() {
        return registrationDate;
    }

    public void setRegistrationDate(Date registrationDate) {
        this.registrationDate = registrationDate;
    }

    @Basic
    @Column(name = "REGISTRATION_LOCATION", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getRegistrationLocation() {
        return registrationLocation;
    }

    public void setRegistrationLocation(String registrationLocation) {
        this.registrationLocation = registrationLocation;
    }

    @Basic
    @Column(name = "REGISTRATION_CAPITAL", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getRegistrationCapital() {
        return registrationCapital;
    }

    public void setRegistrationCapital(String registrationCapital) {
        this.registrationCapital = registrationCapital;
    }

    @Basic
    @Column(name = "BUSINESS_ALLOTTED_TIME_FROM", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getBusinessAllottedTimeFrom() {
        return businessAllottedTimeFrom;
    }

    public void setBusinessAllottedTimeFrom(Date businessAllottedTimeFrom) {
        this.businessAllottedTimeFrom = businessAllottedTimeFrom;
    }

    @Basic
    @Column(name = "BUSINESS_ALLOTTED_TIME_TO", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getBusinessAllottedTimeTo() {
        return businessAllottedTimeTo;
    }

    public void setBusinessAllottedTimeTo(Date businessAllottedTimeTo) {
        this.businessAllottedTimeTo = businessAllottedTimeTo;
    }

    @Basic
    @Column(name = "LEGAL_CODE", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getLegalCode() {
        return legalCode;
    }

    public void setLegalCode(String legalCode) {
        this.legalCode = legalCode;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Organization that = (Organization) o;
        return isActive == that.isActive &&
                pLevel == that.pLevel &&
                Objects.equals(id, that.id) &&
                Objects.equals(clientCode, that.clientCode) &&
                Objects.equals(name, that.name) &&
                Objects.equals(code, that.code) &&
                Objects.equals(parentId, that.parentId) &&
                Objects.equals(taxPayerNumber, that.taxPayerNumber) &&
                Objects.equals(regionId, that.regionId) &&
                Objects.equals(structureId, that.structureId) &&
                Objects.equals(industryId, that.industryId) &&
                Objects.equals(businessUnitId, that.businessUnitId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(areaId, that.areaId) &&
                Objects.equals(englishName, that.englishName) &&
                Objects.equals(abbreviation, that.abbreviation) &&
                Objects.equals(invoiceType, that.invoiceType) &&
                Objects.equals(legalPersonName, that.legalPersonName) &&
                Objects.equals(manufactureAddress, that.manufactureAddress) &&
                Objects.equals(registerAddress, that.registerAddress) &&
                Objects.equals(bankAccountName, that.bankAccountName) &&
                Objects.equals(bankAccountNumber, that.bankAccountNumber) &&
                Objects.equals(phoneNumber, that.phoneNumber) &&
                Objects.equals(registrationType, that.registrationType) &&
                Objects.equals(remark, that.remark) &&
                Objects.equals(vehicleroutinglocation, that.vehicleroutinglocation) &&
                Objects.equals(ratepayer, that.ratepayer) &&
                Objects.equals(address, that.address) &&
                Objects.equals(foundationDate, that.foundationDate) &&
                Objects.equals(registrationDate, that.registrationDate) &&
                Objects.equals(registrationLocation, that.registrationLocation) &&
                Objects.equals(registrationCapital, that.registrationCapital) &&
                Objects.equals(businessAllottedTimeFrom, that.businessAllottedTimeFrom) &&
                Objects.equals(businessAllottedTimeTo, that.businessAllottedTimeTo) &&
                Objects.equals(legalCode, that.legalCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, clientCode, name, code, parentId, taxPayerNumber, regionId, structureId, industryId, businessUnitId, isActive, pLevel, createTime, updateTime, areaId, englishName, abbreviation, invoiceType, legalPersonName, manufactureAddress, registerAddress, bankAccountName, bankAccountNumber, phoneNumber, registrationType, remark, vehicleroutinglocation, ratepayer, address, foundationDate, registrationDate, registrationLocation, registrationCapital, businessAllottedTimeFrom, businessAllottedTimeTo, legalCode);
    }
}
