package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "PERIOD_INFO", schema = PROJECT_ADMIN, catalog = "")
public class PeriodInfo {
    private String id;
    private String projectId;
    private Integer period;
    private Integer status;
    private String creatorId;
    private Date createTime;
    private Date updateTime;
    private String projectInfo;
    private Integer importType;
    private Integer serviceType;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "PROJECT_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getProjectId() {
        return projectId;
    }

    public void setProjectId(String projectId) {
        this.projectId = projectId;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "STATUS", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "PROJECT_INFO", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getProjectInfo() {
        return projectInfo;
    }

    public void setProjectInfo(String projectInfo) {
        this.projectInfo = projectInfo;
    }

    @Basic
    @Column(name = "IMPORT_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getImportType() {
        return importType;
    }

    public void setImportType(Integer importType) {
        this.importType = importType;
    }

    @Basic
    @Column(name = "SERVICE_TYPE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getServiceType() {
        return serviceType;
    }

    public void setServiceType(Integer serviceType) {
        this.serviceType = serviceType;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        PeriodInfo that = (PeriodInfo) o;
        return period == that.period &&
                status == that.status &&
                importType == that.importType &&
                Objects.equals(id, that.id) &&
                Objects.equals(projectId, that.projectId) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(projectInfo, that.projectInfo) &&
                Objects.equals(serviceType, that.serviceType);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, projectId, period, status, creatorId, createTime, updateTime, projectInfo, importType, serviceType);
    }
}
