package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "PROJECT_STATUS_MANAGE", schema = PROJECT_ADMIN, catalog = "")
public class ProjectStatusManage {
    private String id;
    private String dbName;
    private Integer periodId;
    private Integer status;
    private String creatorId;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "DB_NAME", nullable = true, length = 64)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDbName() {
        return dbName;
    }

    public void setDbName(String dbName) {
        this.dbName = dbName;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "STATUS", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ProjectStatusManage that = (ProjectStatusManage) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(dbName, that.dbName) &&
                Objects.equals(periodId, that.periodId) &&
                Objects.equals(status, that.status) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, dbName, periodId, status, creatorId, createTime, updateTime);
    }
}
