package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "REGION", schema = PROJECT_ADMIN, catalog = "")
public class Region {
    private String id;
    private String parentId;
    private String name;
    private String shortName;
    private String mergerName;
    private Integer levelType;
    private String telCode;
    private String zipCode;
    private String pinYin;
    private Double longitude;
    private Double latitude;
    private Boolean isActive;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "PARENT_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "SHORT_NAME", nullable = false, length = 10)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getShortName() {
        return shortName;
    }

    public void setShortName(String shortName) {
        this.shortName = shortName;
    }

    @Basic
    @Column(name = "MERGER_NAME", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMergerName() {
        return mergerName;
    }

    public void setMergerName(String mergerName) {
        this.mergerName = mergerName;
    }

    @Basic
    @Column(name = "LEVEL_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getLevelType() {
        return levelType;
    }

    public void setLevelType(Integer levelType) {
        this.levelType = levelType;
    }

    @Basic
    @Column(name = "TEL_CODE", nullable = true, length = 10)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTelCode() {
        return telCode;
    }

    public void setTelCode(String telCode) {
        this.telCode = telCode;
    }

    @Basic
    @Column(name = "ZIP_CODE", nullable = true, length = 11)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getZipCode() {
        return zipCode;
    }

    public void setZipCode(String zipCode) {
        this.zipCode = zipCode;
    }

    @Basic
    @Column(name = "PIN_YIN", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPinYin() {
        return pinYin;
    }

    public void setPinYin(String pinYin) {
        this.pinYin = pinYin;
    }

    @Basic
    @Column(name = "LONGITUDE", nullable = false, precision = 0)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public Double getLongitude() {
        return longitude;
    }

    public void setLongitude(Double longitude) {
        this.longitude = longitude;
    }

    @Basic
    @Column(name = "LATITUDE", nullable = false, precision = 0)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public Double getLatitude() {
        return latitude;
    }

    public void setLatitude(Double latitude) {
        this.latitude = latitude;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Region region = (Region) o;
        return levelType == region.levelType &&
                Double.compare(region.longitude, longitude) == 0 &&
                Double.compare(region.latitude, latitude) == 0 &&
                isActive == region.isActive &&
                Objects.equals(id, region.id) &&
                Objects.equals(parentId, region.parentId) &&
                Objects.equals(name, region.name) &&
                Objects.equals(shortName, region.shortName) &&
                Objects.equals(mergerName, region.mergerName) &&
                Objects.equals(telCode, region.telCode) &&
                Objects.equals(zipCode, region.zipCode) &&
                Objects.equals(pinYin, region.pinYin);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, parentId, name, shortName, mergerName, levelType, telCode, zipCode, pinYin, longitude, latitude, isActive);
    }
}
