package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "STATISTIC_ATTRIBUTE_DIMENSION", schema = PROJECT_ADMIN, catalog = "")
public class StatisticAttributeDimension {
    private String id;
    private String dimensionId;
    private String statisticsAttributeId;
    private Boolean orderIndex;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "DIMENSION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDimensionId() {
        return dimensionId;
    }

    public void setDimensionId(String dimensionId) {
        this.dimensionId = dimensionId;
    }

    @Basic
    @Column(name = "STATISTICS_ATTRIBUTE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getStatisticsAttributeId() {
        return statisticsAttributeId;
    }

    public void setStatisticsAttributeId(String statisticsAttributeId) {
        this.statisticsAttributeId = statisticsAttributeId;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = true)
    public Boolean getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Boolean orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        StatisticAttributeDimension that = (StatisticAttributeDimension) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(dimensionId, that.dimensionId) &&
                Objects.equals(statisticsAttributeId, that.statisticsAttributeId) &&
                Objects.equals(orderIndex, that.orderIndex);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, dimensionId, statisticsAttributeId, orderIndex);
    }
}
