package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "STOCK", schema = PROJECT_ADMIN, catalog = "")
public class Stock {
    private String id;
    private String name;
    private String code;
    private BigDecimal stockAmount;
    private BigDecimal capitalAmount;
    private BigDecimal capitalPercent;
    private Date effectiveDate;
    private Date expiredDate;
    private String parentId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "NAME", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "CODE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "STOCK_AMOUNT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getStockAmount() {
        return stockAmount;
    }

    public void setStockAmount(BigDecimal stockAmount) {
        this.stockAmount = stockAmount;
    }

    @Basic
    @Column(name = "CAPITAL_AMOUNT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCapitalAmount() {
        return capitalAmount;
    }

    public void setCapitalAmount(BigDecimal capitalAmount) {
        this.capitalAmount = capitalAmount;
    }

    @Basic
    @Column(name = "CAPITAL_PERCENT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCapitalPercent() {
        return capitalPercent;
    }

    public void setCapitalPercent(BigDecimal capitalPercent) {
        this.capitalPercent = capitalPercent;
    }

    @Basic
    @Column(name = "EFFECTIVE_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getEffectiveDate() {
        return effectiveDate;
    }

    public void setEffectiveDate(Date effectiveDate) {
        this.effectiveDate = effectiveDate;
    }

    @Basic
    @Column(name = "EXPIRED_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getExpiredDate() {
        return expiredDate;
    }

    public void setExpiredDate(Date expiredDate) {
        this.expiredDate = expiredDate;
    }

    @Basic
    @Column(name = "PARENT_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Stock stock = (Stock) o;
        return Objects.equals(id, stock.id) &&
                Objects.equals(name, stock.name) &&
                Objects.equals(code, stock.code) &&
                Objects.equals(stockAmount, stock.stockAmount) &&
                Objects.equals(capitalAmount, stock.capitalAmount) &&
                Objects.equals(capitalPercent, stock.capitalPercent) &&
                Objects.equals(effectiveDate, stock.effectiveDate) &&
                Objects.equals(expiredDate, stock.expiredDate) &&
                Objects.equals(parentId, stock.parentId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, code, stockAmount, capitalAmount, capitalPercent, effectiveDate, expiredDate, parentId);
    }
}
