package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "TEMPLATE", schema = PROJECT_ADMIN, catalog = "")
public class Template {
    private Long id;
    private String name;
    private String code;
    private String path;
    private Integer reportType;
    private Long templateGroupId;
    private Integer orderIndex;
    private Date createTime;
    private Date updateTime;
    private Integer isSystemType;
    private Integer isActiveAssociation;
    private String parentId;
    private String createBy;
    private String updateBy;

    @Id
    @Column(name = "ID", nullable = false)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "PATH", nullable = false, length = 500)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPath() {
        return path;
    }

    public void setPath(String path) {
        this.path = path;
    }

    @Basic
    @Column(name = "REPORT_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getReportType() {
        return reportType;
    }

    public void setReportType(Integer reportType) {
        this.reportType = reportType;
    }

    @Basic
    @Column(name = "TEMPLATE_GROUP_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getTemplateGroupId() {
        return templateGroupId;
    }

    public void setTemplateGroupId(Long templateGroupId) {
        this.templateGroupId = templateGroupId;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Integer orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "IS_SYSTEM_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsSystemType() {
        return isSystemType;
    }

    public void setIsSystemType(Integer isSystemType) {
        this.isSystemType = isSystemType;
    }

    @Basic
    @Column(name = "IS_ACTIVE_ASSOCIATION", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsActiveAssociation() {
        return isActiveAssociation;
    }

    public void setIsActiveAssociation(Integer isActiveAssociation) {
        this.isActiveAssociation = isActiveAssociation;
    }

    @Basic
    @Column(name = "PARENT_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Template template = (Template) o;
        return id == template.id &&
                reportType == template.reportType &&
                templateGroupId == template.templateGroupId &&
                orderIndex == template.orderIndex &&
                isSystemType == template.isSystemType &&
                isActiveAssociation == template.isActiveAssociation &&
                Objects.equals(name, template.name) &&
                Objects.equals(code, template.code) &&
                Objects.equals(path, template.path) &&
                Objects.equals(createTime, template.createTime) &&
                Objects.equals(updateTime, template.updateTime) &&
                Objects.equals(parentId, template.parentId) &&
                Objects.equals(createBy, template.createBy) &&
                Objects.equals(updateBy, template.updateBy);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, code, path, reportType, templateGroupId, orderIndex, createTime, updateTime, isSystemType, isActiveAssociation, parentId, createBy, updateBy);
    }
}
