package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "TEMPLATE_FORMULA", schema = PROJECT_ADMIN, catalog = "")
public class TemplateFormula {
    private String id;
    private Integer rowIndex;
    private Integer columnIndex;
    private Integer columnEndIndex;
    private String formula;
    private String templateId;
    private Date createTime;
    private Date updateTime;
    private Boolean isManualChange;
    private String instructions;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ROW_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getRowIndex() {
        return rowIndex;
    }

    public void setRowIndex(Integer rowIndex) {
        this.rowIndex = rowIndex;
    }

    @Basic
    @Column(name = "COLUMN_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getColumnIndex() {
        return columnIndex;
    }

    public void setColumnIndex(Integer columnIndex) {
        this.columnIndex = columnIndex;
    }

    @Basic
    @Column(name = "COLUMN_END_INDEX", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getColumnEndIndex() {
        return columnEndIndex;
    }

    public void setColumnEndIndex(Integer columnEndIndex) {
        this.columnEndIndex = columnEndIndex;
    }

    @Basic
    @Column(name = "FORMULA", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getFormula() {
        return formula;
    }

    public void setFormula(String formula) {
        this.formula = formula;
    }

    @Basic
    @Column(name = "TEMPLATE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTemplateId() {
        return templateId;
    }

    public void setTemplateId(String templateId) {
        this.templateId = templateId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "IS_MANUAL_CHANGE", nullable = false)
    public Boolean getIsManualChange() {
        return isManualChange;
    }

    public void setIsManualChange(Boolean isManualChange) {
        this.isManualChange = isManualChange;
    }

    @Basic
    @Column(name = "INSTRUCTIONS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getInstructions() {
        return instructions;
    }

    public void setInstructions(String instructions) {
        this.instructions = instructions;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        TemplateFormula that = (TemplateFormula) o;
        return rowIndex == that.rowIndex &&
                columnIndex == that.columnIndex &&
                isManualChange == that.isManualChange &&
                Objects.equals(id, that.id) &&
                Objects.equals(columnEndIndex, that.columnEndIndex) &&
                Objects.equals(formula, that.formula) &&
                Objects.equals(templateId, that.templateId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(instructions, that.instructions);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, rowIndex, columnIndex, columnEndIndex, formula, templateId, createTime, updateTime, isManualChange, instructions);
    }
}
