package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "TEMPLATE_GROUP", schema = PROJECT_ADMIN, catalog = "")
public class TemplateGroup {
    private Long id;
    private String name;
    private String serviceTypeId;
    private String industryIds;
    private Integer payTaxType;
    private Integer groupType;
    private Long copyFrom;
    private Date updateTime;
    private Date createTime;
    private Integer isSystemType;
    private String createBy;
    private String updateBy;

    @Id
    @Column(name = "ID", nullable = false)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "SERVICE_TYPE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getServiceTypeId() {
        return serviceTypeId;
    }

    public void setServiceTypeId(String serviceTypeId) {
        this.serviceTypeId = serviceTypeId;
    }

    @Basic
    @Column(name = "INDUSTRY_IDS", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndustryIds() {
        return industryIds;
    }

    public void setIndustryIds(String industryIds) {
        this.industryIds = industryIds;
    }

    @Basic
    @Column(name = "PAY_TAX_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPayTaxType() {
        return payTaxType;
    }

    public void setPayTaxType(Integer payTaxType) {
        this.payTaxType = payTaxType;
    }

    @Basic
    @Column(name = "GROUP_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getGroupType() {
        return groupType;
    }

    public void setGroupType(Integer groupType) {
        this.groupType = groupType;
    }

    @Basic
    @Column(name = "COPY_FROM", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getCopyFrom() {
        return copyFrom;
    }

    public void setCopyFrom(Long copyFrom) {
        this.copyFrom = copyFrom;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "IS_SYSTEM_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsSystemType() {
        return isSystemType;
    }

    public void setIsSystemType(Integer isSystemType) {
        this.isSystemType = isSystemType;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        TemplateGroup that = (TemplateGroup) o;
        return id == that.id &&
                payTaxType == that.payTaxType &&
                groupType == that.groupType &&
                copyFrom == that.copyFrom &&
                isSystemType == that.isSystemType &&
                Objects.equals(name, that.name) &&
                Objects.equals(serviceTypeId, that.serviceTypeId) &&
                Objects.equals(industryIds, that.industryIds) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(createBy, that.createBy) &&
                Objects.equals(updateBy, that.updateBy);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, serviceTypeId, industryIds, payTaxType, groupType, copyFrom, updateTime, createTime, isSystemType, createBy, updateBy);
    }
}
