package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = B_Delimiter + "USER" + E_Delimiter, schema = PROJECT_ADMIN, catalog = "")
public class User {
    private String id;
    private String userName;
    private String email;
    private String password;
    private Integer loginType;
    private Integer status;
    private Date expirationDate;
    private Date createTime;
    private Date updateTime;
    private Boolean isAdmin;
    private Date passwordUpdateTime;
    private Integer attemptTimes;
    private Date lockedTime;
    private String organizationId;
    private Boolean isSuperAdmin;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "USER_NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    @Basic
    @Column(name = "EMAIL", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    @Basic
    @Column(name = "PASSWORD", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    @Basic
    @Column(name = "LOGIN_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getLoginType() {
        return loginType;
    }

    public void setLoginType(Integer loginType) {
        this.loginType = loginType;
    }

    @Basic
    @Column(name = "STATUS", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Basic
    @Column(name = "EXPIRATION_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getExpirationDate() {
        return expirationDate;
    }

    public void setExpirationDate(Date expirationDate) {
        this.expirationDate = expirationDate;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "IS_ADMIN", nullable = false)
    public Boolean getIsAdmin() {
        return isAdmin;
    }

    public void setIsAdmin(Boolean isAdmin) {
        this.isAdmin = isAdmin;
    }

    @Basic
    @Column(name = "PASSWORD_UPDATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getPasswordUpdateTime() {
        return passwordUpdateTime;
    }

    public void setPasswordUpdateTime(Date passwordUpdateTime) {
        this.passwordUpdateTime = passwordUpdateTime;
    }

    @Basic
    @Column(name = "ATTEMPT_TIMES", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAttemptTimes() {
        return attemptTimes;
    }

    public void setAttemptTimes(Integer attemptTimes) {
        this.attemptTimes = attemptTimes;
    }

    @Basic
    @Column(name = "LOCKED_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getLockedTime() {
        return lockedTime;
    }

    public void setLockedTime(Date lockedTime) {
        this.lockedTime = lockedTime;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "IS_SUPER_ADMIN", nullable = false)
    public Boolean getIsSuperAdmin() {
        return isSuperAdmin;
    }

    public void setIsSuperAdmin(Boolean isSuperAdmin) {
        this.isSuperAdmin = isSuperAdmin;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        User user = (User) o;
        return loginType == user.loginType &&
                status == user.status &&
                isAdmin == user.isAdmin &&
                attemptTimes == user.attemptTimes &&
                isSuperAdmin == user.isSuperAdmin &&
                Objects.equals(id, user.id) &&
                Objects.equals(userName, user.userName) &&
                Objects.equals(email, user.email) &&
                Objects.equals(password, user.password) &&
                Objects.equals(expirationDate, user.expirationDate) &&
                Objects.equals(createTime, user.createTime) &&
                Objects.equals(updateTime, user.updateTime) &&
                Objects.equals(passwordUpdateTime, user.passwordUpdateTime) &&
                Objects.equals(lockedTime, user.lockedTime) &&
                Objects.equals(organizationId, user.organizationId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, userName, email, password, loginType, status, expirationDate, createTime, updateTime, isAdmin, passwordUpdateTime, attemptTimes, lockedTime, organizationId, isSuperAdmin);
    }
}
