package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "USER_DIMENSION_VALUE", schema = PROJECT_ADMIN, catalog = "")
public class UserDimensionValue {
    private String id;
    private String userId;
    private String dimensionId;
    private String dimensionValueId;
    private Boolean isAccessible;
    private Boolean hasOriginalRole;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "USER_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    @Basic
    @Column(name = "DIMENSION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDimensionId() {
        return dimensionId;
    }

    public void setDimensionId(String dimensionId) {
        this.dimensionId = dimensionId;
    }

    @Basic
    @Column(name = "DIMENSION_VALUE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDimensionValueId() {
        return dimensionValueId;
    }

    public void setDimensionValueId(String dimensionValueId) {
        this.dimensionValueId = dimensionValueId;
    }

    @Basic
    @Column(name = "IS_ACCESSIBLE", nullable = false)
    public Boolean getIsAccessible() {
        return isAccessible;
    }

    public void setIsAccessible(Boolean isAccessible) {
        this.isAccessible = isAccessible;
    }

    @Basic
    @Column(name = "HAS_ORIGINAL_ROLE", nullable = false)
    public Boolean getHasOriginalRole() {
        return hasOriginalRole;
    }

    public void setHasOriginalRole(Boolean hasOriginalRole) {
        this.hasOriginalRole = hasOriginalRole;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        UserDimensionValue that = (UserDimensionValue) o;
        return isAccessible == that.isAccessible &&
                hasOriginalRole == that.hasOriginalRole &&
                Objects.equals(id, that.id) &&
                Objects.equals(userId, that.userId) &&
                Objects.equals(dimensionId, that.dimensionId) &&
                Objects.equals(dimensionValueId, that.dimensionValueId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, userId, dimensionId, dimensionValueId, isAccessible, hasOriginalRole);
    }
}
