package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "USER_DIMENSION_VALUE_ORG", schema = PROJECT_ADMIN, catalog = "")
public class UserDimensionValueOrg {
    private String id;
    private String userDimensionValueId;
    private String organizationId;
    private Boolean isHeritable;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "USER_DIMENSION_VALUE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUserDimensionValueId() {
        return userDimensionValueId;
    }

    public void setUserDimensionValueId(String userDimensionValueId) {
        this.userDimensionValueId = userDimensionValueId;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "IS_HERITABLE", nullable = true)
    public Boolean getIsHeritable() {
        return isHeritable;
    }

    public void setIsHeritable(Boolean isHeritable) {
        this.isHeritable = isHeritable;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        UserDimensionValueOrg that = (UserDimensionValueOrg) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(userDimensionValueId, that.userDimensionValueId) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(isHeritable, that.isHeritable);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, userDimensionValueId, organizationId, isHeritable);
    }
}
