package pwc.taxtech.atms.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "USER_DIMENSION_VALUE_ROLE", schema = PROJECT_ADMIN, catalog = "")
public class UserDimensionValueRole {
    private String id;
    private String userDimensionValueId;
    private String roleId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "USER_DIMENSION_VALUE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUserDimensionValueId() {
        return userDimensionValueId;
    }

    public void setUserDimensionValueId(String userDimensionValueId) {
        this.userDimensionValueId = userDimensionValueId;
    }

    @Basic
    @Column(name = "ROLE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRoleId() {
        return roleId;
    }

    public void setRoleId(String roleId) {
        this.roleId = roleId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        UserDimensionValueRole that = (UserDimensionValueRole) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(userDimensionValueId, that.userDimensionValueId) &&
                Objects.equals(roleId, that.roleId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, userDimensionValueId, roleId);
    }
}
