package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ACCOUNT", schema = PROJECT_SCHEMA, catalog = "")
public class Account {
    private String id;
    private String code;
    private String name;
    private String parentCode;
    private String fullName;
    private Integer acctProp;
    private Integer subProp;
    private Integer acctLevel;
    private Integer direction;
    private Boolean isLeaf;
    private Integer ruleType;
    private Boolean isActive;
    private String englishName;
    private String industryId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "PARENT_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParentCode() {
        return parentCode;
    }

    public void setParentCode(String parentCode) {
        this.parentCode = parentCode;
    }

    @Basic
    @Column(name = "FULL_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFullName() {
        return fullName;
    }

    public void setFullName(String fullName) {
        this.fullName = fullName;
    }

    @Basic
    @Column(name = "ACCT_PROP", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAcctProp() {
        return acctProp;
    }

    public void setAcctProp(Integer acctProp) {
        this.acctProp = acctProp;
    }

    @Basic
    @Column(name = "SUB_PROP", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getSubProp() {
        return subProp;
    }

    public void setSubProp(Integer subProp) {
        this.subProp = subProp;
    }

    @Basic
    @Column(name = "ACCT_LEVEL", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAcctLevel() {
        return acctLevel;
    }

    public void setAcctLevel(Integer acctLevel) {
        this.acctLevel = acctLevel;
    }

    @Basic
    @Column(name = "DIRECTION", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDirection() {
        return direction;
    }

    public void setDirection(Integer direction) {
        this.direction = direction;
    }

    @Basic
    @Column(name = "IS_LEAF", nullable = false)
    public Boolean getIsLeaf() {
        return isLeaf;
    }

    public void setIsLeaf(Boolean isLeaf) {
        this.isLeaf = isLeaf;
    }

    @Basic
    @Column(name = "RULE_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getRuleType() {
        return ruleType;
    }

    public void setRuleType(Integer ruleType) {
        this.ruleType = ruleType;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Basic
    @Column(name = "ENGLISH_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEnglishName() {
        return englishName;
    }

    public void setEnglishName(String englishName) {
        this.englishName = englishName;
    }

    @Basic
    @Column(name = "INDUSTRY_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndustryId() {
        return industryId;
    }

    public void setIndustryId(String industryId) {
        this.industryId = industryId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Account account = (Account) o;
        return direction == account.direction &&
                isLeaf == account.isLeaf &&
                ruleType == account.ruleType &&
                isActive == account.isActive &&
                Objects.equals(id, account.id) &&
                Objects.equals(code, account.code) &&
                Objects.equals(name, account.name) &&
                Objects.equals(parentCode, account.parentCode) &&
                Objects.equals(fullName, account.fullName) &&
                Objects.equals(acctProp, account.acctProp) &&
                Objects.equals(subProp, account.subProp) &&
                Objects.equals(acctLevel, account.acctLevel) &&
                Objects.equals(englishName, account.englishName) &&
                Objects.equals(industryId, account.industryId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, code, name, parentCode, fullName, acctProp, subProp, acctLevel, direction, isLeaf, ruleType, isActive, englishName, industryId);
    }
}
