package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ACCOUNT_REMAP", schema = PROJECT_SCHEMA, catalog = "")
public class AccountRemap {
    private String remapId;
    private Integer period;
    private String acctCode;
    private String customerCode;
    private BigDecimal remapDebit;
    private BigDecimal remapCredit;
    private String stdCode;
    private String reMappName;
    private String reMappReason;
    private Integer reMappTypeId;
    private Date createTime;
    private Date updateTime;
    private String creatorId;
    private String remapBatchId;

    @Id
    @Column(name = "REMAP_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRemapId() {
        return remapId;
    }

    public void setRemapId(String remapId) {
        this.remapId = remapId;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "ACCT_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAcctCode() {
        return acctCode;
    }

    public void setAcctCode(String acctCode) {
        this.acctCode = acctCode;
    }

    @Basic
    @Column(name = "CUSTOMER_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCustomerCode() {
        return customerCode;
    }

    public void setCustomerCode(String customerCode) {
        this.customerCode = customerCode;
    }

    @Basic
    @Column(name = "REMAP_DEBIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getRemapDebit() {
        return remapDebit;
    }

    public void setRemapDebit(BigDecimal remapDebit) {
        this.remapDebit = remapDebit;
    }

    @Basic
    @Column(name = "REMAP_CREDIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getRemapCredit() {
        return remapCredit;
    }

    public void setRemapCredit(BigDecimal remapCredit) {
        this.remapCredit = remapCredit;
    }

    @Basic
    @Column(name = "STD_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getStdCode() {
        return stdCode;
    }

    public void setStdCode(String stdCode) {
        this.stdCode = stdCode;
    }

    @Basic
    @Column(name = "RE_MAPP_NAME", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getReMappName() {
        return reMappName;
    }

    public void setReMappName(String reMappName) {
        this.reMappName = reMappName;
    }

    @Basic
    @Column(name = "RE_MAPP_REASON", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getReMappReason() {
        return reMappReason;
    }

    public void setReMappReason(String reMappReason) {
        this.reMappReason = reMappReason;
    }

    @Basic
    @Column(name = "RE_MAPP_TYPE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getReMappTypeId() {
        return reMappTypeId;
    }

    public void setReMappTypeId(Integer reMappTypeId) {
        this.reMappTypeId = reMappTypeId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "REMAP_BATCH_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRemapBatchId() {
        return remapBatchId;
    }

    public void setRemapBatchId(String remapBatchId) {
        this.remapBatchId = remapBatchId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AccountRemap that = (AccountRemap) o;
        return period == that.period &&
                reMappTypeId == that.reMappTypeId &&
                Objects.equals(remapId, that.remapId) &&
                Objects.equals(acctCode, that.acctCode) &&
                Objects.equals(customerCode, that.customerCode) &&
                Objects.equals(remapDebit, that.remapDebit) &&
                Objects.equals(remapCredit, that.remapCredit) &&
                Objects.equals(stdCode, that.stdCode) &&
                Objects.equals(reMappName, that.reMappName) &&
                Objects.equals(reMappReason, that.reMappReason) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(remapBatchId, that.remapBatchId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(remapId, period, acctCode, customerCode, remapDebit, remapCredit, stdCode, reMappName, reMappReason, reMappTypeId, createTime, updateTime, creatorId, remapBatchId);
    }
}
