package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ACCOUNT_REMAP_SUM", schema = PROJECT_SCHEMA, catalog = "")
public class AccountRemapSum {
    private String accountRemapSumId;
    private Integer period;
    private String acctCode;
    private String parent;
    private Integer acctLevel;
    private BigDecimal remapDebit;
    private BigDecimal remapCredit;
    private Date createTime;
    private Date updateTime;
    private String creatorId;

    @Id
    @Column(name = "ACCOUNT_REMAP_SUM_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAccountRemapSumId() {
        return accountRemapSumId;
    }

    public void setAccountRemapSumId(String accountRemapSumId) {
        this.accountRemapSumId = accountRemapSumId;
    }

    @Basic
    @Column(name = "PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "ACCT_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAcctCode() {
        return acctCode;
    }

    public void setAcctCode(String acctCode) {
        this.acctCode = acctCode;
    }

    @Basic
    @Column(name = "PARENT", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParent() {
        return parent;
    }

    public void setParent(String parent) {
        this.parent = parent;
    }

    @Basic
    @Column(name = "ACCT_LEVEL", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAcctLevel() {
        return acctLevel;
    }

    public void setAcctLevel(Integer acctLevel) {
        this.acctLevel = acctLevel;
    }

    @Basic
    @Column(name = "REMAP_DEBIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getRemapDebit() {
        return remapDebit;
    }

    public void setRemapDebit(BigDecimal remapDebit) {
        this.remapDebit = remapDebit;
    }

    @Basic
    @Column(name = "REMAP_CREDIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getRemapCredit() {
        return remapCredit;
    }

    public void setRemapCredit(BigDecimal remapCredit) {
        this.remapCredit = remapCredit;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AccountRemapSum that = (AccountRemapSum) o;
        return Objects.equals(accountRemapSumId, that.accountRemapSumId) &&
                Objects.equals(period, that.period) &&
                Objects.equals(acctCode, that.acctCode) &&
                Objects.equals(parent, that.parent) &&
                Objects.equals(acctLevel, that.acctLevel) &&
                Objects.equals(remapDebit, that.remapDebit) &&
                Objects.equals(remapCredit, that.remapCredit) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(creatorId, that.creatorId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(accountRemapSumId, period, acctCode, parent, acctLevel, remapDebit, remapCredit, createTime, updateTime, creatorId);
    }
}
