package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ASSET_GROUP_RESULT", schema = PROJECT_SCHEMA, catalog = "")
public class AssetGroupResult {
    private String id;
    private String assetName;
    private String assetGroupId;
    private String assetDetailGroupId;
    private Integer taxDepreciationPeriod;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ASSET_NAME", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAssetName() {
        return assetName;
    }

    public void setAssetName(String assetName) {
        this.assetName = assetName;
    }

    @Basic
    @Column(name = "ASSET_GROUP_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAssetGroupId() {
        return assetGroupId;
    }

    public void setAssetGroupId(String assetGroupId) {
        this.assetGroupId = assetGroupId;
    }

    @Basic
    @Column(name = "ASSET_DETAIL_GROUP_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAssetDetailGroupId() {
        return assetDetailGroupId;
    }

    public void setAssetDetailGroupId(String assetDetailGroupId) {
        this.assetDetailGroupId = assetDetailGroupId;
    }

    @Basic
    @Column(name = "TAX_DEPRECIATION_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getTaxDepreciationPeriod() {
        return taxDepreciationPeriod;
    }

    public void setTaxDepreciationPeriod(Integer taxDepreciationPeriod) {
        this.taxDepreciationPeriod = taxDepreciationPeriod;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AssetGroupResult that = (AssetGroupResult) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(assetName, that.assetName) &&
                Objects.equals(assetGroupId, that.assetGroupId) &&
                Objects.equals(assetDetailGroupId, that.assetDetailGroupId) &&
                Objects.equals(taxDepreciationPeriod, that.taxDepreciationPeriod) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, assetName, assetGroupId, assetDetailGroupId, taxDepreciationPeriod, createTime, updateTime);
    }
}
