package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ASSETS_LIST", schema = PROJECT_SCHEMA, catalog = "")
public class AssetsList {
    private String id;
    private String assetNumber;
    private String assetGroupName;
    private String assetDetailGroupId;
    private String assetDescription;
    private Date buyDate;
    private Date depreciationDate;
    private Integer depreciationPeriod;
    private BigDecimal acquisitionValue;
    private BigDecimal adjustmentValue;
    private Date disposedDate;
    private BigDecimal residualRate;
    private BigDecimal yearDepreciationAmount;
    private BigDecimal yearAdjustmentAmount;
    private BigDecimal yearEndValue;
    private Integer status;
    private BigDecimal accountAcquisitionValue;
    private BigDecimal accountMonthDepreciationAmount;
    private BigDecimal accountYearDepreciationAmount;
    private BigDecimal accountTotalepreciationAmount;
    private Integer taxDepreciationPeriod;
    private Integer toLastYearDepreciatePeriod;
    private Integer toCurtYearDepreciatePeriod;
    private Integer taxYearDepreciationPeriod;
    private BigDecimal taxMonthDepreciationAmount;
    private BigDecimal toCurtYearDepreciateAmount;
    private BigDecimal taxRuleSettingOrganization;
    private BigDecimal totalDifferenceAmount;
    private BigDecimal yearDifferenceAmount;
    private Integer isRetain;
    private Date createTime;
    private Date updateTime;
    private Integer assetType;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ASSET_NUMBER", nullable = false, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAssetNumber() {
        return assetNumber;
    }

    public void setAssetNumber(String assetNumber) {
        this.assetNumber = assetNumber;
    }

    @Basic
    @Column(name = "ASSET_GROUP_NAME", nullable = false, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAssetGroupName() {
        return assetGroupName;
    }

    public void setAssetGroupName(String assetGroupName) {
        this.assetGroupName = assetGroupName;
    }

    @Basic
    @Column(name = "ASSET_DETAIL_GROUP_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAssetDetailGroupId() {
        return assetDetailGroupId;
    }

    public void setAssetDetailGroupId(String assetDetailGroupId) {
        this.assetDetailGroupId = assetDetailGroupId;
    }

    @Basic
    @Column(name = "ASSET_DESCRIPTION", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getAssetDescription() {
        return assetDescription;
    }

    public void setAssetDescription(String assetDescription) {
        this.assetDescription = assetDescription;
    }

    @Basic
    @Column(name = "BUY_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getBuyDate() {
        return buyDate;
    }

    public void setBuyDate(Date buyDate) {
        this.buyDate = buyDate;
    }

    @Basic
    @Column(name = "DEPRECIATION_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getDepreciationDate() {
        return depreciationDate;
    }

    public void setDepreciationDate(Date depreciationDate) {
        this.depreciationDate = depreciationDate;
    }

    @Basic
    @Column(name = "DEPRECIATION_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDepreciationPeriod() {
        return depreciationPeriod;
    }

    public void setDepreciationPeriod(Integer depreciationPeriod) {
        this.depreciationPeriod = depreciationPeriod;
    }

    @Basic
    @Column(name = "ACQUISITION_VALUE", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAcquisitionValue() {
        return acquisitionValue;
    }

    public void setAcquisitionValue(BigDecimal acquisitionValue) {
        this.acquisitionValue = acquisitionValue;
    }

    @Basic
    @Column(name = "ADJUSTMENT_VALUE", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAdjustmentValue() {
        return adjustmentValue;
    }

    public void setAdjustmentValue(BigDecimal adjustmentValue) {
        this.adjustmentValue = adjustmentValue;
    }

    @Basic
    @Column(name = "DISPOSED_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getDisposedDate() {
        return disposedDate;
    }

    public void setDisposedDate(Date disposedDate) {
        this.disposedDate = disposedDate;
    }

    @Basic
    @Column(name = "RESIDUAL_RATE", nullable = true, precision = 5)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getResidualRate() {
        return residualRate;
    }

    public void setResidualRate(BigDecimal residualRate) {
        this.residualRate = residualRate;
    }

    @Basic
    @Column(name = "YEAR_DEPRECIATION_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearDepreciationAmount() {
        return yearDepreciationAmount;
    }

    public void setYearDepreciationAmount(BigDecimal yearDepreciationAmount) {
        this.yearDepreciationAmount = yearDepreciationAmount;
    }

    @Basic
    @Column(name = "YEAR_ADJUSTMENT_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearAdjustmentAmount() {
        return yearAdjustmentAmount;
    }

    public void setYearAdjustmentAmount(BigDecimal yearAdjustmentAmount) {
        this.yearAdjustmentAmount = yearAdjustmentAmount;
    }

    @Basic
    @Column(name = "YEAR_END_VALUE", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearEndValue() {
        return yearEndValue;
    }

    public void setYearEndValue(BigDecimal yearEndValue) {
        this.yearEndValue = yearEndValue;
    }

    @Basic
    @Column(name = "STATUS", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Basic
    @Column(name = "ACCOUNT_ACQUISITION_VALUE", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAccountAcquisitionValue() {
        return accountAcquisitionValue;
    }

    public void setAccountAcquisitionValue(BigDecimal accountAcquisitionValue) {
        this.accountAcquisitionValue = accountAcquisitionValue;
    }

    @Basic
    @Column(name = "MONTH_DEPRECIATION_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAccountMonthDepreciationAmount() {
        return accountMonthDepreciationAmount;
    }

    public void setAccountMonthDepreciationAmount(BigDecimal accountMonthDepreciationAmount) {
        this.accountMonthDepreciationAmount = accountMonthDepreciationAmount;
    }

    @Basic
    @Column(name = "AYEAR_DEPRECIATION_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAccountYearDepreciationAmount() {
        return accountYearDepreciationAmount;
    }

    public void setAccountYearDepreciationAmount(BigDecimal accountYearDepreciationAmount) {
        this.accountYearDepreciationAmount = accountYearDepreciationAmount;
    }

    @Basic
    @Column(name = "TOTALEPRECIATION_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAccountTotalepreciationAmount() {
        return accountTotalepreciationAmount;
    }

    public void setAccountTotalepreciationAmount(BigDecimal accountTotalepreciationAmount) {
        this.accountTotalepreciationAmount = accountTotalepreciationAmount;
    }

    @Basic
    @Column(name = "TAX_DEPRECIATION_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getTaxDepreciationPeriod() {
        return taxDepreciationPeriod;
    }

    public void setTaxDepreciationPeriod(Integer taxDepreciationPeriod) {
        this.taxDepreciationPeriod = taxDepreciationPeriod;
    }

    @Basic
    @Column(name = "TO_LAST_YEAR_DEPRECIATE_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getToLastYearDepreciatePeriod() {
        return toLastYearDepreciatePeriod;
    }

    public void setToLastYearDepreciatePeriod(Integer toLastYearDepreciatePeriod) {
        this.toLastYearDepreciatePeriod = toLastYearDepreciatePeriod;
    }

    @Basic
    @Column(name = "TO_CURT_YEAR_DEPRECIATE_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getToCurtYearDepreciatePeriod() {
        return toCurtYearDepreciatePeriod;
    }

    public void setToCurtYearDepreciatePeriod(Integer toCurtYearDepreciatePeriod) {
        this.toCurtYearDepreciatePeriod = toCurtYearDepreciatePeriod;
    }

    @Basic
    @Column(name = "TAX_YEAR_DEPRECIATION_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getTaxYearDepreciationPeriod() {
        return taxYearDepreciationPeriod;
    }

    public void setTaxYearDepreciationPeriod(Integer taxYearDepreciationPeriod) {
        this.taxYearDepreciationPeriod = taxYearDepreciationPeriod;
    }

    @Basic
    @Column(name = "TAX_MONTH_DEPRECIATION_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxMonthDepreciationAmount() {
        return taxMonthDepreciationAmount;
    }

    public void setTaxMonthDepreciationAmount(BigDecimal taxMonthDepreciationAmount) {
        this.taxMonthDepreciationAmount = taxMonthDepreciationAmount;
    }

    @Basic
    @Column(name = "TO_CURT_YEAR_DEPRECIATE_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getToCurtYearDepreciateAmount() {
        return toCurtYearDepreciateAmount;
    }

    public void setToCurtYearDepreciateAmount(BigDecimal toCurtYearDepreciateAmount) {
        this.toCurtYearDepreciateAmount = toCurtYearDepreciateAmount;
    }

    @Basic
    @Column(name = "TAX_RULE_SETTING_ORGANIZATION", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxRuleSettingOrganization() {
        return taxRuleSettingOrganization;
    }

    public void setTaxRuleSettingOrganization(BigDecimal taxRuleSettingOrganization) {
        this.taxRuleSettingOrganization = taxRuleSettingOrganization;
    }

    @Basic
    @Column(name = "TOTAL_DIFFERENCE_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTotalDifferenceAmount() {
        return totalDifferenceAmount;
    }

    public void setTotalDifferenceAmount(BigDecimal totalDifferenceAmount) {
        this.totalDifferenceAmount = totalDifferenceAmount;
    }

    @Basic
    @Column(name = "YEAR_DIFFERENCE_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearDifferenceAmount() {
        return yearDifferenceAmount;
    }

    public void setYearDifferenceAmount(BigDecimal yearDifferenceAmount) {
        this.yearDifferenceAmount = yearDifferenceAmount;
    }

    @Basic
    @Column(name = "IS_RETAIN", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsRetain() {
        return isRetain;
    }

    public void setIsRetain(Integer isRetain) {
        this.isRetain = isRetain;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "ASSET_TYPE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAssetType() {
        return assetType;
    }

    public void setAssetType(Integer assetType) {
        this.assetType = assetType;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AssetsList that = (AssetsList) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(assetNumber, that.assetNumber) &&
                Objects.equals(assetGroupName, that.assetGroupName) &&
                Objects.equals(assetDetailGroupId, that.assetDetailGroupId) &&
                Objects.equals(assetDescription, that.assetDescription) &&
                Objects.equals(buyDate, that.buyDate) &&
                Objects.equals(depreciationDate, that.depreciationDate) &&
                Objects.equals(depreciationPeriod, that.depreciationPeriod) &&
                Objects.equals(acquisitionValue, that.acquisitionValue) &&
                Objects.equals(adjustmentValue, that.adjustmentValue) &&
                Objects.equals(disposedDate, that.disposedDate) &&
                Objects.equals(residualRate, that.residualRate) &&
                Objects.equals(yearDepreciationAmount, that.yearDepreciationAmount) &&
                Objects.equals(yearAdjustmentAmount, that.yearAdjustmentAmount) &&
                Objects.equals(yearEndValue, that.yearEndValue) &&
                Objects.equals(status, that.status) &&
                Objects.equals(accountAcquisitionValue, that.accountAcquisitionValue) &&
                Objects.equals(accountMonthDepreciationAmount, that.accountMonthDepreciationAmount) &&
                Objects.equals(accountYearDepreciationAmount, that.accountYearDepreciationAmount) &&
                Objects.equals(accountTotalepreciationAmount, that.accountTotalepreciationAmount) &&
                Objects.equals(taxDepreciationPeriod, that.taxDepreciationPeriod) &&
                Objects.equals(toLastYearDepreciatePeriod, that.toLastYearDepreciatePeriod) &&
                Objects.equals(toCurtYearDepreciatePeriod, that.toCurtYearDepreciatePeriod) &&
                Objects.equals(taxYearDepreciationPeriod, that.taxYearDepreciationPeriod) &&
                Objects.equals(taxMonthDepreciationAmount, that.taxMonthDepreciationAmount) &&
                Objects.equals(toCurtYearDepreciateAmount, that.toCurtYearDepreciateAmount) &&
                Objects.equals(taxRuleSettingOrganization, that.taxRuleSettingOrganization) &&
                Objects.equals(totalDifferenceAmount, that.totalDifferenceAmount) &&
                Objects.equals(yearDifferenceAmount, that.yearDifferenceAmount) &&
                Objects.equals(isRetain, that.isRetain) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(assetType, that.assetType);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, assetNumber, assetGroupName, assetDetailGroupId, assetDescription, buyDate, depreciationDate, depreciationPeriod, acquisitionValue, adjustmentValue, disposedDate, residualRate, yearDepreciationAmount, yearAdjustmentAmount, yearEndValue, status, accountAcquisitionValue, accountMonthDepreciationAmount, accountYearDepreciationAmount, accountTotalepreciationAmount, taxDepreciationPeriod, toLastYearDepreciatePeriod, toCurtYearDepreciatePeriod, taxYearDepreciationPeriod, taxMonthDepreciationAmount, toCurtYearDepreciateAmount, taxRuleSettingOrganization, totalDifferenceAmount, yearDifferenceAmount, isRetain, createTime, updateTime, assetType);
    }
}
