package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "BALANCE", schema = PROJECT_SCHEMA, catalog = "")
public class Balance {
    private String balanceId;
    private Integer periodId;
    private String acctCode;
    private String customerCode;
    private BigDecimal begDebitBal;
    private BigDecimal begCreditBal;
    private BigDecimal begBal;
    private BigDecimal endBal;
    private BigDecimal endDebitBal;
    private BigDecimal endCreditBal;
    private BigDecimal debitBal;
    private BigDecimal creditBal;
    private Integer monthId;
    private BigDecimal yearDebitBal;
    private BigDecimal yearCreditBal;
    private BigDecimal carryoverDebit;
    private BigDecimal carryoverCredit;
    private BigDecimal yearCarryoverDebit;
    private BigDecimal yearCarryoverCredit;
    private BigDecimal debitNet;
    private BigDecimal creditNet;
    private BigDecimal yearDebitNet;
    private BigDecimal yearCreditNet;
    private String stdCode;
    private String mappingReason;
    private String mappingUser;
    private Date mappingTime;
    private Integer subProp;
    private Integer isDummy;

    @Id
    @Column(name = "BALANCE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBalanceId() {
        return balanceId;
    }

    public void setBalanceId(String balanceId) {
        this.balanceId = balanceId;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "ACCT_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAcctCode() {
        return acctCode;
    }

    public void setAcctCode(String acctCode) {
        this.acctCode = acctCode;
    }

    @Basic
    @Column(name = "CUSTOMER_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCustomerCode() {
        return customerCode;
    }

    public void setCustomerCode(String customerCode) {
        this.customerCode = customerCode;
    }

    @Basic
    @Column(name = "BEG_DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBegDebitBal() {
        return begDebitBal;
    }

    public void setBegDebitBal(BigDecimal begDebitBal) {
        this.begDebitBal = begDebitBal;
    }

    @Basic
    @Column(name = "BEG_CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBegCreditBal() {
        return begCreditBal;
    }

    public void setBegCreditBal(BigDecimal begCreditBal) {
        this.begCreditBal = begCreditBal;
    }

    @Basic
    @Column(name = "BEG_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBegBal() {
        return begBal;
    }

    public void setBegBal(BigDecimal begBal) {
        this.begBal = begBal;
    }

    @Basic
    @Column(name = "END_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getEndBal() {
        return endBal;
    }

    public void setEndBal(BigDecimal endBal) {
        this.endBal = endBal;
    }

    @Basic
    @Column(name = "END_DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getEndDebitBal() {
        return endDebitBal;
    }

    public void setEndDebitBal(BigDecimal endDebitBal) {
        this.endDebitBal = endDebitBal;
    }

    @Basic
    @Column(name = "END_CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getEndCreditBal() {
        return endCreditBal;
    }

    public void setEndCreditBal(BigDecimal endCreditBal) {
        this.endCreditBal = endCreditBal;
    }

    @Basic
    @Column(name = "DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getDebitBal() {
        return debitBal;
    }

    public void setDebitBal(BigDecimal debitBal) {
        this.debitBal = debitBal;
    }

    @Basic
    @Column(name = "CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCreditBal() {
        return creditBal;
    }

    public void setCreditBal(BigDecimal creditBal) {
        this.creditBal = creditBal;
    }

    @Basic
    @Column(name = "MONTH_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getMonthId() {
        return monthId;
    }

    public void setMonthId(Integer monthId) {
        this.monthId = monthId;
    }

    @Basic
    @Column(name = "YEAR_DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearDebitBal() {
        return yearDebitBal;
    }

    public void setYearDebitBal(BigDecimal yearDebitBal) {
        this.yearDebitBal = yearDebitBal;
    }

    @Basic
    @Column(name = "YEAR_CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearCreditBal() {
        return yearCreditBal;
    }

    public void setYearCreditBal(BigDecimal yearCreditBal) {
        this.yearCreditBal = yearCreditBal;
    }

    @Basic
    @Column(name = "CARRYOVER_DEBIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCarryoverDebit() {
        return carryoverDebit;
    }

    public void setCarryoverDebit(BigDecimal carryoverDebit) {
        this.carryoverDebit = carryoverDebit;
    }

    @Basic
    @Column(name = "CARRYOVER_CREDIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCarryoverCredit() {
        return carryoverCredit;
    }

    public void setCarryoverCredit(BigDecimal carryoverCredit) {
        this.carryoverCredit = carryoverCredit;
    }

    @Basic
    @Column(name = "YEAR_CARRYOVER_DEBIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearCarryoverDebit() {
        return yearCarryoverDebit;
    }

    public void setYearCarryoverDebit(BigDecimal yearCarryoverDebit) {
        this.yearCarryoverDebit = yearCarryoverDebit;
    }

    @Basic
    @Column(name = "YEAR_CARRYOVER_CREDIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearCarryoverCredit() {
        return yearCarryoverCredit;
    }

    public void setYearCarryoverCredit(BigDecimal yearCarryoverCredit) {
        this.yearCarryoverCredit = yearCarryoverCredit;
    }

    @Basic
    @Column(name = "DEBIT_NET", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getDebitNet() {
        return debitNet;
    }

    public void setDebitNet(BigDecimal debitNet) {
        this.debitNet = debitNet;
    }

    @Basic
    @Column(name = "CREDIT_NET", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCreditNet() {
        return creditNet;
    }

    public void setCreditNet(BigDecimal creditNet) {
        this.creditNet = creditNet;
    }

    @Basic
    @Column(name = "YEAR_DEBIT_NET", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearDebitNet() {
        return yearDebitNet;
    }

    public void setYearDebitNet(BigDecimal yearDebitNet) {
        this.yearDebitNet = yearDebitNet;
    }

    @Basic
    @Column(name = "YEAR_CREDIT_NET", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearCreditNet() {
        return yearCreditNet;
    }

    public void setYearCreditNet(BigDecimal yearCreditNet) {
        this.yearCreditNet = yearCreditNet;
    }

    @Basic
    @Column(name = "STD_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getStdCode() {
        return stdCode;
    }

    public void setStdCode(String stdCode) {
        this.stdCode = stdCode;
    }

    @Basic
    @Column(name = "MAPPING_REASON", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getMappingReason() {
        return mappingReason;
    }

    public void setMappingReason(String mappingReason) {
        this.mappingReason = mappingReason;
    }

    @Basic
    @Column(name = "MAPPING_USER", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMappingUser() {
        return mappingUser;
    }

    public void setMappingUser(String mappingUser) {
        this.mappingUser = mappingUser;
    }

    @Basic
    @Column(name = "MAPPING_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getMappingTime() {
        return mappingTime;
    }

    public void setMappingTime(Date mappingTime) {
        this.mappingTime = mappingTime;
    }

    @Basic
    @Column(name = "SUB_PROP", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getSubProp() {
        return subProp;
    }

    public void setSubProp(Integer subProp) {
        this.subProp = subProp;
    }

    @Basic
    @Column(name = "IS_DUMMY", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsDummy() {
        return isDummy;
    }

    public void setIsDummy(Integer isDummy) {
        this.isDummy = isDummy;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Balance balance = (Balance) o;
        return Objects.equals(balanceId, balance.balanceId) &&
                Objects.equals(periodId, balance.periodId) &&
                Objects.equals(acctCode, balance.acctCode) &&
                Objects.equals(customerCode, balance.customerCode) &&
                Objects.equals(begDebitBal, balance.begDebitBal) &&
                Objects.equals(begCreditBal, balance.begCreditBal) &&
                Objects.equals(begBal, balance.begBal) &&
                Objects.equals(endBal, balance.endBal) &&
                Objects.equals(endDebitBal, balance.endDebitBal) &&
                Objects.equals(endCreditBal, balance.endCreditBal) &&
                Objects.equals(debitBal, balance.debitBal) &&
                Objects.equals(creditBal, balance.creditBal) &&
                Objects.equals(monthId, balance.monthId) &&
                Objects.equals(yearDebitBal, balance.yearDebitBal) &&
                Objects.equals(yearCreditBal, balance.yearCreditBal) &&
                Objects.equals(carryoverDebit, balance.carryoverDebit) &&
                Objects.equals(carryoverCredit, balance.carryoverCredit) &&
                Objects.equals(yearCarryoverDebit, balance.yearCarryoverDebit) &&
                Objects.equals(yearCarryoverCredit, balance.yearCarryoverCredit) &&
                Objects.equals(debitNet, balance.debitNet) &&
                Objects.equals(creditNet, balance.creditNet) &&
                Objects.equals(yearDebitNet, balance.yearDebitNet) &&
                Objects.equals(yearCreditNet, balance.yearCreditNet) &&
                Objects.equals(stdCode, balance.stdCode) &&
                Objects.equals(mappingReason, balance.mappingReason) &&
                Objects.equals(mappingUser, balance.mappingUser) &&
                Objects.equals(mappingTime, balance.mappingTime) &&
                Objects.equals(subProp, balance.subProp) &&
                Objects.equals(isDummy, balance.isDummy);
    }

    @Override
    public int hashCode() {
        return Objects.hash(balanceId, periodId, acctCode, customerCode, begDebitBal, begCreditBal, begBal, endBal, endDebitBal, endCreditBal, debitBal, creditBal, monthId, yearDebitBal, yearCreditBal, carryoverDebit, carryoverCredit, yearCarryoverDebit, yearCarryoverCredit, debitNet, creditNet, yearDebitNet, yearCreditNet, stdCode, mappingReason, mappingUser, mappingTime, subProp, isDummy);
    }
}
