package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "BALANCE_STD_MANUAL", schema = PROJECT_SCHEMA, catalog = "")
public class BalanceStdManual {
    private String balanceId;
    private Long periodId;
    private String acctCode;
    private BigDecimal begBal;
    private BigDecimal begDebitBal;
    private BigDecimal begCreditBal;
    private BigDecimal debitBal;
    private BigDecimal creditBal;
    private BigDecimal yearDebitBal;
    private BigDecimal yearCreditBal;
    private BigDecimal endBal;
    private BigDecimal endDebitBal;
    private BigDecimal endCreditBal;
    private Integer subProp;
    private BigDecimal carryoverDebit;
    private BigDecimal carryoverCredit;
    private BigDecimal yearCarryoverDebit;
    private BigDecimal yearCarryoverCredit;
    private BigDecimal debitNet;
    private BigDecimal creditNet;
    private BigDecimal yearDebitNet;
    private BigDecimal yearCreditNet;

    @Id
    @Column(name = "BALANCE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBalanceId() {
        return balanceId;
    }

    public void setBalanceId(String balanceId) {
        this.balanceId = balanceId;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Long periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "ACCT_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAcctCode() {
        return acctCode;
    }

    public void setAcctCode(String acctCode) {
        this.acctCode = acctCode;
    }

    @Basic
    @Column(name = "BEG_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBegBal() {
        return begBal;
    }

    public void setBegBal(BigDecimal begBal) {
        this.begBal = begBal;
    }

    @Basic
    @Column(name = "BEG_DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBegDebitBal() {
        return begDebitBal;
    }

    public void setBegDebitBal(BigDecimal begDebitBal) {
        this.begDebitBal = begDebitBal;
    }

    @Basic
    @Column(name = "BEG_CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBegCreditBal() {
        return begCreditBal;
    }

    public void setBegCreditBal(BigDecimal begCreditBal) {
        this.begCreditBal = begCreditBal;
    }

    @Basic
    @Column(name = "DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getDebitBal() {
        return debitBal;
    }

    public void setDebitBal(BigDecimal debitBal) {
        this.debitBal = debitBal;
    }

    @Basic
    @Column(name = "CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCreditBal() {
        return creditBal;
    }

    public void setCreditBal(BigDecimal creditBal) {
        this.creditBal = creditBal;
    }

    @Basic
    @Column(name = "YEAR_DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearDebitBal() {
        return yearDebitBal;
    }

    public void setYearDebitBal(BigDecimal yearDebitBal) {
        this.yearDebitBal = yearDebitBal;
    }

    @Basic
    @Column(name = "YEAR_CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearCreditBal() {
        return yearCreditBal;
    }

    public void setYearCreditBal(BigDecimal yearCreditBal) {
        this.yearCreditBal = yearCreditBal;
    }

    @Basic
    @Column(name = "END_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getEndBal() {
        return endBal;
    }

    public void setEndBal(BigDecimal endBal) {
        this.endBal = endBal;
    }

    @Basic
    @Column(name = "END_DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getEndDebitBal() {
        return endDebitBal;
    }

    public void setEndDebitBal(BigDecimal endDebitBal) {
        this.endDebitBal = endDebitBal;
    }

    @Basic
    @Column(name = "END_CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getEndCreditBal() {
        return endCreditBal;
    }

    public void setEndCreditBal(BigDecimal endCreditBal) {
        this.endCreditBal = endCreditBal;
    }

    @Basic
    @Column(name = "SUB_PROP", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getSubProp() {
        return subProp;
    }

    public void setSubProp(Integer subProp) {
        this.subProp = subProp;
    }

    @Basic
    @Column(name = "CARRYOVER_DEBIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCarryoverDebit() {
        return carryoverDebit;
    }

    public void setCarryoverDebit(BigDecimal carryoverDebit) {
        this.carryoverDebit = carryoverDebit;
    }

    @Basic
    @Column(name = "CARRYOVER_CREDIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCarryoverCredit() {
        return carryoverCredit;
    }

    public void setCarryoverCredit(BigDecimal carryoverCredit) {
        this.carryoverCredit = carryoverCredit;
    }

    @Basic
    @Column(name = "YEAR_CARRYOVER_DEBIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearCarryoverDebit() {
        return yearCarryoverDebit;
    }

    public void setYearCarryoverDebit(BigDecimal yearCarryoverDebit) {
        this.yearCarryoverDebit = yearCarryoverDebit;
    }

    @Basic
    @Column(name = "YEAR_CARRYOVER_CREDIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearCarryoverCredit() {
        return yearCarryoverCredit;
    }

    public void setYearCarryoverCredit(BigDecimal yearCarryoverCredit) {
        this.yearCarryoverCredit = yearCarryoverCredit;
    }

    @Basic
    @Column(name = "DEBIT_NET", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getDebitNet() {
        return debitNet;
    }

    public void setDebitNet(BigDecimal debitNet) {
        this.debitNet = debitNet;
    }

    @Basic
    @Column(name = "CREDIT_NET", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCreditNet() {
        return creditNet;
    }

    public void setCreditNet(BigDecimal creditNet) {
        this.creditNet = creditNet;
    }

    @Basic
    @Column(name = "YEAR_DEBIT_NET", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearDebitNet() {
        return yearDebitNet;
    }

    public void setYearDebitNet(BigDecimal yearDebitNet) {
        this.yearDebitNet = yearDebitNet;
    }

    @Basic
    @Column(name = "YEAR_CREDIT_NET", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearCreditNet() {
        return yearCreditNet;
    }

    public void setYearCreditNet(BigDecimal yearCreditNet) {
        this.yearCreditNet = yearCreditNet;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        BalanceStdManual that = (BalanceStdManual) o;
        return periodId == that.periodId &&
                Objects.equals(balanceId, that.balanceId) &&
                Objects.equals(acctCode, that.acctCode) &&
                Objects.equals(begBal, that.begBal) &&
                Objects.equals(begDebitBal, that.begDebitBal) &&
                Objects.equals(begCreditBal, that.begCreditBal) &&
                Objects.equals(debitBal, that.debitBal) &&
                Objects.equals(creditBal, that.creditBal) &&
                Objects.equals(yearDebitBal, that.yearDebitBal) &&
                Objects.equals(yearCreditBal, that.yearCreditBal) &&
                Objects.equals(endBal, that.endBal) &&
                Objects.equals(endDebitBal, that.endDebitBal) &&
                Objects.equals(endCreditBal, that.endCreditBal) &&
                Objects.equals(subProp, that.subProp) &&
                Objects.equals(carryoverDebit, that.carryoverDebit) &&
                Objects.equals(carryoverCredit, that.carryoverCredit) &&
                Objects.equals(yearCarryoverDebit, that.yearCarryoverDebit) &&
                Objects.equals(yearCarryoverCredit, that.yearCarryoverCredit) &&
                Objects.equals(debitNet, that.debitNet) &&
                Objects.equals(creditNet, that.creditNet) &&
                Objects.equals(yearDebitNet, that.yearDebitNet) &&
                Objects.equals(yearCreditNet, that.yearCreditNet);
    }

    @Override
    public int hashCode() {
        return Objects.hash(balanceId, periodId, acctCode, begBal, begDebitBal, begCreditBal, debitBal, creditBal, yearDebitBal, yearCreditBal, endBal, endDebitBal, endCreditBal, subProp, carryoverDebit, carryoverCredit, yearCarryoverDebit, yearCarryoverCredit, debitNet, creditNet, yearDebitNet, yearCreditNet);
    }
}
