package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "CELL_DATA", schema = PROJECT_SCHEMA, catalog = "")
public class CellData {
    private Long id;
    private Long reportId;
    private Long cellTemplateId;
    private String data;
    private String formulaExp;
    private String createBy;
    private Date createTime;
    private String updateBy;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "REPORT_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getReportId() {
        return reportId;
    }

    public void setReportId(Long reportId) {
        this.reportId = reportId;
    }

    @Basic
    @Column(name = "CELL_TEMPLATE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getCellTemplateId() {
        return cellTemplateId;
    }

    public void setCellTemplateId(Long cellTemplateId) {
        this.cellTemplateId = cellTemplateId;
    }

    @Basic
    @Column(name = "DATA", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getData() {
        return data;
    }

    public void setData(String data) {
        this.data = data;
    }

    @Basic
    @Column(name = "FORMULA_EXP", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFormulaExp() {
        return formulaExp;
    }

    public void setFormulaExp(String formulaExp) {
        this.formulaExp = formulaExp;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CellData cellData = (CellData) o;
        return id == cellData.id &&
                reportId == cellData.reportId &&
                cellTemplateId == cellData.cellTemplateId &&
                Objects.equals(data, cellData.data) &&
                Objects.equals(formulaExp, cellData.formulaExp) &&
                Objects.equals(createBy, cellData.createBy) &&
                Objects.equals(createTime, cellData.createTime) &&
                Objects.equals(updateBy, cellData.updateBy) &&
                Objects.equals(updateTime, cellData.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, reportId, cellTemplateId, data, formulaExp, createBy, createTime, updateBy, updateTime);
    }
}
