package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "CELL_DATA_SOURCE", schema = PROJECT_SCHEMA, catalog = "")
public class CellDataSource {
    private Long id;
    private Long cellTemplateId;
    private Long cellDataId;
    private Long dataSourceId;
    private Integer operationType;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CELL_TEMPLATE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getCellTemplateId() {
        return cellTemplateId;
    }

    public void setCellTemplateId(Long cellTemplateId) {
        this.cellTemplateId = cellTemplateId;
    }

    @Basic
    @Column(name = "CELL_DATA_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getCellDataId() {
        return cellDataId;
    }

    public void setCellDataId(Long cellDataId) {
        this.cellDataId = cellDataId;
    }

    @Basic
    @Column(name = "DATA_SOURCE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getDataSourceId() {
        return dataSourceId;
    }

    public void setDataSourceId(Long dataSourceId) {
        this.dataSourceId = dataSourceId;
    }

    @Basic
    @Column(name = "OPERATION_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getOperationType() {
        return operationType;
    }

    public void setOperationType(Integer operationType) {
        this.operationType = operationType;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CellDataSource that = (CellDataSource) o;
        return id == that.id &&
                cellTemplateId == that.cellTemplateId &&
                cellDataId == that.cellDataId &&
                dataSourceId == that.dataSourceId &&
                operationType == that.operationType &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, cellTemplateId, cellDataId, dataSourceId, operationType, createTime, updateTime);
    }
}
