package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "CUST_BALANCE", schema = PROJECT_SCHEMA, catalog = "")
public class CustBalance {
    private String balanceId;
    private Long periodId;
    private String acctCode;
    private String customerCode;
    private BigDecimal begBal;
    private BigDecimal begDebitBal;
    private BigDecimal begCreditBal;
    private BigDecimal debitBal;
    private BigDecimal creditBal;
    private BigDecimal yearDebitBal;
    private BigDecimal yearCreditBal;
    private BigDecimal endBal;
    private BigDecimal endDebitBal;
    private BigDecimal endCreditBal;
    private Integer monthId;
    private Integer isDummy;

    @Id
    @Column(name = "BALANCE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBalanceId() {
        return balanceId;
    }

    public void setBalanceId(String balanceId) {
        this.balanceId = balanceId;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Long periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "ACCT_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAcctCode() {
        return acctCode;
    }

    public void setAcctCode(String acctCode) {
        this.acctCode = acctCode;
    }

    @Basic
    @Column(name = "CUSTOMER_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCustomerCode() {
        return customerCode;
    }

    public void setCustomerCode(String customerCode) {
        this.customerCode = customerCode;
    }

    @Basic
    @Column(name = "BEG_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBegBal() {
        return begBal;
    }

    public void setBegBal(BigDecimal begBal) {
        this.begBal = begBal;
    }

    @Basic
    @Column(name = "BEG_DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBegDebitBal() {
        return begDebitBal;
    }

    public void setBegDebitBal(BigDecimal begDebitBal) {
        this.begDebitBal = begDebitBal;
    }

    @Basic
    @Column(name = "BEG_CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBegCreditBal() {
        return begCreditBal;
    }

    public void setBegCreditBal(BigDecimal begCreditBal) {
        this.begCreditBal = begCreditBal;
    }

    @Basic
    @Column(name = "DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getDebitBal() {
        return debitBal;
    }

    public void setDebitBal(BigDecimal debitBal) {
        this.debitBal = debitBal;
    }

    @Basic
    @Column(name = "CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCreditBal() {
        return creditBal;
    }

    public void setCreditBal(BigDecimal creditBal) {
        this.creditBal = creditBal;
    }

    @Basic
    @Column(name = "YEAR_DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearDebitBal() {
        return yearDebitBal;
    }

    public void setYearDebitBal(BigDecimal yearDebitBal) {
        this.yearDebitBal = yearDebitBal;
    }

    @Basic
    @Column(name = "YEAR_CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getYearCreditBal() {
        return yearCreditBal;
    }

    public void setYearCreditBal(BigDecimal yearCreditBal) {
        this.yearCreditBal = yearCreditBal;
    }

    @Basic
    @Column(name = "END_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getEndBal() {
        return endBal;
    }

    public void setEndBal(BigDecimal endBal) {
        this.endBal = endBal;
    }

    @Basic
    @Column(name = "END_DEBIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getEndDebitBal() {
        return endDebitBal;
    }

    public void setEndDebitBal(BigDecimal endDebitBal) {
        this.endDebitBal = endDebitBal;
    }

    @Basic
    @Column(name = "END_CREDIT_BAL", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getEndCreditBal() {
        return endCreditBal;
    }

    public void setEndCreditBal(BigDecimal endCreditBal) {
        this.endCreditBal = endCreditBal;
    }

    @Basic
    @Column(name = "MONTH_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getMonthId() {
        return monthId;
    }

    public void setMonthId(Integer monthId) {
        this.monthId = monthId;
    }

    @Basic
    @Column(name = "IS_DUMMY", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsDummy() {
        return isDummy;
    }

    public void setIsDummy(Integer isDummy) {
        this.isDummy = isDummy;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CustBalance that = (CustBalance) o;
        return periodId == that.periodId &&
                Objects.equals(balanceId, that.balanceId) &&
                Objects.equals(acctCode, that.acctCode) &&
                Objects.equals(customerCode, that.customerCode) &&
                Objects.equals(begBal, that.begBal) &&
                Objects.equals(begDebitBal, that.begDebitBal) &&
                Objects.equals(begCreditBal, that.begCreditBal) &&
                Objects.equals(debitBal, that.debitBal) &&
                Objects.equals(creditBal, that.creditBal) &&
                Objects.equals(yearDebitBal, that.yearDebitBal) &&
                Objects.equals(yearCreditBal, that.yearCreditBal) &&
                Objects.equals(endBal, that.endBal) &&
                Objects.equals(endDebitBal, that.endDebitBal) &&
                Objects.equals(endCreditBal, that.endCreditBal) &&
                Objects.equals(monthId, that.monthId) &&
                Objects.equals(isDummy, that.isDummy);
    }

    @Override
    public int hashCode() {
        return Objects.hash(balanceId, periodId, acctCode, customerCode, begBal, begDebitBal, begCreditBal, debitBal, creditBal, yearDebitBal, yearCreditBal, endBal, endDebitBal, endCreditBal, monthId, isDummy);
    }
}
