package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "CUSTOMS_INVOICE", schema = PROJECT_SCHEMA, catalog = "")
public class CustomsInvoice {
    private String customsId;
    private String payNum;
    private Date issueDate;
    private BigDecimal invoiceTaxAmount;
    private BigDecimal invoiceAmount;
    private String auditResult;
    private Date createTime;
    private Integer periodId;
    private String creatorId;
    private Integer status;
    private Integer partAccntedPeriod;
    private Integer accntedPeriod;

    @Id
    @Column(name = "CUSTOMS_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCustomsId() {
        return customsId;
    }

    public void setCustomsId(String customsId) {
        this.customsId = customsId;
    }

    @Basic
    @Column(name = "PAY_NUM", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPayNum() {
        return payNum;
    }

    public void setPayNum(String payNum) {
        this.payNum = payNum;
    }

    @Basic
    @Column(name = "ISSUE_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getIssueDate() {
        return issueDate;
    }

    public void setIssueDate(Date issueDate) {
        this.issueDate = issueDate;
    }

    @Basic
    @Column(name = "INVOICE_TAX_AMOUNT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getInvoiceTaxAmount() {
        return invoiceTaxAmount;
    }

    public void setInvoiceTaxAmount(BigDecimal invoiceTaxAmount) {
        this.invoiceTaxAmount = invoiceTaxAmount;
    }

    @Basic
    @Column(name = "INVOICE_AMOUNT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getInvoiceAmount() {
        return invoiceAmount;
    }

    public void setInvoiceAmount(BigDecimal invoiceAmount) {
        this.invoiceAmount = invoiceAmount;
    }

    @Basic
    @Column(name = "AUDIT_RESULT", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getAuditResult() {
        return auditResult;
    }

    public void setAuditResult(String auditResult) {
        this.auditResult = auditResult;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "STATUS", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Basic
    @Column(name = "PART_ACCNTED_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPartAccntedPeriod() {
        return partAccntedPeriod;
    }

    public void setPartAccntedPeriod(Integer partAccntedPeriod) {
        this.partAccntedPeriod = partAccntedPeriod;
    }

    @Basic
    @Column(name = "ACCNTED_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAccntedPeriod() {
        return accntedPeriod;
    }

    public void setAccntedPeriod(Integer accntedPeriod) {
        this.accntedPeriod = accntedPeriod;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CustomsInvoice that = (CustomsInvoice) o;
        return Objects.equals(customsId, that.customsId) &&
                Objects.equals(payNum, that.payNum) &&
                Objects.equals(issueDate, that.issueDate) &&
                Objects.equals(invoiceTaxAmount, that.invoiceTaxAmount) &&
                Objects.equals(invoiceAmount, that.invoiceAmount) &&
                Objects.equals(auditResult, that.auditResult) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(periodId, that.periodId) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(status, that.status) &&
                Objects.equals(partAccntedPeriod, that.partAccntedPeriod) &&
                Objects.equals(accntedPeriod, that.accntedPeriod);
    }

    @Override
    public int hashCode() {
        return Objects.hash(customsId, payNum, issueDate, invoiceTaxAmount, invoiceAmount, auditResult, createTime, periodId, creatorId, status, partAccntedPeriod, accntedPeriod);
    }
}
