package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "DATA_SOURCE_DETAIL", schema = PROJECT_SCHEMA, catalog = "")
public class DataSourceDetail {
    private Long id;
    private Long dataSourceId;
    private Integer dataSourceType;
    private String itemValue;

    @Id
    @Column(name = "ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "DATA_SOURCE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getDataSourceId() {
        return dataSourceId;
    }

    public void setDataSourceId(Long dataSourceId) {
        this.dataSourceId = dataSourceId;
    }

    @Basic
    @Column(name = "DATA_SOURCE_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDataSourceType() {
        return dataSourceType;
    }

    public void setDataSourceType(Integer dataSourceType) {
        this.dataSourceType = dataSourceType;
    }

    @Basic
    @Column(name = "ITEM_VALUE", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getItemValue() {
        return itemValue;
    }

    public void setItemValue(String itemValue) {
        this.itemValue = itemValue;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DataSourceDetail that = (DataSourceDetail) o;
        return id == that.id &&
                dataSourceId == that.dataSourceId &&
                dataSourceType == that.dataSourceType &&
                Objects.equals(itemValue, that.itemValue);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, dataSourceId, dataSourceType, itemValue);
    }
}
