package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ENTRIES_CHECK_DETAIL_RESULT", schema = PROJECT_SCHEMA, catalog = "")
public class EntriesCheckDetailResult {
    private String id;
    private String resultId;
    private Integer isDoubt;
    private Integer isBigVoucher;
    private String voucherId;
    private String vid;
    private Date date;
    private String group;
    private Integer period;
    private String customerCode;
    private String customerName;
    private String summary;
    private String acctCode;
    private String stdCode;
    private BigDecimal debit;
    private BigDecimal credit;
    private Long attach;
    private String itemId;
    private Integer importType;
    private Integer isFiltered;
    private Integer isRelevantAmt;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "RESULT_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getResultId() {
        return resultId;
    }

    public void setResultId(String resultId) {
        this.resultId = resultId;
    }

    @Basic
    @Column(name = "IS_DOUBT", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsDoubt() {
        return isDoubt;
    }

    public void setIsDoubt(Integer isDoubt) {
        this.isDoubt = isDoubt;
    }

    @Basic
    @Column(name = "IS_BIG_VOUCHER", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsBigVoucher() {
        return isBigVoucher;
    }

    public void setIsBigVoucher(Integer isBigVoucher) {
        this.isBigVoucher = isBigVoucher;
    }

    @Basic
    @Column(name = "VOUCHER_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVoucherId() {
        return voucherId;
    }

    public void setVoucherId(String voucherId) {
        this.voucherId = voucherId;
    }

    @Basic
    @Column(name = "VID", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getVid() {
        return vid;
    }

    public void setVid(String vid) {
        this.vid = vid;
    }

    @Basic
    @Column(name = B_Delimiter + "DATE" + E_Delimiter, nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    @Basic
    @Column(name = B_Delimiter + "GROUP" + E_Delimiter, nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGroup() {
        return group;
    }

    public void setGroup(String group) {
        this.group = group;
    }

    @Basic
    @Column(name = "PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "CUSTOMER_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCustomerCode() {
        return customerCode;
    }

    public void setCustomerCode(String customerCode) {
        this.customerCode = customerCode;
    }

    @Basic
    @Column(name = "CUSTOMER_NAME", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCustomerName() {
        return customerName;
    }

    public void setCustomerName(String customerName) {
        this.customerName = customerName;
    }

    @Basic
    @Column(name = "SUMMARY", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getSummary() {
        return summary;
    }

    public void setSummary(String summary) {
        this.summary = summary;
    }

    @Basic
    @Column(name = "ACCT_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAcctCode() {
        return acctCode;
    }

    public void setAcctCode(String acctCode) {
        this.acctCode = acctCode;
    }

    @Basic
    @Column(name = "STD_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getStdCode() {
        return stdCode;
    }

    public void setStdCode(String stdCode) {
        this.stdCode = stdCode;
    }

    @Basic
    @Column(name = "DEBIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getDebit() {
        return debit;
    }

    public void setDebit(BigDecimal debit) {
        this.debit = debit;
    }

    @Basic
    @Column(name = "CREDIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCredit() {
        return credit;
    }

    public void setCredit(BigDecimal credit) {
        this.credit = credit;
    }

    @Basic
    @Column(name = "ATTACH", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getAttach() {
        return attach;
    }

    public void setAttach(Long attach) {
        this.attach = attach;
    }

    @Basic
    @Column(name = "ITEM_ID", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    @Basic
    @Column(name = "IMPORT_TYPE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getImportType() {
        return importType;
    }

    public void setImportType(Integer importType) {
        this.importType = importType;
    }

    @Basic
    @Column(name = "IS_FILTERED", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsFiltered() {
        return isFiltered;
    }

    public void setIsFiltered(Integer isFiltered) {
        this.isFiltered = isFiltered;
    }

    @Basic
    @Column(name = "IS_RELEVANT_AMT", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsRelevantAmt() {
        return isRelevantAmt;
    }

    public void setIsRelevantAmt(Integer isRelevantAmt) {
        this.isRelevantAmt = isRelevantAmt;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        EntriesCheckDetailResult that = (EntriesCheckDetailResult) o;
        return isDoubt == that.isDoubt &&
                isBigVoucher == that.isBigVoucher &&
                isFiltered == that.isFiltered &&
                isRelevantAmt == that.isRelevantAmt &&
                Objects.equals(id, that.id) &&
                Objects.equals(resultId, that.resultId) &&
                Objects.equals(voucherId, that.voucherId) &&
                Objects.equals(vid, that.vid) &&
                Objects.equals(date, that.date) &&
                Objects.equals(group, that.group) &&
                Objects.equals(period, that.period) &&
                Objects.equals(customerCode, that.customerCode) &&
                Objects.equals(customerName, that.customerName) &&
                Objects.equals(summary, that.summary) &&
                Objects.equals(acctCode, that.acctCode) &&
                Objects.equals(stdCode, that.stdCode) &&
                Objects.equals(debit, that.debit) &&
                Objects.equals(credit, that.credit) &&
                Objects.equals(attach, that.attach) &&
                Objects.equals(itemId, that.itemId) &&
                Objects.equals(importType, that.importType) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, resultId, isDoubt, isBigVoucher, voucherId, vid, date, group, period, customerCode, customerName, summary, acctCode, stdCode, debit, credit, attach, itemId, importType, isFiltered, isRelevantAmt, createTime, updateTime);
    }
}
