package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ENTRIES_CHECK_RESULT", schema = PROJECT_SCHEMA, catalog = "")
public class EntriesCheckResult {
    private String id;
    private String modelId;
    private String code;
    private String name;
    private String description;
    private Integer voucherNum;
    private Integer entriesNum;
    private BigDecimal debitRelevantAmt;
    private BigDecimal creditRelevantAmt;
    private BigDecimal debitTotalAmt;
    private BigDecimal creditTotalAmt;
    private Integer bigVoucherNum;
    private Integer bigEntriesNum;
    private BigDecimal bigDebitRelevantAmt;
    private BigDecimal bigCreditRelevantAmt;
    private BigDecimal bigDebitTotalAmt;
    private BigDecimal bigCreditTotalAmt;
    private Integer entryDoubts;
    private Integer bigEntryDoubts;
    private Integer voucherDoubts;
    private Integer bigVoucherDoubts;
    private Integer isFiltered;
    private String serviceTypeId;
    private String categoryId;
    private Integer type;
    private Integer isFilter;
    private Integer isShow;
    private Integer period;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "MODEL_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelId() {
        return modelId;
    }

    public void setModelId(String modelId) {
        this.modelId = modelId;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 20)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "DESCRIPTION", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Basic
    @Column(name = "VOUCHER_NUM", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getVoucherNum() {
        return voucherNum;
    }

    public void setVoucherNum(Integer voucherNum) {
        this.voucherNum = voucherNum;
    }

    @Basic
    @Column(name = "ENTRIES_NUM", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getEntriesNum() {
        return entriesNum;
    }

    public void setEntriesNum(Integer entriesNum) {
        this.entriesNum = entriesNum;
    }

    @Basic
    @Column(name = "DEBIT_RELEVANT_AMT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getDebitRelevantAmt() {
        return debitRelevantAmt;
    }

    public void setDebitRelevantAmt(BigDecimal debitRelevantAmt) {
        this.debitRelevantAmt = debitRelevantAmt;
    }

    @Basic
    @Column(name = "CREDIT_RELEVANT_AMT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCreditRelevantAmt() {
        return creditRelevantAmt;
    }

    public void setCreditRelevantAmt(BigDecimal creditRelevantAmt) {
        this.creditRelevantAmt = creditRelevantAmt;
    }

    @Basic
    @Column(name = "DEBIT_TOTAL_AMT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getDebitTotalAmt() {
        return debitTotalAmt;
    }

    public void setDebitTotalAmt(BigDecimal debitTotalAmt) {
        this.debitTotalAmt = debitTotalAmt;
    }

    @Basic
    @Column(name = "CREDIT_TOTAL_AMT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCreditTotalAmt() {
        return creditTotalAmt;
    }

    public void setCreditTotalAmt(BigDecimal creditTotalAmt) {
        this.creditTotalAmt = creditTotalAmt;
    }

    @Basic
    @Column(name = "BIG_VOUCHER_NUM", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getBigVoucherNum() {
        return bigVoucherNum;
    }

    public void setBigVoucherNum(Integer bigVoucherNum) {
        this.bigVoucherNum = bigVoucherNum;
    }

    @Basic
    @Column(name = "BIG_ENTRIES_NUM", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getBigEntriesNum() {
        return bigEntriesNum;
    }

    public void setBigEntriesNum(Integer bigEntriesNum) {
        this.bigEntriesNum = bigEntriesNum;
    }

    @Basic
    @Column(name = "BIG_DEBIT_RELEVANT_AMT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBigDebitRelevantAmt() {
        return bigDebitRelevantAmt;
    }

    public void setBigDebitRelevantAmt(BigDecimal bigDebitRelevantAmt) {
        this.bigDebitRelevantAmt = bigDebitRelevantAmt;
    }

    @Basic
    @Column(name = "BIG_CREDIT_RELEVANT_AMT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBigCreditRelevantAmt() {
        return bigCreditRelevantAmt;
    }

    public void setBigCreditRelevantAmt(BigDecimal bigCreditRelevantAmt) {
        this.bigCreditRelevantAmt = bigCreditRelevantAmt;
    }

    @Basic
    @Column(name = "BIG_DEBIT_TOTAL_AMT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBigDebitTotalAmt() {
        return bigDebitTotalAmt;
    }

    public void setBigDebitTotalAmt(BigDecimal bigDebitTotalAmt) {
        this.bigDebitTotalAmt = bigDebitTotalAmt;
    }

    @Basic
    @Column(name = "BIG_CREDIT_TOTAL_AMT", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBigCreditTotalAmt() {
        return bigCreditTotalAmt;
    }

    public void setBigCreditTotalAmt(BigDecimal bigCreditTotalAmt) {
        this.bigCreditTotalAmt = bigCreditTotalAmt;
    }

    @Basic
    @Column(name = "ENTRY_DOUBTS", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getEntryDoubts() {
        return entryDoubts;
    }

    public void setEntryDoubts(Integer entryDoubts) {
        this.entryDoubts = entryDoubts;
    }

    @Basic
    @Column(name = "BIG_ENTRY_DOUBTS", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getBigEntryDoubts() {
        return bigEntryDoubts;
    }

    public void setBigEntryDoubts(Integer bigEntryDoubts) {
        this.bigEntryDoubts = bigEntryDoubts;
    }

    @Basic
    @Column(name = "VOUCHER_DOUBTS", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getVoucherDoubts() {
        return voucherDoubts;
    }

    public void setVoucherDoubts(Integer voucherDoubts) {
        this.voucherDoubts = voucherDoubts;
    }

    @Basic
    @Column(name = "BIG_VOUCHER_DOUBTS", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getBigVoucherDoubts() {
        return bigVoucherDoubts;
    }

    public void setBigVoucherDoubts(Integer bigVoucherDoubts) {
        this.bigVoucherDoubts = bigVoucherDoubts;
    }

    @Basic
    @Column(name = "IS_FILTERED", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsFiltered() {
        return isFiltered;
    }

    public void setIsFiltered(Integer isFiltered) {
        this.isFiltered = isFiltered;
    }

    @Basic
    @Column(name = "SERVICE_TYPE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getServiceTypeId() {
        return serviceTypeId;
    }

    public void setServiceTypeId(String serviceTypeId) {
        this.serviceTypeId = serviceTypeId;
    }

    @Basic
    @Column(name = "CATEGORY_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCategoryId() {
        return categoryId;
    }

    public void setCategoryId(String categoryId) {
        this.categoryId = categoryId;
    }

    @Basic
    @Column(name = "TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    @Basic
    @Column(name = "IS_FILTER", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsFilter() {
        return isFilter;
    }

    public void setIsFilter(Integer isFilter) {
        this.isFilter = isFilter;
    }

    @Basic
    @Column(name = "IS_SHOW", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsShow() {
        return isShow;
    }

    public void setIsShow(Integer isShow) {
        this.isShow = isShow;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        EntriesCheckResult that = (EntriesCheckResult) o;
        return voucherNum == that.voucherNum &&
                entriesNum == that.entriesNum &&
                bigVoucherNum == that.bigVoucherNum &&
                bigEntriesNum == that.bigEntriesNum &&
                entryDoubts == that.entryDoubts &&
                bigEntryDoubts == that.bigEntryDoubts &&
                voucherDoubts == that.voucherDoubts &&
                bigVoucherDoubts == that.bigVoucherDoubts &&
                isFiltered == that.isFiltered &&
                type == that.type &&
                isFilter == that.isFilter &&
                isShow == that.isShow &&
                period == that.period &&
                Objects.equals(id, that.id) &&
                Objects.equals(modelId, that.modelId) &&
                Objects.equals(code, that.code) &&
                Objects.equals(name, that.name) &&
                Objects.equals(description, that.description) &&
                Objects.equals(debitRelevantAmt, that.debitRelevantAmt) &&
                Objects.equals(creditRelevantAmt, that.creditRelevantAmt) &&
                Objects.equals(debitTotalAmt, that.debitTotalAmt) &&
                Objects.equals(creditTotalAmt, that.creditTotalAmt) &&
                Objects.equals(bigDebitRelevantAmt, that.bigDebitRelevantAmt) &&
                Objects.equals(bigCreditRelevantAmt, that.bigCreditRelevantAmt) &&
                Objects.equals(bigDebitTotalAmt, that.bigDebitTotalAmt) &&
                Objects.equals(bigCreditTotalAmt, that.bigCreditTotalAmt) &&
                Objects.equals(serviceTypeId, that.serviceTypeId) &&
                Objects.equals(categoryId, that.categoryId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, modelId, code, name, description, voucherNum, entriesNum, debitRelevantAmt, creditRelevantAmt, debitTotalAmt, creditTotalAmt, bigVoucherNum, bigEntriesNum, bigDebitRelevantAmt, bigCreditRelevantAmt, bigDebitTotalAmt, bigCreditTotalAmt, entryDoubts, bigEntryDoubts, voucherDoubts, bigVoucherDoubts, isFiltered, serviceTypeId, categoryId, type, isFilter, isShow, period, createTime, updateTime);
    }
}
