package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "FORMULA_CACHE", schema = PROJECT_SCHEMA, catalog = "")
@IdClass(FormulaCachePK.class)
public class FormulaCache {
    private String id;
    private Integer period;
    private Integer year;
    private String formula;
    private String formulaValue;
    private String targetReportTemplateId;
    private Integer targetRowIndex;
    private String targetRowName;
    private Integer targetColumnIndex;
    private String targetColumnName;
    private Integer targetPeriod;
    private String targetCellDataId;
    private String targetCellTemplateId;
    private Integer resultType;
    private Date createTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Id
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "YEAR", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getYear() {
        return year;
    }

    public void setYear(Integer year) {
        this.year = year;
    }

    @Basic
    @Column(name = "FORMULA", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getFormula() {
        return formula;
    }

    public void setFormula(String formula) {
        this.formula = formula;
    }

    @Basic
    @Column(name = "FORMULA_VALUE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFormulaValue() {
        return formulaValue;
    }

    public void setFormulaValue(String formulaValue) {
        this.formulaValue = formulaValue;
    }

    @Basic
    @Column(name = "TARGET_REPORT_TEMPLATE_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTargetReportTemplateId() {
        return targetReportTemplateId;
    }

    public void setTargetReportTemplateId(String targetReportTemplateId) {
        this.targetReportTemplateId = targetReportTemplateId;
    }

    @Basic
    @Column(name = "TARGET_ROW_INDEX", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getTargetRowIndex() {
        return targetRowIndex;
    }

    public void setTargetRowIndex(Integer targetRowIndex) {
        this.targetRowIndex = targetRowIndex;
    }

    @Basic
    @Column(name = "TARGET_ROW_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTargetRowName() {
        return targetRowName;
    }

    public void setTargetRowName(String targetRowName) {
        this.targetRowName = targetRowName;
    }

    @Basic
    @Column(name = "TARGET_COLUMN_INDEX", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getTargetColumnIndex() {
        return targetColumnIndex;
    }

    public void setTargetColumnIndex(Integer targetColumnIndex) {
        this.targetColumnIndex = targetColumnIndex;
    }

    @Basic
    @Column(name = "TARGET_COLUMN_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTargetColumnName() {
        return targetColumnName;
    }

    public void setTargetColumnName(String targetColumnName) {
        this.targetColumnName = targetColumnName;
    }

    @Basic
    @Column(name = "TARGET_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getTargetPeriod() {
        return targetPeriod;
    }

    public void setTargetPeriod(Integer targetPeriod) {
        this.targetPeriod = targetPeriod;
    }

    @Basic
    @Column(name = "TARGET_CELL_DATA_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTargetCellDataId() {
        return targetCellDataId;
    }

    public void setTargetCellDataId(String targetCellDataId) {
        this.targetCellDataId = targetCellDataId;
    }

    @Basic
    @Column(name = "TARGET_CELL_TEMPLATE_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTargetCellTemplateId() {
        return targetCellTemplateId;
    }

    public void setTargetCellTemplateId(String targetCellTemplateId) {
        this.targetCellTemplateId = targetCellTemplateId;
    }

    @Basic
    @Column(name = "RESULT_TYPE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getResultType() {
        return resultType;
    }

    public void setResultType(Integer resultType) {
        this.resultType = resultType;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        FormulaCache that = (FormulaCache) o;
        return period == that.period &&
                year == that.year &&
                Objects.equals(id, that.id) &&
                Objects.equals(formula, that.formula) &&
                Objects.equals(formulaValue, that.formulaValue) &&
                Objects.equals(targetReportTemplateId, that.targetReportTemplateId) &&
                Objects.equals(targetRowIndex, that.targetRowIndex) &&
                Objects.equals(targetRowName, that.targetRowName) &&
                Objects.equals(targetColumnIndex, that.targetColumnIndex) &&
                Objects.equals(targetColumnName, that.targetColumnName) &&
                Objects.equals(targetPeriod, that.targetPeriod) &&
                Objects.equals(targetCellDataId, that.targetCellDataId) &&
                Objects.equals(targetCellTemplateId, that.targetCellTemplateId) &&
                Objects.equals(resultType, that.resultType) &&
                Objects.equals(createTime, that.createTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, period, year, formula, formulaValue, targetReportTemplateId, targetRowIndex, targetRowName, targetColumnIndex, targetColumnName, targetPeriod, targetCellDataId, targetCellTemplateId, resultType, createTime);
    }
}
