package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "GOODS_MAPPING", schema = PROJECT_SCHEMA, catalog = "")
public class GoodsMapping {
    private String id;
    private String custGoodsName;
    private String stdGoodsName;
    private String creatorId;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CUST_GOODS_NAME", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCustGoodsName() {
        return custGoodsName;
    }

    public void setCustGoodsName(String custGoodsName) {
        this.custGoodsName = custGoodsName;
    }

    @Basic
    @Column(name = "STD_GOODS_NAME", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getStdGoodsName() {
        return stdGoodsName;
    }

    public void setStdGoodsName(String stdGoodsName) {
        this.stdGoodsName = stdGoodsName;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        GoodsMapping that = (GoodsMapping) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(custGoodsName, that.custGoodsName) &&
                Objects.equals(stdGoodsName, that.stdGoodsName) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, custGoodsName, stdGoodsName, creatorId, createTime, updateTime);
    }
}
