package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "IMPORT_FILE", schema = PROJECT_SCHEMA, catalog = "")
public class ImportFile {
    private String fileId;
    private String filePath;
    private String fileName;
    private Integer periodId;
    private String fileType;
    private String creatorId;
    private Date createTime;
    private Integer fileImportType;
    private String comments;

    @Id
    @Column(name = "FILE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFileId() {
        return fileId;
    }

    public void setFileId(String fileId) {
        this.fileId = fileId;
    }

    @Basic
    @Column(name = "FILE_PATH", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getFilePath() {
        return filePath;
    }

    public void setFilePath(String filePath) {
        this.filePath = filePath;
    }

    @Basic
    @Column(name = "FILE_NAME", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getFileName() {
        return fileName;
    }

    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "FILE_TYPE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFileType() {
        return fileType;
    }

    public void setFileType(String fileType) {
        this.fileType = fileType;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "FILE_IMPORT_TYPE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getFileImportType() {
        return fileImportType;
    }

    public void setFileImportType(Integer fileImportType) {
        this.fileImportType = fileImportType;
    }

    @Basic
    @Column(name = "COMMENTS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getComments() {
        return comments;
    }

    public void setComments(String comments) {
        this.comments = comments;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ImportFile that = (ImportFile) o;
        return Objects.equals(fileId, that.fileId) &&
                Objects.equals(filePath, that.filePath) &&
                Objects.equals(fileName, that.fileName) &&
                Objects.equals(periodId, that.periodId) &&
                Objects.equals(fileType, that.fileType) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(fileImportType, that.fileImportType) &&
                Objects.equals(comments, that.comments);
    }

    @Override
    public int hashCode() {
        return Objects.hash(fileId, filePath, fileName, periodId, fileType, creatorId, createTime, fileImportType, comments);
    }
}
