package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "INDEX_ANALYSIS_DETAIL_RESULT", schema = PROJECT_SCHEMA, catalog = "")
public class IndexAnalysisDetailResult {
    private String id;
    private String resultId;
    private Integer year;
    private Integer period;
    private String indexName;
    private Integer sequence;
    private Integer displayType;
    private Integer isVisible;
    private Integer isMainValue;
    private Integer isYearValue;
    private Integer isMonExp;
    private Integer isYearExp;
    private String indexResult;
    private String indexCode;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "RESULT_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getResultId() {
        return resultId;
    }

    public void setResultId(String resultId) {
        this.resultId = resultId;
    }

    @Basic
    @Column(name = "YEAR", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getYear() {
        return year;
    }

    public void setYear(Integer year) {
        this.year = year;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "INDEX_NAME", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndexName() {
        return indexName;
    }

    public void setIndexName(String indexName) {
        this.indexName = indexName;
    }

    @Basic
    @Column(name = "SEQUENCE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getSequence() {
        return sequence;
    }

    public void setSequence(Integer sequence) {
        this.sequence = sequence;
    }

    @Basic
    @Column(name = "DISPLAY_TYPE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDisplayType() {
        return displayType;
    }

    public void setDisplayType(Integer displayType) {
        this.displayType = displayType;
    }

    @Basic
    @Column(name = "IS_VISIBLE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsVisible() {
        return isVisible;
    }

    public void setIsVisible(Integer isVisible) {
        this.isVisible = isVisible;
    }

    @Basic
    @Column(name = "IS_MAIN_VALUE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsMainValue() {
        return isMainValue;
    }

    public void setIsMainValue(Integer isMainValue) {
        this.isMainValue = isMainValue;
    }

    @Basic
    @Column(name = "IS_YEAR_VALUE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsYearValue() {
        return isYearValue;
    }

    public void setIsYearValue(Integer isYearValue) {
        this.isYearValue = isYearValue;
    }

    @Basic
    @Column(name = "IS_MON_EXP", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsMonExp() {
        return isMonExp;
    }

    public void setIsMonExp(Integer isMonExp) {
        this.isMonExp = isMonExp;
    }

    @Basic
    @Column(name = "IS_YEAR_EXP", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsYearExp() {
        return isYearExp;
    }

    public void setIsYearExp(Integer isYearExp) {
        this.isYearExp = isYearExp;
    }

    @Basic
    @Column(name = "INDEX_RESULT", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndexResult() {
        return indexResult;
    }

    public void setIndexResult(String indexResult) {
        this.indexResult = indexResult;
    }

    @Basic
    @Column(name = "INDEX_CODE", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getIndexCode() {
        return indexCode;
    }

    public void setIndexCode(String indexCode) {
        this.indexCode = indexCode;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        IndexAnalysisDetailResult that = (IndexAnalysisDetailResult) o;
        return year == that.year &&
                period == that.period &&
                isVisible == that.isVisible &&
                isMainValue == that.isMainValue &&
                isYearValue == that.isYearValue &&
                isMonExp == that.isMonExp &&
                isYearExp == that.isYearExp &&
                Objects.equals(id, that.id) &&
                Objects.equals(resultId, that.resultId) &&
                Objects.equals(indexName, that.indexName) &&
                Objects.equals(sequence, that.sequence) &&
                Objects.equals(displayType, that.displayType) &&
                Objects.equals(indexResult, that.indexResult) &&
                Objects.equals(indexCode, that.indexCode) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, resultId, year, period, indexName, sequence, displayType, isVisible, isMainValue, isYearValue, isMonExp, isYearExp, indexResult, indexCode, createTime, updateTime);
    }
}
