package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "INDEX_ANALYSIS_RESULT", schema = PROJECT_SCHEMA, catalog = "")
public class IndexAnalysisResult {
    private String id;
    private String modelId;
    private String code;
    private String name;
    private String description;
    private String monthExplain;
    private String yearExplain;
    private String serviceTypeId;
    private String categoryId;
    private Integer type;
    private String indexCodeTotal;
    private Integer isShow;
    private Integer isReport;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "MODEL_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelId() {
        return modelId;
    }

    public void setModelId(String modelId) {
        this.modelId = modelId;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 20)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "DESCRIPTION", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Basic
    @Column(name = "MONTH_EXPLAIN", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMonthExplain() {
        return monthExplain;
    }

    public void setMonthExplain(String monthExplain) {
        this.monthExplain = monthExplain;
    }

    @Basic
    @Column(name = "YEAR_EXPLAIN", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getYearExplain() {
        return yearExplain;
    }

    public void setYearExplain(String yearExplain) {
        this.yearExplain = yearExplain;
    }

    @Basic
    @Column(name = "SERVICE_TYPE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getServiceTypeId() {
        return serviceTypeId;
    }

    public void setServiceTypeId(String serviceTypeId) {
        this.serviceTypeId = serviceTypeId;
    }

    @Basic
    @Column(name = "CATEGORY_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCategoryId() {
        return categoryId;
    }

    public void setCategoryId(String categoryId) {
        this.categoryId = categoryId;
    }

    @Basic
    @Column(name = "TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    @Basic
    @Column(name = "INDEX_CODE_TOTAL", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getIndexCodeTotal() {
        return indexCodeTotal;
    }

    public void setIndexCodeTotal(String indexCodeTotal) {
        this.indexCodeTotal = indexCodeTotal;
    }

    @Basic
    @Column(name = "IS_SHOW", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsShow() {
        return isShow;
    }

    public void setIsShow(Integer isShow) {
        this.isShow = isShow;
    }

    @Basic
    @Column(name = "IS_REPORT", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsReport() {
        return isReport;
    }

    public void setIsReport(Integer isReport) {
        this.isReport = isReport;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        IndexAnalysisResult that = (IndexAnalysisResult) o;
        return type == that.type &&
                isShow == that.isShow &&
                isReport == that.isReport &&
                Objects.equals(id, that.id) &&
                Objects.equals(modelId, that.modelId) &&
                Objects.equals(code, that.code) &&
                Objects.equals(name, that.name) &&
                Objects.equals(description, that.description) &&
                Objects.equals(monthExplain, that.monthExplain) &&
                Objects.equals(yearExplain, that.yearExplain) &&
                Objects.equals(serviceTypeId, that.serviceTypeId) &&
                Objects.equals(categoryId, that.categoryId) &&
                Objects.equals(indexCodeTotal, that.indexCodeTotal) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, modelId, code, name, description, monthExplain, yearExplain, serviceTypeId, categoryId, type, indexCodeTotal, isShow, isReport, createTime, updateTime);
    }
}
