package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "INPUT_VAT_INVOICE", schema = PROJECT_SCHEMA, catalog = "")
public class InputVatInvoice {
    private String id;
    private Integer periodId;
    private String invoiceCode;
    private String invoiceNumber;
    private Date invoiceDate;
    private String sellerTaxNumber;
    private BigDecimal amount;
    private BigDecimal taxAmount;
    private Integer invoiceType;
    private String certificationResult;
    private Date certificationDate;
    private String creatorId;
    private Date createTime;
    private Integer status;
    private Integer partAccntedPeriod;
    private Integer accntedPeriod;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "INVOICE_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceCode() {
        return invoiceCode;
    }

    public void setInvoiceCode(String invoiceCode) {
        this.invoiceCode = invoiceCode;
    }

    @Basic
    @Column(name = "INVOICE_NUMBER", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceNumber() {
        return invoiceNumber;
    }

    public void setInvoiceNumber(String invoiceNumber) {
        this.invoiceNumber = invoiceNumber;
    }

    @Basic
    @Column(name = "INVOICE_DATE", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getInvoiceDate() {
        return invoiceDate;
    }

    public void setInvoiceDate(Date invoiceDate) {
        this.invoiceDate = invoiceDate;
    }

    @Basic
    @Column(name = "SELLER_TAX_NUMBER", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSellerTaxNumber() {
        return sellerTaxNumber;
    }

    public void setSellerTaxNumber(String sellerTaxNumber) {
        this.sellerTaxNumber = sellerTaxNumber;
    }

    @Basic
    @Column(name = "AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    @Basic
    @Column(name = "TAX_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxAmount() {
        return taxAmount;
    }

    public void setTaxAmount(BigDecimal taxAmount) {
        this.taxAmount = taxAmount;
    }

    @Basic
    @Column(name = "INVOICE_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getInvoiceType() {
        return invoiceType;
    }

    public void setInvoiceType(Integer invoiceType) {
        this.invoiceType = invoiceType;
    }

    @Basic
    @Column(name = "CERTIFICATION_RESULT", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCertificationResult() {
        return certificationResult;
    }

    public void setCertificationResult(String certificationResult) {
        this.certificationResult = certificationResult;
    }

    @Basic
    @Column(name = "CERTIFICATION_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCertificationDate() {
        return certificationDate;
    }

    public void setCertificationDate(Date certificationDate) {
        this.certificationDate = certificationDate;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "STATUS", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Basic
    @Column(name = "PART_ACCNTED_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPartAccntedPeriod() {
        return partAccntedPeriod;
    }

    public void setPartAccntedPeriod(Integer partAccntedPeriod) {
        this.partAccntedPeriod = partAccntedPeriod;
    }

    @Basic
    @Column(name = "ACCNTED_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAccntedPeriod() {
        return accntedPeriod;
    }

    public void setAccntedPeriod(Integer accntedPeriod) {
        this.accntedPeriod = accntedPeriod;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        InputVatInvoice that = (InputVatInvoice) o;
        return periodId == that.periodId &&
                invoiceType == that.invoiceType &&
                Objects.equals(id, that.id) &&
                Objects.equals(invoiceCode, that.invoiceCode) &&
                Objects.equals(invoiceNumber, that.invoiceNumber) &&
                Objects.equals(invoiceDate, that.invoiceDate) &&
                Objects.equals(sellerTaxNumber, that.sellerTaxNumber) &&
                Objects.equals(amount, that.amount) &&
                Objects.equals(taxAmount, that.taxAmount) &&
                Objects.equals(certificationResult, that.certificationResult) &&
                Objects.equals(certificationDate, that.certificationDate) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(status, that.status) &&
                Objects.equals(partAccntedPeriod, that.partAccntedPeriod) &&
                Objects.equals(accntedPeriod, that.accntedPeriod);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, periodId, invoiceCode, invoiceNumber, invoiceDate, sellerTaxNumber, amount, taxAmount, invoiceType, certificationResult, certificationDate, creatorId, createTime, status, partAccntedPeriod, accntedPeriod);
    }
}
