package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "INPUT_VAT_INVOICE_ITEM", schema = PROJECT_SCHEMA, catalog = "")
public class InputVatInvoiceItem {
    private String id;
    private String inputVatInvoiceId;
    private Integer periodId;
    private String invoiceCode;
    private String invoiceNumber;
    private BigDecimal amount;
    private BigDecimal taxAmount;
    private BigDecimal taxRate;
    private String productionName;
    private String creatorId;
    private Date createTime;
    private String productionCode;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "INPUT_V_A_T_INVOICE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInputVatInvoiceId() {
        return inputVatInvoiceId;
    }

    public void setInputVatInvoiceId(String inputVatInvoiceId) {
        this.inputVatInvoiceId = inputVatInvoiceId;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "INVOICE_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceCode() {
        return invoiceCode;
    }

    public void setInvoiceCode(String invoiceCode) {
        this.invoiceCode = invoiceCode;
    }

    @Basic
    @Column(name = "INVOICE_NUMBER", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceNumber() {
        return invoiceNumber;
    }

    public void setInvoiceNumber(String invoiceNumber) {
        this.invoiceNumber = invoiceNumber;
    }

    @Basic
    @Column(name = "AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    @Basic
    @Column(name = "TAX_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxAmount() {
        return taxAmount;
    }

    public void setTaxAmount(BigDecimal taxAmount) {
        this.taxAmount = taxAmount;
    }

    @Basic
    @Column(name = "TAX_RATE", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxRate() {
        return taxRate;
    }

    public void setTaxRate(BigDecimal taxRate) {
        this.taxRate = taxRate;
    }

    @Basic
    @Column(name = "PRODUCTION_NAME", nullable = false, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getProductionName() {
        return productionName;
    }

    public void setProductionName(String productionName) {
        this.productionName = productionName;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "PRODUCTION_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getProductionCode() {
        return productionCode;
    }

    public void setProductionCode(String productionCode) {
        this.productionCode = productionCode;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        InputVatInvoiceItem that = (InputVatInvoiceItem) o;
        return periodId == that.periodId &&
                Objects.equals(id, that.id) &&
                Objects.equals(inputVatInvoiceId, that.inputVatInvoiceId) &&
                Objects.equals(invoiceCode, that.invoiceCode) &&
                Objects.equals(invoiceNumber, that.invoiceNumber) &&
                Objects.equals(amount, that.amount) &&
                Objects.equals(taxAmount, that.taxAmount) &&
                Objects.equals(taxRate, that.taxRate) &&
                Objects.equals(productionName, that.productionName) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(productionCode, that.productionCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, inputVatInvoiceId, periodId, invoiceCode, invoiceNumber, amount, taxAmount, taxRate, productionName, creatorId, createTime, productionCode);
    }
}
