package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "MODEL_BACK_FILL_AMOUNT", schema = PROJECT_SCHEMA, catalog = "")
public class ModelBackFillAmount {
    private String id;
    private String dataSourceId;
    private String entriesCheckResultId;
    private BigDecimal amount;
    private String cellDataId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "DATA_SOURCE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDataSourceId() {
        return dataSourceId;
    }

    public void setDataSourceId(String dataSourceId) {
        this.dataSourceId = dataSourceId;
    }

    @Basic
    @Column(name = "ENTRIES_CHECK_RESULT_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEntriesCheckResultId() {
        return entriesCheckResultId;
    }

    public void setEntriesCheckResultId(String entriesCheckResultId) {
        this.entriesCheckResultId = entriesCheckResultId;
    }

    @Basic
    @Column(name = "AMOUNT", nullable = false, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    @Basic
    @Column(name = "CELL_DATA_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCellDataId() {
        return cellDataId;
    }

    public void setCellDataId(String cellDataId) {
        this.cellDataId = cellDataId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ModelBackFillAmount that = (ModelBackFillAmount) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(dataSourceId, that.dataSourceId) &&
                Objects.equals(entriesCheckResultId, that.entriesCheckResultId) &&
                Objects.equals(amount, that.amount) &&
                Objects.equals(cellDataId, that.cellDataId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, dataSourceId, entriesCheckResultId, amount, cellDataId);
    }
}
