package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "MODEL_DETAIL_LOG", schema = PROJECT_SCHEMA, catalog = "")
public class ModelDetailLog {
    private String id;
    private String modelLogId;
    private Integer feature;
    private String modelId;
    private String code;
    private String name;
    private String description;
    private Integer runningResult;
    private Integer period;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "MODEL_LOG_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelLogId() {
        return modelLogId;
    }

    public void setModelLogId(String modelLogId) {
        this.modelLogId = modelLogId;
    }

    @Basic
    @Column(name = "FEATURE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getFeature() {
        return feature;
    }

    public void setFeature(Integer feature) {
        this.feature = feature;
    }

    @Basic
    @Column(name = "MODEL_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelId() {
        return modelId;
    }

    public void setModelId(String modelId) {
        this.modelId = modelId;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 20)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "DESCRIPTION", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Basic
    @Column(name = "RUNNING_RESULT", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getRunningResult() {
        return runningResult;
    }

    public void setRunningResult(Integer runningResult) {
        this.runningResult = runningResult;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ModelDetailLog that = (ModelDetailLog) o;
        return feature == that.feature &&
                runningResult == that.runningResult &&
                period == that.period &&
                Objects.equals(id, that.id) &&
                Objects.equals(modelLogId, that.modelLogId) &&
                Objects.equals(modelId, that.modelId) &&
                Objects.equals(code, that.code) &&
                Objects.equals(name, that.name) &&
                Objects.equals(description, that.description) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, modelLogId, feature, modelId, code, name, description, runningResult, period, createTime, updateTime);
    }
}
