package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "MODEL_LOG", schema = PROJECT_SCHEMA, catalog = "")
public class ModelLog {
    private String id;
    private String organizationId;
    private Integer runNumber;
    private String description;
    private Integer successNumber;
    private Integer failureNumber;
    private String serviceTypeId;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "RUN_NUMBER", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getRunNumber() {
        return runNumber;
    }

    public void setRunNumber(Integer runNumber) {
        this.runNumber = runNumber;
    }

    @Basic
    @Column(name = "DESCRIPTION", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Basic
    @Column(name = "SUCCESS_NUMBER", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getSuccessNumber() {
        return successNumber;
    }

    public void setSuccessNumber(Integer successNumber) {
        this.successNumber = successNumber;
    }

    @Basic
    @Column(name = "FAILURE_NUMBER", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getFailureNumber() {
        return failureNumber;
    }

    public void setFailureNumber(Integer failureNumber) {
        this.failureNumber = failureNumber;
    }

    @Basic
    @Column(name = "SERVICE_TYPE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getServiceTypeId() {
        return serviceTypeId;
    }

    public void setServiceTypeId(String serviceTypeId) {
        this.serviceTypeId = serviceTypeId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ModelLog modelLog = (ModelLog) o;
        return runNumber == modelLog.runNumber &&
                successNumber == modelLog.successNumber &&
                failureNumber == modelLog.failureNumber &&
                Objects.equals(id, modelLog.id) &&
                Objects.equals(organizationId, modelLog.organizationId) &&
                Objects.equals(description, modelLog.description) &&
                Objects.equals(serviceTypeId, modelLog.serviceTypeId) &&
                Objects.equals(createTime, modelLog.createTime) &&
                Objects.equals(updateTime, modelLog.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, organizationId, runNumber, description, successNumber, failureNumber, serviceTypeId, createTime, updateTime);
    }
}
