package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "MODIFIED_REPORT_CELL", schema = PROJECT_SCHEMA, catalog = "")
public class ModifiedReportCell {
    private Long id;
    private Long reportId;
    private Integer row;
    private Integer col;
    private String originalValue;
    private String value;
    private Long relatedCellDataId;
    private String comment;
    private Date createTime;
    private Date updateTime;
    private String createBy;
    private String updateBy;

    @Id
    @Column(name = "ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "REPORT_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getReportId() {
        return reportId;
    }

    public void setReportId(Long reportId) {
        this.reportId = reportId;
    }

    @Basic
    @Column(name = B_Delimiter + "ROW" + E_Delimiter, nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getRow() {
        return row;
    }

    public void setRow(Integer row) {
        this.row = row;
    }

    @Basic
    @Column(name = "COL", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getCol() {
        return col;
    }

    public void setCol(Integer col) {
        this.col = col;
    }

    @Basic
    @Column(name = "ORIGINAL_VALUE", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOriginalValue() {
        return originalValue;
    }

    public void setOriginalValue(String originalValue) {
        this.originalValue = originalValue;
    }

    @Basic
    @Column(name = "VALUE", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @Basic
    @Column(name = "RELATED_CELL_DATA_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getRelatedCellDataId() {
        return relatedCellDataId;
    }

    public void setRelatedCellDataId(Long relatedCellDataId) {
        this.relatedCellDataId = relatedCellDataId;
    }

    @Basic
    @Column(name = B_Delimiter + "COMMENT" + E_Delimiter, nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ModifiedReportCell that = (ModifiedReportCell) o;
        return id == that.id &&
                reportId == that.reportId &&
                row == that.row &&
                col == that.col &&
                relatedCellDataId == that.relatedCellDataId &&
                Objects.equals(originalValue, that.originalValue) &&
                Objects.equals(value, that.value) &&
                Objects.equals(comment, that.comment) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(createBy, that.createBy) &&
                Objects.equals(updateBy, that.updateBy);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, reportId, row, col, originalValue, value, relatedCellDataId, comment, createTime, updateTime, createBy, updateBy);
    }
}
