package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OPERATION_LOG", schema = PROJECT_SCHEMA, catalog = "")
public class OperationLog {
    private String id;
    private String operationName;
    private Integer moduleId;
    private String operationObject;
    private Integer operationType;
    private String operationContent;
    private String originalState;
    private String updateState;
    private String creatorId;
    private String comment;
    private Date createTime;
    private Date updateTime;
    private String ip;
    private Integer period;
    private Integer serviceType;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "OPERATION_NAME", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOperationName() {
        return operationName;
    }

    public void setOperationName(String operationName) {
        this.operationName = operationName;
    }

    @Basic
    @Column(name = "MODULE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getModuleId() {
        return moduleId;
    }

    public void setModuleId(Integer moduleId) {
        this.moduleId = moduleId;
    }

    @Basic
    @Column(name = "OPERATION_OBJECT", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getOperationObject() {
        return operationObject;
    }

    public void setOperationObject(String operationObject) {
        this.operationObject = operationObject;
    }

    @Basic
    @Column(name = "OPERATION_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getOperationType() {
        return operationType;
    }

    public void setOperationType(Integer operationType) {
        this.operationType = operationType;
    }

    @Basic
    @Column(name = "OPERATION_CONTENT", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getOperationContent() {
        return operationContent;
    }

    public void setOperationContent(String operationContent) {
        this.operationContent = operationContent;
    }

    @Basic
    @Column(name = "ORIGINAL_STATE", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getOriginalState() {
        return originalState;
    }

    public void setOriginalState(String originalState) {
        this.originalState = originalState;
    }

    @Basic
    @Column(name = "UPDATE_STATE", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getUpdateState() {
        return updateState;
    }

    public void setUpdateState(String updateState) {
        this.updateState = updateState;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = B_Delimiter + "COMMENT" + E_Delimiter, nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "IP", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    @Basic
    @Column(name = "PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "SERVICE_TYPE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getServiceType() {
        return serviceType;
    }

    public void setServiceType(Integer serviceType) {
        this.serviceType = serviceType;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OperationLog that = (OperationLog) o;
        return moduleId == that.moduleId &&
                operationType == that.operationType &&
                Objects.equals(id, that.id) &&
                Objects.equals(operationName, that.operationName) &&
                Objects.equals(operationObject, that.operationObject) &&
                Objects.equals(operationContent, that.operationContent) &&
                Objects.equals(originalState, that.originalState) &&
                Objects.equals(updateState, that.updateState) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(comment, that.comment) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(ip, that.ip) &&
                Objects.equals(period, that.period) &&
                Objects.equals(serviceType, that.serviceType);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, operationName, moduleId, operationObject, operationType, operationContent, originalState, updateState, creatorId, comment, createTime, updateTime, ip, period, serviceType);
    }
}
