package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_VAT_INVOICE", schema = PROJECT_SCHEMA, catalog = "")
public class OutputVatInvoice {
    private String invoiceId;
    private Integer invoiceType;
    private String classCode;
    private String invoiceNumber;
    private String buyerName;
    private String buyerTaxNumber;
    private String bankAccount;
    private String phoneNum;
    private Date invoiceDate;
    private Integer seqNo;
    private Integer periodId;
    private Integer status;
    private String creatorId;
    private Date createTime;
    private Integer partAccntedPeriod;
    private Integer accntedPeriod;

    @Id
    @Column(name = "INVOICE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceId() {
        return invoiceId;
    }

    public void setInvoiceId(String invoiceId) {
        this.invoiceId = invoiceId;
    }

    @Basic
    @Column(name = "INVOICE_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getInvoiceType() {
        return invoiceType;
    }

    public void setInvoiceType(Integer invoiceType) {
        this.invoiceType = invoiceType;
    }

    @Basic
    @Column(name = "CLASS_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getClassCode() {
        return classCode;
    }

    public void setClassCode(String classCode) {
        this.classCode = classCode;
    }

    @Basic
    @Column(name = "INVOICE_NUMBER", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceNumber() {
        return invoiceNumber;
    }

    public void setInvoiceNumber(String invoiceNumber) {
        this.invoiceNumber = invoiceNumber;
    }

    @Basic
    @Column(name = "BUYER_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBuyerName() {
        return buyerName;
    }

    public void setBuyerName(String buyerName) {
        this.buyerName = buyerName;
    }

    @Basic
    @Column(name = "BUYER_TAX_NUMBER", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBuyerTaxNumber() {
        return buyerTaxNumber;
    }

    public void setBuyerTaxNumber(String buyerTaxNumber) {
        this.buyerTaxNumber = buyerTaxNumber;
    }

    @Basic
    @Column(name = "BANK_ACCOUNT", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBankAccount() {
        return bankAccount;
    }

    public void setBankAccount(String bankAccount) {
        this.bankAccount = bankAccount;
    }

    @Basic
    @Column(name = "PHONE_NUM", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPhoneNum() {
        return phoneNum;
    }

    public void setPhoneNum(String phoneNum) {
        this.phoneNum = phoneNum;
    }

    @Basic
    @Column(name = "INVOICE_DATE", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getInvoiceDate() {
        return invoiceDate;
    }

    public void setInvoiceDate(Date invoiceDate) {
        this.invoiceDate = invoiceDate;
    }

    @Basic
    @Column(name = "SEQ_NO", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getSeqNo() {
        return seqNo;
    }

    public void setSeqNo(Integer seqNo) {
        this.seqNo = seqNo;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "STATUS", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "PART_ACCNTED_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPartAccntedPeriod() {
        return partAccntedPeriod;
    }

    public void setPartAccntedPeriod(Integer partAccntedPeriod) {
        this.partAccntedPeriod = partAccntedPeriod;
    }

    @Basic
    @Column(name = "ACCNTED_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAccntedPeriod() {
        return accntedPeriod;
    }

    public void setAccntedPeriod(Integer accntedPeriod) {
        this.accntedPeriod = accntedPeriod;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputVatInvoice that = (OutputVatInvoice) o;
        return invoiceType == that.invoiceType &&
                seqNo == that.seqNo &&
                periodId == that.periodId &&
                Objects.equals(invoiceId, that.invoiceId) &&
                Objects.equals(classCode, that.classCode) &&
                Objects.equals(invoiceNumber, that.invoiceNumber) &&
                Objects.equals(buyerName, that.buyerName) &&
                Objects.equals(buyerTaxNumber, that.buyerTaxNumber) &&
                Objects.equals(bankAccount, that.bankAccount) &&
                Objects.equals(phoneNum, that.phoneNum) &&
                Objects.equals(invoiceDate, that.invoiceDate) &&
                Objects.equals(status, that.status) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(partAccntedPeriod, that.partAccntedPeriod) &&
                Objects.equals(accntedPeriod, that.accntedPeriod);
    }

    @Override
    public int hashCode() {
        return Objects.hash(invoiceId, invoiceType, classCode, invoiceNumber, buyerName, buyerTaxNumber, bankAccount, phoneNum, invoiceDate, seqNo, periodId, status, creatorId, createTime, partAccntedPeriod, accntedPeriod);
    }
}
