package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_VAT_INVOICE_ITEM", schema = PROJECT_SCHEMA, catalog = "")
public class OutputVatInvoiceItem {
    private String itemId;
    private String invoiceId;
    private String codeVersion;
    private String productName;
    private String documentNum;
    private String productStandard;
    private String unit;
    private Integer quantity;
    private Double unitPrice;
    private BigDecimal amount;
    private BigDecimal taxRate;
    private BigDecimal taxAmount;
    private Integer seqNo;
    private String taxClassCode;
    private String creatorId;
    private Date createTime;
    private Integer periodId;

    @Id
    @Column(name = "ITEM_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    @Basic
    @Column(name = "INVOICE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceId() {
        return invoiceId;
    }

    public void setInvoiceId(String invoiceId) {
        this.invoiceId = invoiceId;
    }

    @Basic
    @Column(name = "CODE_VERSION", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCodeVersion() {
        return codeVersion;
    }

    public void setCodeVersion(String codeVersion) {
        this.codeVersion = codeVersion;
    }

    @Basic
    @Column(name = "PRODUCT_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getProductName() {
        return productName;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    @Basic
    @Column(name = "DOCUMENT_NUM", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDocumentNum() {
        return documentNum;
    }

    public void setDocumentNum(String documentNum) {
        this.documentNum = documentNum;
    }

    @Basic
    @Column(name = "PRODUCT_STANDARD", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getProductStandard() {
        return productStandard;
    }

    public void setProductStandard(String productStandard) {
        this.productStandard = productStandard;
    }

    @Basic
    @Column(name = "UNIT", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    @Basic
    @Column(name = "QUANTITY", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getQuantity() {
        return quantity;
    }

    public void setQuantity(Integer quantity) {
        this.quantity = quantity;
    }

    @Basic
    @Column(name = "UNIT_PRICE", nullable = true, precision = 0)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public Double getUnitPrice() {
        return unitPrice;
    }

    public void setUnitPrice(Double unitPrice) {
        this.unitPrice = unitPrice;
    }

    @Basic
    @Column(name = "AMOUNT", nullable = false, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    @Basic
    @Column(name = "TAX_RATE", nullable = false, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxRate() {
        return taxRate;
    }

    public void setTaxRate(BigDecimal taxRate) {
        this.taxRate = taxRate;
    }

    @Basic
    @Column(name = "TAX_AMOUNT", nullable = false, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxAmount() {
        return taxAmount;
    }

    public void setTaxAmount(BigDecimal taxAmount) {
        this.taxAmount = taxAmount;
    }

    @Basic
    @Column(name = "SEQ_NO", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getSeqNo() {
        return seqNo;
    }

    public void setSeqNo(Integer seqNo) {
        this.seqNo = seqNo;
    }

    @Basic
    @Column(name = "TAX_CLASS_CODE", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxClassCode() {
        return taxClassCode;
    }

    public void setTaxClassCode(String taxClassCode) {
        this.taxClassCode = taxClassCode;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputVatInvoiceItem that = (OutputVatInvoiceItem) o;
        return seqNo == that.seqNo &&
                periodId == that.periodId &&
                Objects.equals(itemId, that.itemId) &&
                Objects.equals(invoiceId, that.invoiceId) &&
                Objects.equals(codeVersion, that.codeVersion) &&
                Objects.equals(productName, that.productName) &&
                Objects.equals(documentNum, that.documentNum) &&
                Objects.equals(productStandard, that.productStandard) &&
                Objects.equals(unit, that.unit) &&
                Objects.equals(quantity, that.quantity) &&
                Objects.equals(unitPrice, that.unitPrice) &&
                Objects.equals(amount, that.amount) &&
                Objects.equals(taxRate, that.taxRate) &&
                Objects.equals(taxAmount, that.taxAmount) &&
                Objects.equals(taxClassCode, that.taxClassCode) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(itemId, invoiceId, codeVersion, productName, documentNum, productStandard, unit, quantity, unitPrice, amount, taxRate, taxAmount, seqNo, taxClassCode, creatorId, createTime, periodId);
    }
}
