package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "PERIOD_CELL_REFERENCE", schema = PROJECT_SCHEMA, catalog = "")
@IdClass(PeriodCellReferencePK.class)
public class PeriodCellReference {
    private String id;
    private Integer period;
    private Integer formulaBlockIndex;
    private String referenceFromCellId;
    private String referenceFromTemplateId;
    private String referenceToCellId;
    private String referenceToTemplateId;
    private String referenceFromKeyValueId;
    private String referenceToKeyValueId;
    private Integer isValidation;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Id
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "FORMULA_BLOCK_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getFormulaBlockIndex() {
        return formulaBlockIndex;
    }

    public void setFormulaBlockIndex(Integer formulaBlockIndex) {
        this.formulaBlockIndex = formulaBlockIndex;
    }

    @Basic
    @Column(name = "REFERENCE_FROM_CELL_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getReferenceFromCellId() {
        return referenceFromCellId;
    }

    public void setReferenceFromCellId(String referenceFromCellId) {
        this.referenceFromCellId = referenceFromCellId;
    }

    @Basic
    @Column(name = "REFERENCE_FROM_TEMPLATE_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getReferenceFromTemplateId() {
        return referenceFromTemplateId;
    }

    public void setReferenceFromTemplateId(String referenceFromTemplateId) {
        this.referenceFromTemplateId = referenceFromTemplateId;
    }

    @Basic
    @Column(name = "REFERENCE_TO_CELL_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getReferenceToCellId() {
        return referenceToCellId;
    }

    public void setReferenceToCellId(String referenceToCellId) {
        this.referenceToCellId = referenceToCellId;
    }

    @Basic
    @Column(name = "REFERENCE_TO_TEMPLATE_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getReferenceToTemplateId() {
        return referenceToTemplateId;
    }

    public void setReferenceToTemplateId(String referenceToTemplateId) {
        this.referenceToTemplateId = referenceToTemplateId;
    }

    @Basic
    @Column(name = "REFERENCE_FROM_KEY_VALUE_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getReferenceFromKeyValueId() {
        return referenceFromKeyValueId;
    }

    public void setReferenceFromKeyValueId(String referenceFromKeyValueId) {
        this.referenceFromKeyValueId = referenceFromKeyValueId;
    }

    @Basic
    @Column(name = "REFERENCE_TO_KEY_VALUE_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getReferenceToKeyValueId() {
        return referenceToKeyValueId;
    }

    public void setReferenceToKeyValueId(String referenceToKeyValueId) {
        this.referenceToKeyValueId = referenceToKeyValueId;
    }

    @Basic
    @Column(name = "IS_VALIDATION", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsValidation() {
        return isValidation;
    }

    public void setIsValidation(Integer isValidation) {
        this.isValidation = isValidation;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        PeriodCellReference that = (PeriodCellReference) o;
        return period == that.period &&
                formulaBlockIndex == that.formulaBlockIndex &&
                isValidation == that.isValidation &&
                Objects.equals(id, that.id) &&
                Objects.equals(referenceFromCellId, that.referenceFromCellId) &&
                Objects.equals(referenceFromTemplateId, that.referenceFromTemplateId) &&
                Objects.equals(referenceToCellId, that.referenceToCellId) &&
                Objects.equals(referenceToTemplateId, that.referenceToTemplateId) &&
                Objects.equals(referenceFromKeyValueId, that.referenceFromKeyValueId) &&
                Objects.equals(referenceToKeyValueId, that.referenceToKeyValueId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, period, formulaBlockIndex, referenceFromCellId, referenceFromTemplateId, referenceToCellId, referenceToTemplateId, referenceFromKeyValueId, referenceToKeyValueId, isValidation);
    }
}
