package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "PERIOD_FORMULA_BLOCK", schema = PROJECT_SCHEMA, catalog = "")
public class PeriodFormulaBlock {
    private Long id;
    private Integer period;
    private Long reportId;
    private Long cellTemplateId;
    private String formulaExpression;
    private String data;
    private Long dataSourceId;
    private String createBy;
    private Date createTime;
    private String updateBy;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "REPORT_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getReportId() {
        return reportId;
    }

    public void setReportId(Long reportId) {
        this.reportId = reportId;
    }

    @Basic
    @Column(name = "CELL_TEMPLATE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getCellTemplateId() {
        return cellTemplateId;
    }

    public void setCellTemplateId(Long cellTemplateId) {
        this.cellTemplateId = cellTemplateId;
    }

    @Basic
    @Column(name = "FORMULA_EXPRESSION", nullable = false, length = 1000)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFormulaExpression() {
        return formulaExpression;
    }

    public void setFormulaExpression(String formulaExpression) {
        this.formulaExpression = formulaExpression;
    }

    @Basic
    @Column(name = "DATA", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getData() {
        return data;
    }

    public void setData(String data) {
        this.data = data;
    }

    @Basic
    @Column(name = "DATA_SOURCE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getDataSourceId() {
        return dataSourceId;
    }

    public void setDataSourceId(Long dataSourceId) {
        this.dataSourceId = dataSourceId;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        PeriodFormulaBlock that = (PeriodFormulaBlock) o;
        return id == that.id &&
                period == that.period &&
                reportId == that.reportId &&
                cellTemplateId == that.cellTemplateId &&
                dataSourceId == that.dataSourceId &&
                Objects.equals(formulaExpression, that.formulaExpression) &&
                Objects.equals(data, that.data) &&
                Objects.equals(createBy, that.createBy) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateBy, that.updateBy) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, period, reportId, cellTemplateId, formulaExpression, data, dataSourceId, createBy, createTime, updateBy, updateTime);
    }
}
