package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "PERIOD_TAX_PAYER_REPORT_RULE", schema = PROJECT_SCHEMA, catalog = "")
public class PeriodTaxPayerReportRule {
    private Long id;
    private Integer isDefault;
    private Integer period;
    private Integer taxPayerType;
    private Long templateGroupId;
    private String organizationId;
    private Date createTime;
    private Date updateTime;
    private Long taxPayerReportRuleId;
    private String createBy;
    private String updateBy;

    @Id
    @Column(name = "ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "IS_DEFAULT", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsDefault() {
        return isDefault;
    }

    public void setIsDefault(Integer isDefault) {
        this.isDefault = isDefault;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "TAX_PAYER_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getTaxPayerType() {
        return taxPayerType;
    }

    public void setTaxPayerType(Integer taxPayerType) {
        this.taxPayerType = taxPayerType;
    }

    @Basic
    @Column(name = "TEMPLATE_GROUP_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getTemplateGroupId() {
        return templateGroupId;
    }

    public void setTemplateGroupId(Long templateGroupId) {
        this.templateGroupId = templateGroupId;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "TAX_PAYER_REPORT_RULE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getTaxPayerReportRuleId() {
        return taxPayerReportRuleId;
    }

    public void setTaxPayerReportRuleId(Long taxPayerReportRuleId) {
        this.taxPayerReportRuleId = taxPayerReportRuleId;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        PeriodTaxPayerReportRule that = (PeriodTaxPayerReportRule) o;
        return id == that.id &&
                isDefault == that.isDefault &&
                period == that.period &&
                taxPayerType == that.taxPayerType &&
                templateGroupId == that.templateGroupId &&
                taxPayerReportRuleId == that.taxPayerReportRuleId &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(createBy, that.createBy) &&
                Objects.equals(updateBy, that.updateBy);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, isDefault, period, taxPayerType, templateGroupId, organizationId, createTime, updateTime, taxPayerReportRuleId, createBy, updateBy);
    }
}
