package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "VALIDATION_INFO", schema = PROJECT_SCHEMA, catalog = "")
public class ValidationInfo {
    private String id;
    private Integer importTypeId;
    private String validationResult;
    private String validationDetails;
    private String validationTips;
    private Integer number;
    private String creatorId;
    private Date createTime;
    private Integer periodId;
    private Integer erpCheckTypeId;
    private Integer errorLevel;
    private Boolean isShowDetail;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "IMPORT_TYPE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getImportTypeId() {
        return importTypeId;
    }

    public void setImportTypeId(Integer importTypeId) {
        this.importTypeId = importTypeId;
    }

    @Basic
    @Column(name = "VALIDATION_RESULT", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getValidationResult() {
        return validationResult;
    }

    public void setValidationResult(String validationResult) {
        this.validationResult = validationResult;
    }

    @Basic
    @Column(name = "VALIDATION_DETAILS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getValidationDetails() {
        return validationDetails;
    }

    public void setValidationDetails(String validationDetails) {
        this.validationDetails = validationDetails;
    }

    @Basic
    @Column(name = "VALIDATION_TIPS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getValidationTips() {
        return validationTips;
    }

    public void setValidationTips(String validationTips) {
        this.validationTips = validationTips;
    }

    @Basic
    @Column(name = B_Delimiter + "NUMBER" + E_Delimiter, nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getNumber() {
        return number;
    }

    public void setNumber(Integer number) {
        this.number = number;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "ERP_CHECK_TYPE_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getErpCheckTypeId() {
        return erpCheckTypeId;
    }

    public void setErpCheckTypeId(Integer erpCheckTypeId) {
        this.erpCheckTypeId = erpCheckTypeId;
    }

    @Basic
    @Column(name = "ERROR_LEVEL", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getErrorLevel() {
        return errorLevel;
    }

    public void setErrorLevel(Integer errorLevel) {
        this.errorLevel = errorLevel;
    }

    @Basic
    @Column(name = "IS_SHOW_DETAIL", nullable = true)
    public Boolean getIsShowDetail() {
        return isShowDetail;
    }

    public void setIsShowDetail(Boolean isShowDetail) {
        this.isShowDetail = isShowDetail;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ValidationInfo that = (ValidationInfo) o;
        return importTypeId == that.importTypeId &&
                Objects.equals(id, that.id) &&
                Objects.equals(validationResult, that.validationResult) &&
                Objects.equals(validationDetails, that.validationDetails) &&
                Objects.equals(validationTips, that.validationTips) &&
                Objects.equals(number, that.number) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(periodId, that.periodId) &&
                Objects.equals(erpCheckTypeId, that.erpCheckTypeId) &&
                Objects.equals(errorLevel, that.errorLevel) &&
                Objects.equals(isShowDetail, that.isShowDetail);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, importTypeId, validationResult, validationDetails, validationTips, number, creatorId, createTime, periodId, erpCheckTypeId, errorLevel, isShowDetail);
    }
}
