package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "VOUCHER", schema = PROJECT_SCHEMA, catalog = "")
public class Voucher {
    private String voucherId;
    private String vid;
    private Date date;
    private String group;
    private Integer period;
    private String customerCode;
    private String customerName;
    private String summary;
    private String acctCode;
    private BigDecimal debit;
    private BigDecimal credit;
    private Long attach;
    private String itemId;
    private Date createTime;
    private Integer importType;
    private String creatorId;
    private Integer monthId;
    private Integer originalPeriod;
    private Integer status;
    private Integer partBilledPeriod;
    private Integer billedPeriod;
    private String stdCode;
    private String mappingReason;
    private String mappingUser;
    private Date mappingTime;
    private String remapId;

    @Id
    @Column(name = "VOUCHER_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVoucherId() {
        return voucherId;
    }

    public void setVoucherId(String voucherId) {
        this.voucherId = voucherId;
    }

    @Basic
    @Column(name = "VID", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getVid() {
        return vid;
    }

    public void setVid(String vid) {
        this.vid = vid;
    }

    @Basic
    @Column(name = B_Delimiter + "DATE" + E_Delimiter, nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    @Basic
    @Column(name = B_Delimiter + "GROUP" + E_Delimiter, nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGroup() {
        return group;
    }

    public void setGroup(String group) {
        this.group = group;
    }

    @Basic
    @Column(name = "PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "CUSTOMER_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCustomerCode() {
        return customerCode;
    }

    public void setCustomerCode(String customerCode) {
        this.customerCode = customerCode;
    }

    @Basic
    @Column(name = "CUSTOMER_NAME", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCustomerName() {
        return customerName;
    }

    public void setCustomerName(String customerName) {
        this.customerName = customerName;
    }

    @Basic
    @Column(name = "SUMMARY", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getSummary() {
        return summary;
    }

    public void setSummary(String summary) {
        this.summary = summary;
    }

    @Basic
    @Column(name = "ACCT_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAcctCode() {
        return acctCode;
    }

    public void setAcctCode(String acctCode) {
        this.acctCode = acctCode;
    }

    @Basic
    @Column(name = "DEBIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getDebit() {
        return debit;
    }

    public void setDebit(BigDecimal debit) {
        this.debit = debit;
    }

    @Basic
    @Column(name = "CREDIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCredit() {
        return credit;
    }

    public void setCredit(BigDecimal credit) {
        this.credit = credit;
    }

    @Basic
    @Column(name = "ATTACH", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Long getAttach() {
        return attach;
    }

    public void setAttach(Long attach) {
        this.attach = attach;
    }

    @Basic
    @Column(name = "ITEM_ID", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "IMPORT_TYPE", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getImportType() {
        return importType;
    }

    public void setImportType(Integer importType) {
        this.importType = importType;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "MONTH_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getMonthId() {
        return monthId;
    }

    public void setMonthId(Integer monthId) {
        this.monthId = monthId;
    }

    @Basic
    @Column(name = "ORIGINAL_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getOriginalPeriod() {
        return originalPeriod;
    }

    public void setOriginalPeriod(Integer originalPeriod) {
        this.originalPeriod = originalPeriod;
    }

    @Basic
    @Column(name = "STATUS", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Basic
    @Column(name = "PART_BILLED_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPartBilledPeriod() {
        return partBilledPeriod;
    }

    public void setPartBilledPeriod(Integer partBilledPeriod) {
        this.partBilledPeriod = partBilledPeriod;
    }

    @Basic
    @Column(name = "BILLED_PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getBilledPeriod() {
        return billedPeriod;
    }

    public void setBilledPeriod(Integer billedPeriod) {
        this.billedPeriod = billedPeriod;
    }

    @Basic
    @Column(name = "STD_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getStdCode() {
        return stdCode;
    }

    public void setStdCode(String stdCode) {
        this.stdCode = stdCode;
    }

    @Basic
    @Column(name = "MAPPING_REASON", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getMappingReason() {
        return mappingReason;
    }

    public void setMappingReason(String mappingReason) {
        this.mappingReason = mappingReason;
    }

    @Basic
    @Column(name = "MAPPING_USER", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMappingUser() {
        return mappingUser;
    }

    public void setMappingUser(String mappingUser) {
        this.mappingUser = mappingUser;
    }

    @Basic
    @Column(name = "MAPPING_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getMappingTime() {
        return mappingTime;
    }

    public void setMappingTime(Date mappingTime) {
        this.mappingTime = mappingTime;
    }

    @Basic
    @Column(name = "REMAP_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRemapId() {
        return remapId;
    }

    public void setRemapId(String remapId) {
        this.remapId = remapId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Voucher voucher = (Voucher) o;
        return Objects.equals(voucherId, voucher.voucherId) &&
                Objects.equals(vid, voucher.vid) &&
                Objects.equals(date, voucher.date) &&
                Objects.equals(group, voucher.group) &&
                Objects.equals(period, voucher.period) &&
                Objects.equals(customerCode, voucher.customerCode) &&
                Objects.equals(customerName, voucher.customerName) &&
                Objects.equals(summary, voucher.summary) &&
                Objects.equals(acctCode, voucher.acctCode) &&
                Objects.equals(debit, voucher.debit) &&
                Objects.equals(credit, voucher.credit) &&
                Objects.equals(attach, voucher.attach) &&
                Objects.equals(itemId, voucher.itemId) &&
                Objects.equals(createTime, voucher.createTime) &&
                Objects.equals(importType, voucher.importType) &&
                Objects.equals(creatorId, voucher.creatorId) &&
                Objects.equals(monthId, voucher.monthId) &&
                Objects.equals(originalPeriod, voucher.originalPeriod) &&
                Objects.equals(status, voucher.status) &&
                Objects.equals(partBilledPeriod, voucher.partBilledPeriod) &&
                Objects.equals(billedPeriod, voucher.billedPeriod) &&
                Objects.equals(stdCode, voucher.stdCode) &&
                Objects.equals(mappingReason, voucher.mappingReason) &&
                Objects.equals(mappingUser, voucher.mappingUser) &&
                Objects.equals(mappingTime, voucher.mappingTime) &&
                Objects.equals(remapId, voucher.remapId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(voucherId, vid, date, group, period, customerCode, customerName, summary, acctCode, debit, credit, attach, itemId, createTime, importType, creatorId, monthId, originalPeriod, status, partBilledPeriod, billedPeriod, stdCode, mappingReason, mappingUser, mappingTime, remapId);
    }
}
