package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "VOUCHER_MAIN", schema = PROJECT_SCHEMA, catalog = "")
public class VoucherMain {
    private String voucherMainId;
    private Integer period;
    private String group;
    private String vid;
    private Integer voucherCount;
    private Integer acctCodeCount;
    private BigDecimal amount;
    private BigDecimal amountCredit;
    private Date createTime;
    private Date updateTime;
    private String creatorId;

    @Id
    @Column(name = "VOUCHER_MAIN_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVoucherMainId() {
        return voucherMainId;
    }

    public void setVoucherMainId(String voucherMainId) {
        this.voucherMainId = voucherMainId;
    }

    @Basic
    @Column(name = "PERIOD", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = B_Delimiter + "GROUP" + E_Delimiter, nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGroup() {
        return group;
    }

    public void setGroup(String group) {
        this.group = group;
    }

    @Basic
    @Column(name = "VID", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getVid() {
        return vid;
    }

    public void setVid(String vid) {
        this.vid = vid;
    }

    @Basic
    @Column(name = "VOUCHER_COUNT", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getVoucherCount() {
        return voucherCount;
    }

    public void setVoucherCount(Integer voucherCount) {
        this.voucherCount = voucherCount;
    }

    @Basic
    @Column(name = "ACCT_CODE_COUNT", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAcctCodeCount() {
        return acctCodeCount;
    }

    public void setAcctCodeCount(Integer acctCodeCount) {
        this.acctCodeCount = acctCodeCount;
    }

    @Basic
    @Column(name = "AMOUNT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    @Basic
    @Column(name = "AMOUNT_CREDIT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAmountCredit() {
        return amountCredit;
    }

    public void setAmountCredit(BigDecimal amountCredit) {
        this.amountCredit = amountCredit;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        VoucherMain that = (VoucherMain) o;
        return Objects.equals(voucherMainId, that.voucherMainId) &&
                Objects.equals(period, that.period) &&
                Objects.equals(group, that.group) &&
                Objects.equals(vid, that.vid) &&
                Objects.equals(voucherCount, that.voucherCount) &&
                Objects.equals(acctCodeCount, that.acctCodeCount) &&
                Objects.equals(amount, that.amount) &&
                Objects.equals(amountCredit, that.amountCredit) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(creatorId, that.creatorId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(voucherMainId, period, group, vid, voucherCount, acctCodeCount, amount, amountCredit, createTime, updateTime, creatorId);
    }
}
