package pwc.taxtech.atms.vat.entity;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "VOUCHER_MAPPING", schema = PROJECT_SCHEMA, catalog = "")
public class VoucherMapping {
    private String id;
    private String tranCode;
    private String vid;
    private Integer period;
    private String group;
    private String itemId;
    private String creatorId;
    private Date createTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "TRAN_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTranCode() {
        return tranCode;
    }

    public void setTranCode(String tranCode) {
        this.tranCode = tranCode;
    }

    @Basic
    @Column(name = "VID", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVid() {
        return vid;
    }

    public void setVid(String vid) {
        this.vid = vid;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = B_Delimiter + "GROUP" + E_Delimiter, nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGroup() {
        return group;
    }

    public void setGroup(String group) {
        this.group = group;
    }

    @Basic
    @Column(name = "ITEM_ID", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        VoucherMapping that = (VoucherMapping) o;
        return period == that.period &&
                Objects.equals(id, that.id) &&
                Objects.equals(tranCode, that.tranCode) &&
                Objects.equals(vid, that.vid) &&
                Objects.equals(group, that.group) &&
                Objects.equals(itemId, that.itemId) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, tranCode, vid, period, group, itemId, creatorId, createTime);
    }
}
