package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "BD_USER_RED_LETTER_REASON", schema = PROJECT_ADMIN, catalog = "")
public class BdUserRedLetterReason {
    private String id;
    private Integer invoicingReasonIndex;
    private String inputReason;
    private String evidenceDocuments;
    private Integer isRecievingAll;
    private String invoiceId;
    private String caseNumber;
    private Date createTime;
    private String createBy;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "INVOICING_REASON_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getInvoicingReasonIndex() {
        return invoicingReasonIndex;
    }

    public void setInvoicingReasonIndex(Integer invoicingReasonIndex) {
        this.invoicingReasonIndex = invoicingReasonIndex;
    }

    @Basic
    @Column(name = "INPUT_REASON", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInputReason() {
        return inputReason;
    }

    public void setInputReason(String inputReason) {
        this.inputReason = inputReason;
    }

    @Basic
    @Column(name = "EVIDENCE_DOCUMENTS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getEvidenceDocuments() {
        return evidenceDocuments;
    }

    public void setEvidenceDocuments(String evidenceDocuments) {
        this.evidenceDocuments = evidenceDocuments;
    }

    @Basic
    @Column(name = "IS_RECIEVING_ALL", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsRecievingAll() {
        return isRecievingAll;
    }

    public void setIsRecievingAll(Integer isRecievingAll) {
        this.isRecievingAll = isRecievingAll;
    }

    @Basic
    @Column(name = "INVOICE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceId() {
        return invoiceId;
    }

    public void setInvoiceId(String invoiceId) {
        this.invoiceId = invoiceId;
    }

    @Basic
    @Column(name = "CASE_NUMBER", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCaseNumber() {
        return caseNumber;
    }

    public void setCaseNumber(String caseNumber) {
        this.caseNumber = caseNumber;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        BdUserRedLetterReason that = (BdUserRedLetterReason) o;
        return invoicingReasonIndex == that.invoicingReasonIndex &&
                isRecievingAll == that.isRecievingAll &&
                Objects.equals(id, that.id) &&
                Objects.equals(inputReason, that.inputReason) &&
                Objects.equals(evidenceDocuments, that.evidenceDocuments) &&
                Objects.equals(invoiceId, that.invoiceId) &&
                Objects.equals(caseNumber, that.caseNumber) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(createBy, that.createBy);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, invoicingReasonIndex, inputReason, evidenceDocuments, isRecievingAll, invoiceId, caseNumber, createTime, createBy);
    }
}
