package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "DASHBOARD_CONFIG_ORGANIZATION", schema = PROJECT_ADMIN, catalog = "")
public class DashboardConfigOrganization {
    private String id;
    private String name;
    private Integer isDefault;
    private String userId;
    private String years;
    private Integer dimensionType;
    private String indexIDs;
    private String userSetting;
    private Integer isShowData;
    private Integer orderIndex;
    private Date createTime;
    private Date updateTime;
    private String riskTip;
    private Integer isShowGrid;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "IS_DEFAULT", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsDefault() {
        return isDefault;
    }

    public void setIsDefault(Integer isDefault) {
        this.isDefault = isDefault;
    }

    @Basic
    @Column(name = "USER_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    @Basic
    @Column(name = "YEARS", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getYears() {
        return years;
    }

    public void setYears(String years) {
        this.years = years;
    }

    @Basic
    @Column(name = "DIMENSION_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDimensionType() {
        return dimensionType;
    }

    public void setDimensionType(Integer dimensionType) {
        this.dimensionType = dimensionType;
    }

    @Basic
    @Column(name = "INDEX_IDS", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getIndexIDs() {
        return indexIDs;
    }

    public void setIndexIDs(String indexIDs) {
        this.indexIDs = indexIDs;
    }

    @Basic
    @Column(name = "USER_SETTING", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getUserSetting() {
        return userSetting;
    }

    public void setUserSetting(String userSetting) {
        this.userSetting = userSetting;
    }

    @Basic
    @Column(name = "IS_SHOW_DATA", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsShowData() {
        return isShowData;
    }

    public void setIsShowData(Integer isShowData) {
        this.isShowData = isShowData;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Integer orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "RISK_TIP", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getRiskTip() {
        return riskTip;
    }

    public void setRiskTip(String riskTip) {
        this.riskTip = riskTip;
    }

    @Basic
    @Column(name = "IS_SHOW_GRID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsShowGrid() {
        return isShowGrid;
    }

    public void setIsShowGrid(Integer isShowGrid) {
        this.isShowGrid = isShowGrid;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DashboardConfigOrganization that = (DashboardConfigOrganization) o;
        return isDefault == that.isDefault &&
                dimensionType == that.dimensionType &&
                isShowData == that.isShowData &&
                orderIndex == that.orderIndex &&
                Objects.equals(id, that.id) &&
                Objects.equals(name, that.name) &&
                Objects.equals(userId, that.userId) &&
                Objects.equals(years, that.years) &&
                Objects.equals(indexIDs, that.indexIDs) &&
                Objects.equals(userSetting, that.userSetting) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(riskTip, that.riskTip) &&
                Objects.equals(isShowGrid, that.isShowGrid);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, isDefault, userId, years, dimensionType, indexIDs, userSetting, isShowData, orderIndex, createTime, updateTime, riskTip, isShowGrid);
    }
}
