package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "DATA_SOURCE_FORMULA_MAPPING", schema = PROJECT_ADMIN, catalog = "")
public class DataSourceFormulaMapping {
    private String id;
    private Integer dataSourceId;
    private String dataSourceName;
    private String fourmulaName;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "DATA_SOURCE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDataSourceId() {
        return dataSourceId;
    }

    public void setDataSourceId(Integer dataSourceId) {
        this.dataSourceId = dataSourceId;
    }

    @Basic
    @Column(name = "DATA_SOURCE_NAME", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDataSourceName() {
        return dataSourceName;
    }

    public void setDataSourceName(String dataSourceName) {
        this.dataSourceName = dataSourceName;
    }

    @Basic
    @Column(name = "FOURMULA_NAME", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFourmulaName() {
        return fourmulaName;
    }

    public void setFourmulaName(String fourmulaName) {
        this.fourmulaName = fourmulaName;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DataSourceFormulaMapping that = (DataSourceFormulaMapping) o;
        return dataSourceId == that.dataSourceId &&
                Objects.equals(id, that.id) &&
                Objects.equals(dataSourceName, that.dataSourceName) &&
                Objects.equals(fourmulaName, that.fourmulaName);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, dataSourceId, dataSourceName, fourmulaName);
    }
}
