package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "DEMO", schema = PROJECT_ADMIN, catalog = "")
public class Demo {
    private Long id;
    private String name;
    private Boolean age;
    private Integer createTime;
    private Integer updateTime;
    private Boolean isDelete;

    @Id
    @Column(name = "ID", nullable = false)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "AGE", nullable = false)
    public Boolean getAge() {
        return age;
    }

    public void setAge(Boolean age) {
        this.age = age;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Integer createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Integer updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "IS_DELETE", nullable = false)
    public Boolean getIsDelete() {
        return isDelete;
    }

    public void setIsDelete(Boolean isDelete) {
        this.isDelete = isDelete;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Demo demo = (Demo) o;
        return id == demo.id &&
                age == demo.age &&
                createTime == demo.createTime &&
                updateTime == demo.updateTime &&
                isDelete == demo.isDelete &&
                Objects.equals(name, demo.name);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, age, createTime, updateTime, isDelete);
    }
}
