package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "DOCUMENT_MANAGE", schema = PROJECT_ADMIN, catalog = "")
public class DocumentManage {
    private String id;
    private Integer documentTypeId;
    private String code;
    private String fileId;
    private Integer serviceTypeId;
    private String projectId;
    private Integer periodId;
    private Boolean isActive;
    private String organizationId;
    private Date expiredFrom;
    private Date expriedTo;
    private String nameCode;
    private String projectCode;
    private BigDecimal amount;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "DOCUMENT_TYPE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDocumentTypeId() {
        return documentTypeId;
    }

    public void setDocumentTypeId(Integer documentTypeId) {
        this.documentTypeId = documentTypeId;
    }

    @Basic
    @Column(name = "CODE", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "FILE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFileId() {
        return fileId;
    }

    public void setFileId(String fileId) {
        this.fileId = fileId;
    }

    @Basic
    @Column(name = "SERVICE_TYPE_ID", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getServiceTypeId() {
        return serviceTypeId;
    }

    public void setServiceTypeId(Integer serviceTypeId) {
        this.serviceTypeId = serviceTypeId;
    }

    @Basic
    @Column(name = "PROJECT_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getProjectId() {
        return projectId;
    }

    public void setProjectId(String projectId) {
        this.projectId = projectId;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "EXPIRED_FROM", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getExpiredFrom() {
        return expiredFrom;
    }

    public void setExpiredFrom(Date expiredFrom) {
        this.expiredFrom = expiredFrom;
    }

    @Basic
    @Column(name = "EXPRIED_TO", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getExpriedTo() {
        return expriedTo;
    }

    public void setExpriedTo(Date expriedTo) {
        this.expriedTo = expriedTo;
    }

    @Basic
    @Column(name = "NAME_CODE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getNameCode() {
        return nameCode;
    }

    public void setNameCode(String nameCode) {
        this.nameCode = nameCode;
    }

    @Basic
    @Column(name = "PROJECT_CODE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getProjectCode() {
        return projectCode;
    }

    public void setProjectCode(String projectCode) {
        this.projectCode = projectCode;
    }

    @Basic
    @Column(name = "AMOUNT", nullable = true, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DocumentManage that = (DocumentManage) o;
        return documentTypeId == that.documentTypeId &&
                serviceTypeId == that.serviceTypeId &&
                isActive == that.isActive &&
                Objects.equals(id, that.id) &&
                Objects.equals(code, that.code) &&
                Objects.equals(fileId, that.fileId) &&
                Objects.equals(projectId, that.projectId) &&
                Objects.equals(periodId, that.periodId) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(expiredFrom, that.expiredFrom) &&
                Objects.equals(expriedTo, that.expriedTo) &&
                Objects.equals(nameCode, that.nameCode) &&
                Objects.equals(projectCode, that.projectCode) &&
                Objects.equals(amount, that.amount);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, documentTypeId, code, fileId, serviceTypeId, projectId, periodId, isActive, organizationId, expiredFrom, expriedTo, nameCode, projectCode, amount);
    }
}
