package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "ENTRIES_CHECK_DETAIL", schema = PROJECT_ADMIN, catalog = "")
public class EntriesCheckDetail {
    private String id;
    private String modelId;
    private Integer guideLine;
    private String acctJudge;
    private String standardCode;
    private Integer acctDirection;
    private String entriesComparison;
    private BigDecimal thresholdValue;
    private String summary;
    private Integer isRelevantAmt;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "MODEL_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelId() {
        return modelId;
    }

    public void setModelId(String modelId) {
        this.modelId = modelId;
    }

    @Basic
    @Column(name = "GUIDE_LINE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getGuideLine() {
        return guideLine;
    }

    public void setGuideLine(Integer guideLine) {
        this.guideLine = guideLine;
    }

    @Basic
    @Column(name = "ACCT_JUDGE", nullable = false, length = 10)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAcctJudge() {
        return acctJudge;
    }

    public void setAcctJudge(String acctJudge) {
        this.acctJudge = acctJudge;
    }

    @Basic
    @Column(name = "STANDARD_CODE", nullable = true, length = 10)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getStandardCode() {
        return standardCode;
    }

    public void setStandardCode(String standardCode) {
        this.standardCode = standardCode;
    }

    @Basic
    @Column(name = "ACCT_DIRECTION", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getAcctDirection() {
        return acctDirection;
    }

    public void setAcctDirection(Integer acctDirection) {
        this.acctDirection = acctDirection;
    }

    @Basic
    @Column(name = "ENTRIES_COMPARISON", nullable = true, length = 10)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEntriesComparison() {
        return entriesComparison;
    }

    public void setEntriesComparison(String entriesComparison) {
        this.entriesComparison = entriesComparison;
    }

    @Basic
    @Column(name = "THRESHOLD_VALUE", nullable = false, precision = 3)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getThresholdValue() {
        return thresholdValue;
    }

    public void setThresholdValue(BigDecimal thresholdValue) {
        this.thresholdValue = thresholdValue;
    }

    @Basic
    @Column(name = "SUMMARY", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getSummary() {
        return summary;
    }

    public void setSummary(String summary) {
        this.summary = summary;
    }

    @Basic
    @Column(name = "IS_RELEVANT_AMT", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsRelevantAmt() {
        return isRelevantAmt;
    }

    public void setIsRelevantAmt(Integer isRelevantAmt) {
        this.isRelevantAmt = isRelevantAmt;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        EntriesCheckDetail that = (EntriesCheckDetail) o;
        return guideLine == that.guideLine &&
                isRelevantAmt == that.isRelevantAmt &&
                Objects.equals(id, that.id) &&
                Objects.equals(modelId, that.modelId) &&
                Objects.equals(acctJudge, that.acctJudge) &&
                Objects.equals(standardCode, that.standardCode) &&
                Objects.equals(acctDirection, that.acctDirection) &&
                Objects.equals(entriesComparison, that.entriesComparison) &&
                Objects.equals(thresholdValue, that.thresholdValue) &&
                Objects.equals(summary, that.summary) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, modelId, guideLine, acctJudge, standardCode, acctDirection, entriesComparison, thresholdValue, summary, isRelevantAmt, createTime, updateTime);
    }
}
