package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "INDEX_ANALYSIS_DETAIL", schema = PROJECT_ADMIN, catalog = "")
public class IndexAnalysisDetail {
    private String id;
    private String modelId;
    private String indexName;
    private String indexFormula;
    private Integer sequence;
    private Integer displayType;
    private Integer isVisible;
    private Integer isMainValue;
    private Integer isYearValue;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "MODEL_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelId() {
        return modelId;
    }

    public void setModelId(String modelId) {
        this.modelId = modelId;
    }

    @Basic
    @Column(name = "INDEX_NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIndexName() {
        return indexName;
    }

    public void setIndexName(String indexName) {
        this.indexName = indexName;
    }

    @Basic
    @Column(name = "INDEX_FORMULA", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getIndexFormula() {
        return indexFormula;
    }

    public void setIndexFormula(String indexFormula) {
        this.indexFormula = indexFormula;
    }

    @Basic
    @Column(name = "SEQUENCE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getSequence() {
        return sequence;
    }

    public void setSequence(Integer sequence) {
        this.sequence = sequence;
    }

    @Basic
    @Column(name = "DISPLAY_TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDisplayType() {
        return displayType;
    }

    public void setDisplayType(Integer displayType) {
        this.displayType = displayType;
    }

    @Basic
    @Column(name = "IS_VISIBLE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsVisible() {
        return isVisible;
    }

    public void setIsVisible(Integer isVisible) {
        this.isVisible = isVisible;
    }

    @Basic
    @Column(name = "IS_MAIN_VALUE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsMainValue() {
        return isMainValue;
    }

    public void setIsMainValue(Integer isMainValue) {
        this.isMainValue = isMainValue;
    }

    @Basic
    @Column(name = "IS_YEAR_VALUE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsYearValue() {
        return isYearValue;
    }

    public void setIsYearValue(Integer isYearValue) {
        this.isYearValue = isYearValue;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        IndexAnalysisDetail that = (IndexAnalysisDetail) o;
        return sequence == that.sequence &&
                displayType == that.displayType &&
                isVisible == that.isVisible &&
                isMainValue == that.isMainValue &&
                isYearValue == that.isYearValue &&
                Objects.equals(id, that.id) &&
                Objects.equals(modelId, that.modelId) &&
                Objects.equals(indexName, that.indexName) &&
                Objects.equals(indexFormula, that.indexFormula) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, modelId, indexName, indexFormula, sequence, displayType, isVisible, isMainValue, isYearValue, createTime, updateTime);
    }
}
