package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "INDEX_ANALYSIS_RESULT_SUMMARY", schema = PROJECT_ADMIN, catalog = "")
public class IndexAnalysisResultSummary {
    private String id;
    private String resultId;
    private Integer year;
    private Integer period;
    private String organizationId;
    private String serviceTypeId;
    private String modelId;
    private String categoryId;
    private String modelCode;
    private String modelName;
    private String description;
    private Integer type;
    private Integer isYearValue;
    private Integer monthExp;
    private Integer yearExp;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "RESULT_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getResultId() {
        return resultId;
    }

    public void setResultId(String resultId) {
        this.resultId = resultId;
    }

    @Basic
    @Column(name = "YEAR", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getYear() {
        return year;
    }

    public void setYear(Integer year) {
        this.year = year;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriod() {
        return period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "SERVICE_TYPE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getServiceTypeId() {
        return serviceTypeId;
    }

    public void setServiceTypeId(String serviceTypeId) {
        this.serviceTypeId = serviceTypeId;
    }

    @Basic
    @Column(name = "MODEL_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelId() {
        return modelId;
    }

    public void setModelId(String modelId) {
        this.modelId = modelId;
    }

    @Basic
    @Column(name = "CATEGORY_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCategoryId() {
        return categoryId;
    }

    public void setCategoryId(String categoryId) {
        this.categoryId = categoryId;
    }

    @Basic
    @Column(name = "MODEL_CODE", nullable = false, length = 20)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelCode() {
        return modelCode;
    }

    public void setModelCode(String modelCode) {
        this.modelCode = modelCode;
    }

    @Basic
    @Column(name = "MODEL_NAME", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelName() {
        return modelName;
    }

    public void setModelName(String modelName) {
        this.modelName = modelName;
    }

    @Basic
    @Column(name = "DESCRIPTION", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Basic
    @Column(name = "TYPE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    @Basic
    @Column(name = "IS_YEAR_VALUE", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getIsYearValue() {
        return isYearValue;
    }

    public void setIsYearValue(Integer isYearValue) {
        this.isYearValue = isYearValue;
    }

    @Basic
    @Column(name = "MONTH_EXP", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getMonthExp() {
        return monthExp;
    }

    public void setMonthExp(Integer monthExp) {
        this.monthExp = monthExp;
    }

    @Basic
    @Column(name = "YEAR_EXP", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getYearExp() {
        return yearExp;
    }

    public void setYearExp(Integer yearExp) {
        this.yearExp = yearExp;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        IndexAnalysisResultSummary that = (IndexAnalysisResultSummary) o;
        return year == that.year &&
                period == that.period &&
                type == that.type &&
                isYearValue == that.isYearValue &&
                monthExp == that.monthExp &&
                yearExp == that.yearExp &&
                Objects.equals(id, that.id) &&
                Objects.equals(resultId, that.resultId) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(serviceTypeId, that.serviceTypeId) &&
                Objects.equals(modelId, that.modelId) &&
                Objects.equals(categoryId, that.categoryId) &&
                Objects.equals(modelCode, that.modelCode) &&
                Objects.equals(modelName, that.modelName) &&
                Objects.equals(description, that.description) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, resultId, year, period, organizationId, serviceTypeId, modelId, categoryId, modelCode, modelName, description, type, isYearValue, monthExp, yearExp, createTime, updateTime);
    }
}
