package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "INVOICE_RULE_SETTING", schema = PROJECT_ADMIN, catalog = "")
public class InvoiceRuleSetting {
    private String id;
    private String organizationId;
    private Boolean isToApplyHeadCompanySetting;
    private Boolean isSpecialInvoice;
    private Boolean isNormalInvoice;
    private BigDecimal specialInvoiceUpperLimitAmount;
    private Boolean specialInvoiceSplitUpperLimit;
    private BigDecimal normalInvoiceUpperLimitAmount;
    private Boolean normalInvoiceSplitUpperLimit;
    private Boolean isInvoiceOutForOtherOrgs;
    private Boolean isInvoiceOutForSelfOrgs;
    private Boolean isShowBusinessNo;
    private Boolean isShowGoodsName;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "IS_APPLY_HEAD_COMPANY_SETTING", nullable = false)
    public Boolean getIsToApplyHeadCompanySetting() {
        return isToApplyHeadCompanySetting;
    }

    public void setIsToApplyHeadCompanySetting(Boolean isToApplyHeadCompanySetting) {
        this.isToApplyHeadCompanySetting = isToApplyHeadCompanySetting;
    }

    @Basic
    @Column(name = "IS_SPECIAL_INVOICE", nullable = false)
    public Boolean getIsSpecialInvoice() {
        return isSpecialInvoice;
    }

    public void setIsSpecialInvoice(Boolean isSpecialInvoice) {
        this.isSpecialInvoice = isSpecialInvoice;
    }

    @Basic
    @Column(name = "IS_NORMAL_INVOICE", nullable = false)
    public Boolean getIsNormalInvoice() {
        return isNormalInvoice;
    }

    public void setIsNormalInvoice(Boolean isNormalInvoice) {
        this.isNormalInvoice = isNormalInvoice;
    }

    @Basic
    @Column(name = "SPECIAL_UPPER_LIMIT_AMOUNT", nullable = false, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getSpecialInvoiceUpperLimitAmount() {
        return specialInvoiceUpperLimitAmount;
    }

    public void setSpecialInvoiceUpperLimitAmount(BigDecimal specialInvoiceUpperLimitAmount) {
        this.specialInvoiceUpperLimitAmount = specialInvoiceUpperLimitAmount;
    }

    @Basic
    @Column(name = "SPECIAL_SPLIT_UPPER_LIMIT", nullable = false)
    public Boolean getSpecialInvoiceSplitUpperLimit() {
        return specialInvoiceSplitUpperLimit;
    }

    public void setSpecialInvoiceSplitUpperLimit(Boolean specialInvoiceSplitUpperLimit) {
        this.specialInvoiceSplitUpperLimit = specialInvoiceSplitUpperLimit;
    }

    @Basic
    @Column(name = "NORMAL_UPPER_LIMIT_AMOUNT", nullable = false, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getNormalInvoiceUpperLimitAmount() {
        return normalInvoiceUpperLimitAmount;
    }

    public void setNormalInvoiceUpperLimitAmount(BigDecimal normalInvoiceUpperLimitAmount) {
        this.normalInvoiceUpperLimitAmount = normalInvoiceUpperLimitAmount;
    }

    @Basic
    @Column(name = "NORMAL_SPLIT_UPPER_LIMIT", nullable = false)
    public Boolean getNormalInvoiceSplitUpperLimit() {
        return normalInvoiceSplitUpperLimit;
    }

    public void setNormalInvoiceSplitUpperLimit(Boolean normalInvoiceSplitUpperLimit) {
        this.normalInvoiceSplitUpperLimit = normalInvoiceSplitUpperLimit;
    }

    @Basic
    @Column(name = "IS_INVOICE_OUT_FOR_OTHER_ORGS", nullable = false)
    public Boolean getIsInvoiceOutForOtherOrgs() {
        return isInvoiceOutForOtherOrgs;
    }

    public void setIsInvoiceOutForOtherOrgs(Boolean isInvoiceOutForOtherOrgs) {
        this.isInvoiceOutForOtherOrgs = isInvoiceOutForOtherOrgs;
    }

    @Basic
    @Column(name = "IS_INVOICE_OUT_FOR_SELF_ORGS", nullable = false)
    public Boolean getIsInvoiceOutForSelfOrgs() {
        return isInvoiceOutForSelfOrgs;
    }

    public void setIsInvoiceOutForSelfOrgs(Boolean isInvoiceOutForSelfOrgs) {
        this.isInvoiceOutForSelfOrgs = isInvoiceOutForSelfOrgs;
    }

    @Basic
    @Column(name = "IS_SHOW_BUSINESS_N_O", nullable = false)
    public Boolean getIsShowBusinessNo() {
        return isShowBusinessNo;
    }

    public void setIsShowBusinessNo(Boolean isShowBusinessNo) {
        this.isShowBusinessNo = isShowBusinessNo;
    }

    @Basic
    @Column(name = "IS_SHOW_GOODS_NAME", nullable = false)
    public Boolean getIsShowGoodsName() {
        return isShowGoodsName;
    }

    public void setIsShowGoodsName(Boolean isShowGoodsName) {
        this.isShowGoodsName = isShowGoodsName;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        InvoiceRuleSetting that = (InvoiceRuleSetting) o;
        return isToApplyHeadCompanySetting == that.isToApplyHeadCompanySetting &&
                isSpecialInvoice == that.isSpecialInvoice &&
                isNormalInvoice == that.isNormalInvoice &&
                specialInvoiceSplitUpperLimit == that.specialInvoiceSplitUpperLimit &&
                normalInvoiceSplitUpperLimit == that.normalInvoiceSplitUpperLimit &&
                isInvoiceOutForOtherOrgs == that.isInvoiceOutForOtherOrgs &&
                isInvoiceOutForSelfOrgs == that.isInvoiceOutForSelfOrgs &&
                isShowBusinessNo == that.isShowBusinessNo &&
                isShowGoodsName == that.isShowGoodsName &&
                Objects.equals(id, that.id) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(specialInvoiceUpperLimitAmount, that.specialInvoiceUpperLimitAmount) &&
                Objects.equals(normalInvoiceUpperLimitAmount, that.normalInvoiceUpperLimitAmount);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, organizationId, isToApplyHeadCompanySetting, isSpecialInvoice, isNormalInvoice, specialInvoiceUpperLimitAmount, specialInvoiceSplitUpperLimit, normalInvoiceUpperLimitAmount, normalInvoiceSplitUpperLimit, isInvoiceOutForOtherOrgs, isInvoiceOutForSelfOrgs, isShowBusinessNo, isShowGoodsName);
    }
}
