package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "INVOICE_RULE_SORT_SETTING", schema = PROJECT_ADMIN, catalog = "")
public class InvoiceRuleSortSetting {
    private String id;
    private String organizationId;
    private String dictionaryInvoiceSortFieldId;
    private Boolean isSortFieldAsc;
    private Boolean orderIndex;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "DICT_INVOICE_SORT_FIELD_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDictionaryInvoiceSortFieldId() {
        return dictionaryInvoiceSortFieldId;
    }

    public void setDictionaryInvoiceSortFieldId(String dictionaryInvoiceSortFieldId) {
        this.dictionaryInvoiceSortFieldId = dictionaryInvoiceSortFieldId;
    }

    @Basic
    @Column(name = "IS_SORT_FIELD_ASC", nullable = false)
    public Boolean getIsSortFieldAsc() {
        return isSortFieldAsc;
    }

    public void setIsSortFieldAsc(Boolean isSortFieldAsc) {
        this.isSortFieldAsc = isSortFieldAsc;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = false)
    public Boolean getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Boolean orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        InvoiceRuleSortSetting that = (InvoiceRuleSortSetting) o;
        return isSortFieldAsc == that.isSortFieldAsc &&
                orderIndex == that.orderIndex &&
                Objects.equals(id, that.id) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(dictionaryInvoiceSortFieldId, that.dictionaryInvoiceSortFieldId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, organizationId, dictionaryInvoiceSortFieldId, isSortFieldAsc, orderIndex);
    }
}
