package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OPERATION_LOG", schema = PROJECT_ADMIN, catalog = "")
public class OperationLog {
    private String id;
    private String operationObject;
    private String originalState;
    private String updateState;
    private String operationDescription;
    private String operationBy;
    private String ip;
    private String oid;
    private Integer moduleId;
    private String comment;
    private Date createTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "OPERATION_OBJECT", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOperationObject() {
        return operationObject;
    }

    public void setOperationObject(String operationObject) {
        this.operationObject = operationObject;
    }

    @Basic
    @Column(name = "ORIGINAL_STATE", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOriginalState() {
        return originalState;
    }

    public void setOriginalState(String originalState) {
        this.originalState = originalState;
    }

    @Basic
    @Column(name = "UPDATE_STATE", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateState() {
        return updateState;
    }

    public void setUpdateState(String updateState) {
        this.updateState = updateState;
    }

    @Basic
    @Column(name = "OPERATION_DESCRIPTION", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOperationDescription() {
        return operationDescription;
    }

    public void setOperationDescription(String operationDescription) {
        this.operationDescription = operationDescription;
    }

    @Basic
    @Column(name = "OPERATION_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOperationBy() {
        return operationBy;
    }

    public void setOperationBy(String operationBy) {
        this.operationBy = operationBy;
    }

    @Basic
    @Column(name = "IP", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    @Basic
    @Column(name = "O_ID", nullable = false, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOid() {
        return oid;
    }

    public void setOid(String oid) {
        this.oid = oid;
    }

    @Basic
    @Column(name = "MODULE_ID", nullable = false)
    public Integer getModuleId() {
        return moduleId;
    }

    public void setModuleId(Integer moduleId) {
        this.moduleId = moduleId;
    }

    @Basic
    @Column(name = B_Delimiter + "COMMENT" + E_Delimiter, nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OperationLog that = (OperationLog) o;
        return moduleId == that.moduleId &&
                Objects.equals(id, that.id) &&
                Objects.equals(operationObject, that.operationObject) &&
                Objects.equals(originalState, that.originalState) &&
                Objects.equals(updateState, that.updateState) &&
                Objects.equals(operationDescription, that.operationDescription) &&
                Objects.equals(operationBy, that.operationBy) &&
                Objects.equals(ip, that.ip) &&
                Objects.equals(oid, that.oid) &&
                Objects.equals(comment, that.comment) &&
                Objects.equals(createTime, that.createTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, operationObject, originalState, updateState, operationDescription, operationBy, ip, oid, moduleId, comment, createTime);
    }
}
