package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_GDBD_DETAIL", schema = PROJECT_ADMIN, catalog = "")
public class OutputGdbdDetail {
    private String id;
    private String outputInvoicePrintedId;
    private String outputInvoiceGdIssuedId;
    private Integer quantity;
    private BigDecimal price;
    private BigDecimal amount;
    private BigDecimal taxRate;
    private BigDecimal taxAmount;
    private String manualInputReasons;
    private String manualInputEvidenceFiles;
    private Integer status;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "OUTPUT_INVOICE_PRINTED_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOutputInvoicePrintedId() {
        return outputInvoicePrintedId;
    }

    public void setOutputInvoicePrintedId(String outputInvoicePrintedId) {
        this.outputInvoicePrintedId = outputInvoicePrintedId;
    }

    @Basic
    @Column(name = "OUTPUT_INVOICE_G_D_ISSUED_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOutputInvoiceGdIssuedId() {
        return outputInvoiceGdIssuedId;
    }

    public void setOutputInvoiceGdIssuedId(String outputInvoiceGdIssuedId) {
        this.outputInvoiceGdIssuedId = outputInvoiceGdIssuedId;
    }

    @Basic
    @Column(name = "QUANTITY", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getQuantity() {
        return quantity;
    }

    public void setQuantity(Integer quantity) {
        this.quantity = quantity;
    }

    @Basic
    @Column(name = "PRICE", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    @Basic
    @Column(name = "AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    @Basic
    @Column(name = "TAX_RATE", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxRate() {
        return taxRate;
    }

    public void setTaxRate(BigDecimal taxRate) {
        this.taxRate = taxRate;
    }

    @Basic
    @Column(name = "TAX_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxAmount() {
        return taxAmount;
    }

    public void setTaxAmount(BigDecimal taxAmount) {
        this.taxAmount = taxAmount;
    }

    @Basic
    @Column(name = "MANUAL_INPUT_REASONS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getManualInputReasons() {
        return manualInputReasons;
    }

    public void setManualInputReasons(String manualInputReasons) {
        this.manualInputReasons = manualInputReasons;
    }

    @Basic
    @Column(name = "MANUAL_INPUT_EVIDENCE_FILES", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getManualInputEvidenceFiles() {
        return manualInputEvidenceFiles;
    }

    public void setManualInputEvidenceFiles(String manualInputEvidenceFiles) {
        this.manualInputEvidenceFiles = manualInputEvidenceFiles;
    }

    @Basic
    @Column(name = "STATUS", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputGdbdDetail that = (OutputGdbdDetail) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(outputInvoicePrintedId, that.outputInvoicePrintedId) &&
                Objects.equals(outputInvoiceGdIssuedId, that.outputInvoiceGdIssuedId) &&
                Objects.equals(quantity, that.quantity) &&
                Objects.equals(price, that.price) &&
                Objects.equals(amount, that.amount) &&
                Objects.equals(taxRate, that.taxRate) &&
                Objects.equals(taxAmount, that.taxAmount) &&
                Objects.equals(manualInputReasons, that.manualInputReasons) &&
                Objects.equals(manualInputEvidenceFiles, that.manualInputEvidenceFiles) &&
                Objects.equals(status, that.status);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, outputInvoicePrintedId, outputInvoiceGdIssuedId, quantity, price, amount, taxRate, taxAmount, manualInputReasons, manualInputEvidenceFiles, status);
    }
}
