package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_INVOICE_EDIT_HISTORY", schema = PROJECT_ADMIN, catalog = "")
public class OutputInvoiceEditHistory {
    private String id;
    private String outputInvoiceId;
    private String reasonIDs;
    private String englishReasons;
    private String chineseReasons;
    private String createBy;
    private Date createTime;
    private BigDecimal amount;
    private String manufacturer;
    private String issuingEntity;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "OUTPUT_INVOICE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOutputInvoiceId() {
        return outputInvoiceId;
    }

    public void setOutputInvoiceId(String outputInvoiceId) {
        this.outputInvoiceId = outputInvoiceId;
    }

    @Basic
    @Column(name = "REASON_IDS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getReasonIDs() {
        return reasonIDs;
    }

    public void setReasonIDs(String reasonIDs) {
        this.reasonIDs = reasonIDs;
    }

    @Basic
    @Column(name = "ENGLISH_REASONS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getEnglishReasons() {
        return englishReasons;
    }

    public void setEnglishReasons(String englishReasons) {
        this.englishReasons = englishReasons;
    }

    @Basic
    @Column(name = "CHINESE_REASONS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getChineseReasons() {
        return chineseReasons;
    }

    public void setChineseReasons(String chineseReasons) {
        this.chineseReasons = chineseReasons;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    @Basic
    @Column(name = "MANUFACTURER", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getManufacturer() {
        return manufacturer;
    }

    public void setManufacturer(String manufacturer) {
        this.manufacturer = manufacturer;
    }

    @Basic
    @Column(name = "ISSUING_ENTITY", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIssuingEntity() {
        return issuingEntity;
    }

    public void setIssuingEntity(String issuingEntity) {
        this.issuingEntity = issuingEntity;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputInvoiceEditHistory that = (OutputInvoiceEditHistory) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(outputInvoiceId, that.outputInvoiceId) &&
                Objects.equals(reasonIDs, that.reasonIDs) &&
                Objects.equals(englishReasons, that.englishReasons) &&
                Objects.equals(chineseReasons, that.chineseReasons) &&
                Objects.equals(createBy, that.createBy) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(amount, that.amount) &&
                Objects.equals(manufacturer, that.manufacturer) &&
                Objects.equals(issuingEntity, that.issuingEntity);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, outputInvoiceId, reasonIDs, englishReasons, chineseReasons, createBy, createTime, amount, manufacturer, issuingEntity);
    }
}
