package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_INVOICE_GD_ISSUED", schema = PROJECT_ADMIN, catalog = "")
public class OutputInvoiceGdIssued {
    private String id;
    private BigDecimal totalAmount;
    private String gdInvoiceCode;
    private String gdInvoiceNumber;
    private Date gdIssuedDate;
    private String buyerOrganizationCode;
    private Date createTime;
    private Date updateTime;
    private BigDecimal totalTaxAmount;
    private Integer status;
    private String vrl;
    private String remarks;
    private String receiver;
    private String reviewer;
    private String drawer;
    private Boolean isRedInvoice;
    private String buyerOrganizationName;
    private String buyerOrganizationEnglishName;
    private String buyerAddress;
    private String buyerPhoneNo;
    private String buyerBankName;
    private String buyerBankNumber;
    private String buyerTaxPayerNumber;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "TOTAL_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTotalAmount() {
        return totalAmount;
    }

    public void setTotalAmount(BigDecimal totalAmount) {
        this.totalAmount = totalAmount;
    }

    @Basic
    @Column(name = "G_D_INVOICE_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGdInvoiceCode() {
        return gdInvoiceCode;
    }

    public void setGdInvoiceCode(String gdInvoiceCode) {
        this.gdInvoiceCode = gdInvoiceCode;
    }

    @Basic
    @Column(name = "G_D_INVOICE_NUMBER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGdInvoiceNumber() {
        return gdInvoiceNumber;
    }

    public void setGdInvoiceNumber(String gdInvoiceNumber) {
        this.gdInvoiceNumber = gdInvoiceNumber;
    }

    @Basic
    @Column(name = "G_D_ISSUED_DATE", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getGdIssuedDate() {
        return gdIssuedDate;
    }

    public void setGdIssuedDate(Date gdIssuedDate) {
        this.gdIssuedDate = gdIssuedDate;
    }

    @Basic
    @Column(name = "BUYER_ORGANIZATION_CODE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBuyerOrganizationCode() {
        return buyerOrganizationCode;
    }

    public void setBuyerOrganizationCode(String buyerOrganizationCode) {
        this.buyerOrganizationCode = buyerOrganizationCode;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "TOTAL_TAX_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTotalTaxAmount() {
        return totalTaxAmount;
    }

    public void setTotalTaxAmount(BigDecimal totalTaxAmount) {
        this.totalTaxAmount = totalTaxAmount;
    }

    @Basic
    @Column(name = "STATUS", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Basic
    @Column(name = "V_R_L", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVrl() {
        return vrl;
    }

    public void setVrl(String vrl) {
        this.vrl = vrl;
    }

    @Basic
    @Column(name = "REMARKS", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRemarks() {
        return remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    @Basic
    @Column(name = "RECEIVER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getReceiver() {
        return receiver;
    }

    public void setReceiver(String receiver) {
        this.receiver = receiver;
    }

    @Basic
    @Column(name = "REVIEWER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getReviewer() {
        return reviewer;
    }

    public void setReviewer(String reviewer) {
        this.reviewer = reviewer;
    }

    @Basic
    @Column(name = "DRAWER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDrawer() {
        return drawer;
    }

    public void setDrawer(String drawer) {
        this.drawer = drawer;
    }

    @Basic
    @Column(name = "IS_RED_INVOICE", nullable = false)
    public Boolean getIsRedInvoice() {
        return isRedInvoice;
    }

    public void setIsRedInvoice(Boolean isRedInvoice) {
        this.isRedInvoice = isRedInvoice;
    }

    @Basic
    @Column(name = "BUYER_ORGANIZATION_NAME", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBuyerOrganizationName() {
        return buyerOrganizationName;
    }

    public void setBuyerOrganizationName(String buyerOrganizationName) {
        this.buyerOrganizationName = buyerOrganizationName;
    }

    @Basic
    @Column(name = "BUYER_ORG_ENGLISH_NAME", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getBuyerOrganizationEnglishName() {
        return buyerOrganizationEnglishName;
    }

    public void setBuyerOrganizationEnglishName(String buyerOrganizationEnglishName) {
        this.buyerOrganizationEnglishName = buyerOrganizationEnglishName;
    }

    @Basic
    @Column(name = "BUYER_ADDRESS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getBuyerAddress() {
        return buyerAddress;
    }

    public void setBuyerAddress(String buyerAddress) {
        this.buyerAddress = buyerAddress;
    }

    @Basic
    @Column(name = "BUYER_PHONE_NO", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBuyerPhoneNo() {
        return buyerPhoneNo;
    }

    public void setBuyerPhoneNo(String buyerPhoneNo) {
        this.buyerPhoneNo = buyerPhoneNo;
    }

    @Basic
    @Column(name = "BUYER_BANK_NAME", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBuyerBankName() {
        return buyerBankName;
    }

    public void setBuyerBankName(String buyerBankName) {
        this.buyerBankName = buyerBankName;
    }

    @Basic
    @Column(name = "BUYER_BANK_NUMBER", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBuyerBankNumber() {
        return buyerBankNumber;
    }

    public void setBuyerBankNumber(String buyerBankNumber) {
        this.buyerBankNumber = buyerBankNumber;
    }

    @Basic
    @Column(name = "BUYER_TAX_PAYER_NUMBER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBuyerTaxPayerNumber() {
        return buyerTaxPayerNumber;
    }

    public void setBuyerTaxPayerNumber(String buyerTaxPayerNumber) {
        this.buyerTaxPayerNumber = buyerTaxPayerNumber;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputInvoiceGdIssued that = (OutputInvoiceGdIssued) o;
        return isRedInvoice == that.isRedInvoice &&
                Objects.equals(id, that.id) &&
                Objects.equals(totalAmount, that.totalAmount) &&
                Objects.equals(gdInvoiceCode, that.gdInvoiceCode) &&
                Objects.equals(gdInvoiceNumber, that.gdInvoiceNumber) &&
                Objects.equals(gdIssuedDate, that.gdIssuedDate) &&
                Objects.equals(buyerOrganizationCode, that.buyerOrganizationCode) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(totalTaxAmount, that.totalTaxAmount) &&
                Objects.equals(status, that.status) &&
                Objects.equals(vrl, that.vrl) &&
                Objects.equals(remarks, that.remarks) &&
                Objects.equals(receiver, that.receiver) &&
                Objects.equals(reviewer, that.reviewer) &&
                Objects.equals(drawer, that.drawer) &&
                Objects.equals(buyerOrganizationName, that.buyerOrganizationName) &&
                Objects.equals(buyerOrganizationEnglishName, that.buyerOrganizationEnglishName) &&
                Objects.equals(buyerAddress, that.buyerAddress) &&
                Objects.equals(buyerPhoneNo, that.buyerPhoneNo) &&
                Objects.equals(buyerBankName, that.buyerBankName) &&
                Objects.equals(buyerBankNumber, that.buyerBankNumber) &&
                Objects.equals(buyerTaxPayerNumber, that.buyerTaxPayerNumber);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, totalAmount, gdInvoiceCode, gdInvoiceNumber, gdIssuedDate, buyerOrganizationCode, createTime, updateTime, totalTaxAmount, status, vrl, remarks, receiver, reviewer, drawer, isRedInvoice, buyerOrganizationName, buyerOrganizationEnglishName, buyerAddress, buyerPhoneNo, buyerBankName, buyerBankNumber, buyerTaxPayerNumber);
    }
}
