package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_INVOICE_IMPORT_SHIPMENT", schema = PROJECT_ADMIN, catalog = "")
public class OutputInvoiceImportShipment {
    private String id;
    private String pgIweek;
    private String company;
    private String companyVloolup;
    private String confirmationNumber;
    private String vin;
    private String carType;
    private String isMarketingCar;
    private BigDecimal taxableSubtotal;
    private BigDecimal vehiclePriceafterDiscounts;
    private BigDecimal vat;
    private BigDecimal revenue;
    private String discounts;
    private String subsidy;
    private BigDecimal cost;
    private String gdRevenue;
    private String gdvat;
    private String gdCost;
    private BigDecimal inventory;
    private String orginalbeforeIntercompany;
    private String notes;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "P_G_IWEEK", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPgIweek() {
        return pgIweek;
    }

    public void setPgIweek(String pgIweek) {
        this.pgIweek = pgIweek;
    }

    @Basic
    @Column(name = "COMPANY", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCompany() {
        return company;
    }

    public void setCompany(String company) {
        this.company = company;
    }

    @Basic
    @Column(name = "COMPANY_VLOOLUP", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCompanyVloolup() {
        return companyVloolup;
    }

    public void setCompanyVloolup(String companyVloolup) {
        this.companyVloolup = companyVloolup;
    }

    @Basic
    @Column(name = "CONFIRMATION_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getConfirmationNumber() {
        return confirmationNumber;
    }

    public void setConfirmationNumber(String confirmationNumber) {
        this.confirmationNumber = confirmationNumber;
    }

    @Basic
    @Column(name = "V_I_N", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVin() {
        return vin;
    }

    public void setVin(String vin) {
        this.vin = vin;
    }

    @Basic
    @Column(name = "CAR_TYPE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCarType() {
        return carType;
    }

    public void setCarType(String carType) {
        this.carType = carType;
    }

    @Basic
    @Column(name = "IS_MARKETING_CAR", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getIsMarketingCar() {
        return isMarketingCar;
    }

    public void setIsMarketingCar(String isMarketingCar) {
        this.isMarketingCar = isMarketingCar;
    }

    @Basic
    @Column(name = "TAXABLE_SUBTOTAL", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxableSubtotal() {
        return taxableSubtotal;
    }

    public void setTaxableSubtotal(BigDecimal taxableSubtotal) {
        this.taxableSubtotal = taxableSubtotal;
    }

    @Basic
    @Column(name = "VEHICLE_PRICEAFTER_DISCOUNTS", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getVehiclePriceafterDiscounts() {
        return vehiclePriceafterDiscounts;
    }

    public void setVehiclePriceafterDiscounts(BigDecimal vehiclePriceafterDiscounts) {
        this.vehiclePriceafterDiscounts = vehiclePriceafterDiscounts;
    }

    @Basic
    @Column(name = "V_A_T", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getVat() {
        return vat;
    }

    public void setVat(BigDecimal vat) {
        this.vat = vat;
    }

    @Basic
    @Column(name = "REVENUE", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getRevenue() {
        return revenue;
    }

    public void setRevenue(BigDecimal revenue) {
        this.revenue = revenue;
    }

    @Basic
    @Column(name = "DISCOUNTS", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDiscounts() {
        return discounts;
    }

    public void setDiscounts(String discounts) {
        this.discounts = discounts;
    }

    @Basic
    @Column(name = "SUBSIDY", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSubsidy() {
        return subsidy;
    }

    public void setSubsidy(String subsidy) {
        this.subsidy = subsidy;
    }

    @Basic
    @Column(name = "COST", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getCost() {
        return cost;
    }

    public void setCost(BigDecimal cost) {
        this.cost = cost;
    }

    @Basic
    @Column(name = "G_D_REVENUE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGdRevenue() {
        return gdRevenue;
    }

    public void setGdRevenue(String gdRevenue) {
        this.gdRevenue = gdRevenue;
    }

    @Basic
    @Column(name = "G_D_V_A_T", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGdvat() {
        return gdvat;
    }

    public void setGdvat(String gdvat) {
        this.gdvat = gdvat;
    }

    @Basic
    @Column(name = "G_D_COST", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGdCost() {
        return gdCost;
    }

    public void setGdCost(String gdCost) {
        this.gdCost = gdCost;
    }

    @Basic
    @Column(name = "INVENTORY", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getInventory() {
        return inventory;
    }

    public void setInventory(BigDecimal inventory) {
        this.inventory = inventory;
    }

    @Basic
    @Column(name = "ORGINALBEFORE_INTERCOMPANY", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrginalbeforeIntercompany() {
        return orginalbeforeIntercompany;
    }

    public void setOrginalbeforeIntercompany(String orginalbeforeIntercompany) {
        this.orginalbeforeIntercompany = orginalbeforeIntercompany;
    }

    @Basic
    @Column(name = "NOTES", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getNotes() {
        return notes;
    }

    public void setNotes(String notes) {
        this.notes = notes;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputInvoiceImportShipment that = (OutputInvoiceImportShipment) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(pgIweek, that.pgIweek) &&
                Objects.equals(company, that.company) &&
                Objects.equals(companyVloolup, that.companyVloolup) &&
                Objects.equals(confirmationNumber, that.confirmationNumber) &&
                Objects.equals(vin, that.vin) &&
                Objects.equals(carType, that.carType) &&
                Objects.equals(isMarketingCar, that.isMarketingCar) &&
                Objects.equals(taxableSubtotal, that.taxableSubtotal) &&
                Objects.equals(vehiclePriceafterDiscounts, that.vehiclePriceafterDiscounts) &&
                Objects.equals(vat, that.vat) &&
                Objects.equals(revenue, that.revenue) &&
                Objects.equals(discounts, that.discounts) &&
                Objects.equals(subsidy, that.subsidy) &&
                Objects.equals(cost, that.cost) &&
                Objects.equals(gdRevenue, that.gdRevenue) &&
                Objects.equals(gdvat, that.gdvat) &&
                Objects.equals(gdCost, that.gdCost) &&
                Objects.equals(inventory, that.inventory) &&
                Objects.equals(orginalbeforeIntercompany, that.orginalbeforeIntercompany) &&
                Objects.equals(notes, that.notes) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, pgIweek, company, companyVloolup, confirmationNumber, vin, carType, isMarketingCar, taxableSubtotal, vehiclePriceafterDiscounts, vat, revenue, discounts, subsidy, cost, gdRevenue, gdvat, gdCost, inventory, orginalbeforeIntercompany, notes, createTime, updateTime);
    }
}
