package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_INVOICE_IMPORTED", schema = PROJECT_ADMIN, catalog = "")
public class OutputInvoiceImported {
    private String id;
    private String entityCode;
    private String bdFapiaoEntity;
    private String cabinConfiguration;
    private String caseNumber;
    private String ciqNumber;
    private String companyVatidTaxId;
    private String deliveryStatus;
    private String driverLicense;
    private String importCertificateNumber;
    private Date lastModifiedBy;
    private String modelSeries;
    private String motorNumber;
    private String organizationCode;
    private String registrationLocalName;
    private BigDecimal subtotalforFinalPayment;
    private Boolean subforFinalPaymentSpecified;
    private BigDecimal taxableSubtotal;
    private String vatRateorLevyRate;
    private String vehicleroutinglocation;
    private String vin;
    private Boolean isRelatedBd;
    private BigDecimal bdSubtotalforFinalPayment;
    private String otherItem1;
    private BigDecimal otherItem1Amount;
    private String otherItem2;
    private BigDecimal otherItem2Amount;
    private String otherItem3;
    private BigDecimal otherItem3Amount;
    private Date orderplaceddate;
    private Date reservationTermsAcceptedDate;
    private Date actualDeliveryDate;
    private Date deliveryConfirmedDate;
    private String governmentClassification;
    private String capacity;
    private String manufacturer;
    private String brandandModelNumber;
    private Boolean recordStatus;
    private String otherVrLs;
    private String commissionableStore;
    private String financePartner;
    private Date statusUpdateTime;
    private Boolean printedStatus;
    private String lastSyncVrl;
    private String updateBy;
    private Date createTime;
    private Date updateTime;
    private String otherBDs;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ENTITY_CODE", nullable = true, length = 20)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEntityCode() {
        return entityCode;
    }

    public void setEntityCode(String entityCode) {
        this.entityCode = entityCode;
    }

    @Basic
    @Column(name = "B_D_FAPIAO_ENTITY", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBdFapiaoEntity() {
        return bdFapiaoEntity;
    }

    public void setBdFapiaoEntity(String bdFapiaoEntity) {
        this.bdFapiaoEntity = bdFapiaoEntity;
    }

    @Basic
    @Column(name = "CABIN_CONFIGURATION", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCabinConfiguration() {
        return cabinConfiguration;
    }

    public void setCabinConfiguration(String cabinConfiguration) {
        this.cabinConfiguration = cabinConfiguration;
    }

    @Basic
    @Column(name = "CASE_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCaseNumber() {
        return caseNumber;
    }

    public void setCaseNumber(String caseNumber) {
        this.caseNumber = caseNumber;
    }

    @Basic
    @Column(name = "C_I_Q_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCiqNumber() {
        return ciqNumber;
    }

    public void setCiqNumber(String ciqNumber) {
        this.ciqNumber = ciqNumber;
    }

    @Basic
    @Column(name = "COMPANY_V_A_T_ID_TAX_ID", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCompanyVatidTaxId() {
        return companyVatidTaxId;
    }

    public void setCompanyVatidTaxId(String companyVatidTaxId) {
        this.companyVatidTaxId = companyVatidTaxId;
    }

    @Basic
    @Column(name = "DELIVERY_STATUS", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDeliveryStatus() {
        return deliveryStatus;
    }

    public void setDeliveryStatus(String deliveryStatus) {
        this.deliveryStatus = deliveryStatus;
    }

    @Basic
    @Column(name = "DRIVER_LICENSE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDriverLicense() {
        return driverLicense;
    }

    public void setDriverLicense(String driverLicense) {
        this.driverLicense = driverLicense;
    }

    @Basic
    @Column(name = "IMPORT_CERTIFICATE_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getImportCertificateNumber() {
        return importCertificateNumber;
    }

    public void setImportCertificateNumber(String importCertificateNumber) {
        this.importCertificateNumber = importCertificateNumber;
    }

    @Basic
    @Column(name = "LAST_MODIFIED_BY", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(Date lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    @Basic
    @Column(name = "MODEL_SERIES", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelSeries() {
        return modelSeries;
    }

    public void setModelSeries(String modelSeries) {
        this.modelSeries = modelSeries;
    }

    @Basic
    @Column(name = "MOTOR_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMotorNumber() {
        return motorNumber;
    }

    public void setMotorNumber(String motorNumber) {
        this.motorNumber = motorNumber;
    }

    @Basic
    @Column(name = "ORGANIZATION_CODE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationCode() {
        return organizationCode;
    }

    public void setOrganizationCode(String organizationCode) {
        this.organizationCode = organizationCode;
    }

    @Basic
    @Column(name = "REGISTRATION_LOCAL_NAME", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRegistrationLocalName() {
        return registrationLocalName;
    }

    public void setRegistrationLocalName(String registrationLocalName) {
        this.registrationLocalName = registrationLocalName;
    }

    @Basic
    @Column(name = "SUBTOTALFOR_FINAL_PAYMENT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getSubtotalforFinalPayment() {
        return subtotalforFinalPayment;
    }

    public void setSubtotalforFinalPayment(BigDecimal subtotalforFinalPayment) {
        this.subtotalforFinalPayment = subtotalforFinalPayment;
    }

    @Basic
    @Column(name = "SUBFOR_FINAL_PAYMENT_SPECIFIED", nullable = false)
    public Boolean getSubforFinalPaymentSpecified() {
        return subforFinalPaymentSpecified;
    }

    public void setSubforFinalPaymentSpecified(Boolean subforFinalPaymentSpecified) {
        this.subforFinalPaymentSpecified = subforFinalPaymentSpecified;
    }

    @Basic
    @Column(name = "TAXABLE_SUBTOTAL", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxableSubtotal() {
        return taxableSubtotal;
    }

    public void setTaxableSubtotal(BigDecimal taxableSubtotal) {
        this.taxableSubtotal = taxableSubtotal;
    }

    @Basic
    @Column(name = "V_A_T_RATEOR_LEVY_RATE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVatRateorLevyRate() {
        return vatRateorLevyRate;
    }

    public void setVatRateorLevyRate(String vatRateorLevyRate) {
        this.vatRateorLevyRate = vatRateorLevyRate;
    }

    @Basic
    @Column(name = "VEHICLEROUTINGLOCATION", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVehicleroutinglocation() {
        return vehicleroutinglocation;
    }

    public void setVehicleroutinglocation(String vehicleroutinglocation) {
        this.vehicleroutinglocation = vehicleroutinglocation;
    }

    @Basic
    @Column(name = "V_I_N", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVin() {
        return vin;
    }

    public void setVin(String vin) {
        this.vin = vin;
    }

    @Basic
    @Column(name = "IS_RELATED_B_D", nullable = false)
    public Boolean getIsRelatedBd() {
        return isRelatedBd;
    }

    public void setIsRelatedBd(Boolean isRelatedBd) {
        this.isRelatedBd = isRelatedBd;
    }

    @Basic
    @Column(name = "B_D_SUBTOTALFOR_FINAL_PAYMENT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getBdSubtotalforFinalPayment() {
        return bdSubtotalforFinalPayment;
    }

    public void setBdSubtotalforFinalPayment(BigDecimal bdSubtotalforFinalPayment) {
        this.bdSubtotalforFinalPayment = bdSubtotalforFinalPayment;
    }

    @Basic
    @Column(name = "OTHER_ITEM1", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOtherItem1() {
        return otherItem1;
    }

    public void setOtherItem1(String otherItem1) {
        this.otherItem1 = otherItem1;
    }

    @Basic
    @Column(name = "OTHER_ITEM1_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getOtherItem1Amount() {
        return otherItem1Amount;
    }

    public void setOtherItem1Amount(BigDecimal otherItem1Amount) {
        this.otherItem1Amount = otherItem1Amount;
    }

    @Basic
    @Column(name = "OTHER_ITEM2", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOtherItem2() {
        return otherItem2;
    }

    public void setOtherItem2(String otherItem2) {
        this.otherItem2 = otherItem2;
    }

    @Basic
    @Column(name = "OTHER_ITEM2_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getOtherItem2Amount() {
        return otherItem2Amount;
    }

    public void setOtherItem2Amount(BigDecimal otherItem2Amount) {
        this.otherItem2Amount = otherItem2Amount;
    }

    @Basic
    @Column(name = "OTHER_ITEM3", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOtherItem3() {
        return otherItem3;
    }

    public void setOtherItem3(String otherItem3) {
        this.otherItem3 = otherItem3;
    }

    @Basic
    @Column(name = "OTHER_ITEM3_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getOtherItem3Amount() {
        return otherItem3Amount;
    }

    public void setOtherItem3Amount(BigDecimal otherItem3Amount) {
        this.otherItem3Amount = otherItem3Amount;
    }

    @Basic
    @Column(name = "ORDERPLACEDDATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getOrderplaceddate() {
        return orderplaceddate;
    }

    public void setOrderplaceddate(Date orderplaceddate) {
        this.orderplaceddate = orderplaceddate;
    }

    @Basic
    @Column(name = "RESERVATION_ACCEPTED_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getReservationTermsAcceptedDate() {
        return reservationTermsAcceptedDate;
    }

    public void setReservationTermsAcceptedDate(Date reservationTermsAcceptedDate) {
        this.reservationTermsAcceptedDate = reservationTermsAcceptedDate;
    }

    @Basic
    @Column(name = "ACTUAL_DELIVERY_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getActualDeliveryDate() {
        return actualDeliveryDate;
    }

    public void setActualDeliveryDate(Date actualDeliveryDate) {
        this.actualDeliveryDate = actualDeliveryDate;
    }

    @Basic
    @Column(name = "DELIVERY_CONFIRMED_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getDeliveryConfirmedDate() {
        return deliveryConfirmedDate;
    }

    public void setDeliveryConfirmedDate(Date deliveryConfirmedDate) {
        this.deliveryConfirmedDate = deliveryConfirmedDate;
    }

    @Basic
    @Column(name = "GOVERNMENT_CLASSIFICATION", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGovernmentClassification() {
        return governmentClassification;
    }

    public void setGovernmentClassification(String governmentClassification) {
        this.governmentClassification = governmentClassification;
    }

    @Basic
    @Column(name = "CAPACITY", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCapacity() {
        return capacity;
    }

    public void setCapacity(String capacity) {
        this.capacity = capacity;
    }

    @Basic
    @Column(name = "MANUFACTURER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getManufacturer() {
        return manufacturer;
    }

    public void setManufacturer(String manufacturer) {
        this.manufacturer = manufacturer;
    }

    @Basic
    @Column(name = "BRANDAND_MODEL_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBrandandModelNumber() {
        return brandandModelNumber;
    }

    public void setBrandandModelNumber(String brandandModelNumber) {
        this.brandandModelNumber = brandandModelNumber;
    }

    @Basic
    @Column(name = "RECORD_STATUS", nullable = true)
    public Boolean getRecordStatus() {
        return recordStatus;
    }

    public void setRecordStatus(Boolean recordStatus) {
        this.recordStatus = recordStatus;
    }

    @Basic
    @Column(name = "OTHER_V_R_LS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getOtherVrLs() {
        return otherVrLs;
    }

    public void setOtherVrLs(String otherVrLs) {
        this.otherVrLs = otherVrLs;
    }

    @Basic
    @Column(name = "COMMISSIONABLE_STORE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCommissionableStore() {
        return commissionableStore;
    }

    public void setCommissionableStore(String commissionableStore) {
        this.commissionableStore = commissionableStore;
    }

    @Basic
    @Column(name = "FINANCE_PARTNER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFinancePartner() {
        return financePartner;
    }

    public void setFinancePartner(String financePartner) {
        this.financePartner = financePartner;
    }

    @Basic
    @Column(name = "STATUS_UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getStatusUpdateTime() {
        return statusUpdateTime;
    }

    public void setStatusUpdateTime(Date statusUpdateTime) {
        this.statusUpdateTime = statusUpdateTime;
    }

    @Basic
    @Column(name = "PRINTED_STATUS", nullable = true)
    public Boolean getPrintedStatus() {
        return printedStatus;
    }

    public void setPrintedStatus(Boolean printedStatus) {
        this.printedStatus = printedStatus;
    }

    @Basic
    @Column(name = "LAST_SYNC_V_R_L", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getLastSyncVrl() {
        return lastSyncVrl;
    }

    public void setLastSyncVrl(String lastSyncVrl) {
        this.lastSyncVrl = lastSyncVrl;
    }

    @Basic
    @Column(name = "UPDATE_BY", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "OTHER_B_DS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getOtherBDs() {
        return otherBDs;
    }

    public void setOtherBDs(String otherBDs) {
        this.otherBDs = otherBDs;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputInvoiceImported that = (OutputInvoiceImported) o;
        return subforFinalPaymentSpecified == that.subforFinalPaymentSpecified &&
                isRelatedBd == that.isRelatedBd &&
                Objects.equals(id, that.id) &&
                Objects.equals(entityCode, that.entityCode) &&
                Objects.equals(bdFapiaoEntity, that.bdFapiaoEntity) &&
                Objects.equals(cabinConfiguration, that.cabinConfiguration) &&
                Objects.equals(caseNumber, that.caseNumber) &&
                Objects.equals(ciqNumber, that.ciqNumber) &&
                Objects.equals(companyVatidTaxId, that.companyVatidTaxId) &&
                Objects.equals(deliveryStatus, that.deliveryStatus) &&
                Objects.equals(driverLicense, that.driverLicense) &&
                Objects.equals(importCertificateNumber, that.importCertificateNumber) &&
                Objects.equals(lastModifiedBy, that.lastModifiedBy) &&
                Objects.equals(modelSeries, that.modelSeries) &&
                Objects.equals(motorNumber, that.motorNumber) &&
                Objects.equals(organizationCode, that.organizationCode) &&
                Objects.equals(registrationLocalName, that.registrationLocalName) &&
                Objects.equals(subtotalforFinalPayment, that.subtotalforFinalPayment) &&
                Objects.equals(taxableSubtotal, that.taxableSubtotal) &&
                Objects.equals(vatRateorLevyRate, that.vatRateorLevyRate) &&
                Objects.equals(vehicleroutinglocation, that.vehicleroutinglocation) &&
                Objects.equals(vin, that.vin) &&
                Objects.equals(bdSubtotalforFinalPayment, that.bdSubtotalforFinalPayment) &&
                Objects.equals(otherItem1, that.otherItem1) &&
                Objects.equals(otherItem1Amount, that.otherItem1Amount) &&
                Objects.equals(otherItem2, that.otherItem2) &&
                Objects.equals(otherItem2Amount, that.otherItem2Amount) &&
                Objects.equals(otherItem3, that.otherItem3) &&
                Objects.equals(otherItem3Amount, that.otherItem3Amount) &&
                Objects.equals(orderplaceddate, that.orderplaceddate) &&
                Objects.equals(reservationTermsAcceptedDate, that.reservationTermsAcceptedDate) &&
                Objects.equals(actualDeliveryDate, that.actualDeliveryDate) &&
                Objects.equals(deliveryConfirmedDate, that.deliveryConfirmedDate) &&
                Objects.equals(governmentClassification, that.governmentClassification) &&
                Objects.equals(capacity, that.capacity) &&
                Objects.equals(manufacturer, that.manufacturer) &&
                Objects.equals(brandandModelNumber, that.brandandModelNumber) &&
                Objects.equals(recordStatus, that.recordStatus) &&
                Objects.equals(otherVrLs, that.otherVrLs) &&
                Objects.equals(commissionableStore, that.commissionableStore) &&
                Objects.equals(financePartner, that.financePartner) &&
                Objects.equals(statusUpdateTime, that.statusUpdateTime) &&
                Objects.equals(printedStatus, that.printedStatus) &&
                Objects.equals(lastSyncVrl, that.lastSyncVrl) &&
                Objects.equals(updateBy, that.updateBy) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(otherBDs, that.otherBDs);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, entityCode, bdFapiaoEntity, cabinConfiguration, caseNumber, ciqNumber, companyVatidTaxId, deliveryStatus, driverLicense, importCertificateNumber, lastModifiedBy, modelSeries, motorNumber, organizationCode, registrationLocalName, subtotalforFinalPayment, subforFinalPaymentSpecified, taxableSubtotal, vatRateorLevyRate, vehicleroutinglocation, vin, isRelatedBd, bdSubtotalforFinalPayment, otherItem1, otherItem1Amount, otherItem2, otherItem2Amount, otherItem3, otherItem3Amount, orderplaceddate, reservationTermsAcceptedDate, actualDeliveryDate, deliveryConfirmedDate, governmentClassification, capacity, manufacturer, brandandModelNumber, recordStatus, otherVrLs, commissionableStore, financePartner, statusUpdateTime, printedStatus, lastSyncVrl, updateBy, createTime, updateTime, otherBDs);
    }
}
