package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "OUTPUT_INVOICE_MODEL_MAPPING", schema = PROJECT_ADMIN, catalog = "")
public class OutputInvoiceModelMapping {
    private String id;
    private String modelSeries;
    private String cabinConfiguration;
    private String makeAndModel;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "MODEL_SERIES", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getModelSeries() {
        return modelSeries;
    }

    public void setModelSeries(String modelSeries) {
        this.modelSeries = modelSeries;
    }

    @Basic
    @Column(name = "CABIN_CONFIGURATION", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCabinConfiguration() {
        return cabinConfiguration;
    }

    public void setCabinConfiguration(String cabinConfiguration) {
        this.cabinConfiguration = cabinConfiguration;
    }

    @Basic
    @Column(name = "MAKE_AND_MODEL", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMakeAndModel() {
        return makeAndModel;
    }

    public void setMakeAndModel(String makeAndModel) {
        this.makeAndModel = makeAndModel;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputInvoiceModelMapping that = (OutputInvoiceModelMapping) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(modelSeries, that.modelSeries) &&
                Objects.equals(cabinConfiguration, that.cabinConfiguration) &&
                Objects.equals(makeAndModel, that.makeAndModel);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, modelSeries, cabinConfiguration, makeAndModel);
    }
}
