package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_INVOICE_PAYMENT_DETAIL", schema = PROJECT_ADMIN, catalog = "")
public class OutputInvoicePaymentDetail {
    private String id;
    private String caseNumber;
    private BigDecimal paymentAmount;
    private Date paymentDate;
    private String payorName;
    private Date createTime;
    private Date updateTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CASE_NUMBER", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCaseNumber() {
        return caseNumber;
    }

    public void setCaseNumber(String caseNumber) {
        this.caseNumber = caseNumber;
    }

    @Basic
    @Column(name = "PAYMENT_AMOUNT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getPaymentAmount() {
        return paymentAmount;
    }

    public void setPaymentAmount(BigDecimal paymentAmount) {
        this.paymentAmount = paymentAmount;
    }

    @Basic
    @Column(name = "PAYMENT_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getPaymentDate() {
        return paymentDate;
    }

    public void setPaymentDate(Date paymentDate) {
        this.paymentDate = paymentDate;
    }

    @Basic
    @Column(name = "PAYOR_NAME", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPayorName() {
        return payorName;
    }

    public void setPayorName(String payorName) {
        this.payorName = payorName;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputInvoicePaymentDetail that = (OutputInvoicePaymentDetail) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(caseNumber, that.caseNumber) &&
                Objects.equals(paymentAmount, that.paymentAmount) &&
                Objects.equals(paymentDate, that.paymentDate) &&
                Objects.equals(payorName, that.payorName) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, caseNumber, paymentAmount, paymentDate, payorName, createTime, updateTime);
    }
}
