package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_INVOICE_PRINTED", schema = PROJECT_ADMIN, catalog = "")
public class OutputInvoicePrinted {
    private String id;
    private String bdFapiaoEntity;
    private String registrationLocalName;
    private String buyerIdOrCode;
    private String organizationCode;
    private String companyVatidTaxId;
    private Boolean issuranceType;
    private String category;
    private String vehicleModel;
    private String cabinConfiguration;
    private String caseNumber;
    private String producingPlace;
    private String certificateNumber;
    private String importCertificateNumber;
    private String ciqNumber;
    private String motorNumber;
    private String vin;
    private BigDecimal subtotalforFinalPayment;
    private String subtotalforFinalPaymentCh;
    private String invoiceCode;
    private String invoiceNumber;
    private String salesUnitName;
    private String salesUnitPhoneNumber;
    private String salesTaxPayerNumber;
    private String salesAccount;
    private String salesAddress;
    private String salesBankName;
    private String vatRateorLevyRate;
    private BigDecimal taxableSubtotal;
    private String mainTaxAuthoritiesCode;
    private BigDecimal excludeTaxPrice;
    private BigDecimal vatTax;
    private String taxPaymentCertificateNumber;
    private String tonnage;
    private Boolean invoiceStatus;
    private Date createTime;
    private Date updateTime;
    private Boolean bdStatus;
    private Boolean gdBdStatus;
    private String gdIssuedId;
    private Date caseCollectionDate;
    private Date bdIssuedDate;
    private String governmentClassification;
    private String capacity;
    private String manufacturer;
    private String brandandModelNumber;
    private String vehicleroutinglocation;
    private String deliveryStatus;
    private Boolean printedType;
    private String taxControlDiskId;
    private String printedUser;
    private String machineNo;
    private Boolean isBdRed;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "B_D_FAPIAO_ENTITY", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBdFapiaoEntity() {
        return bdFapiaoEntity;
    }

    public void setBdFapiaoEntity(String bdFapiaoEntity) {
        this.bdFapiaoEntity = bdFapiaoEntity;
    }

    @Basic
    @Column(name = "REGISTRATION_LOCAL_NAME", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRegistrationLocalName() {
        return registrationLocalName;
    }

    public void setRegistrationLocalName(String registrationLocalName) {
        this.registrationLocalName = registrationLocalName;
    }

    @Basic
    @Column(name = "BUYER_ID_OR_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBuyerIdOrCode() {
        return buyerIdOrCode;
    }

    public void setBuyerIdOrCode(String buyerIdOrCode) {
        this.buyerIdOrCode = buyerIdOrCode;
    }

    @Basic
    @Column(name = "ORGANIZATION_CODE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationCode() {
        return organizationCode;
    }

    public void setOrganizationCode(String organizationCode) {
        this.organizationCode = organizationCode;
    }

    @Basic
    @Column(name = "COMPANY_V_A_T_ID_TAX_ID", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCompanyVatidTaxId() {
        return companyVatidTaxId;
    }

    public void setCompanyVatidTaxId(String companyVatidTaxId) {
        this.companyVatidTaxId = companyVatidTaxId;
    }

    @Basic
    @Column(name = "ISSURANCE_TYPE", nullable = true)
    public Boolean getIssuranceType() {
        return issuranceType;
    }

    public void setIssuranceType(Boolean issuranceType) {
        this.issuranceType = issuranceType;
    }

    @Basic
    @Column(name = "CATEGORY", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    @Basic
    @Column(name = "VEHICLE_MODEL", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVehicleModel() {
        return vehicleModel;
    }

    public void setVehicleModel(String vehicleModel) {
        this.vehicleModel = vehicleModel;
    }

    @Basic
    @Column(name = "CABIN_CONFIGURATION", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCabinConfiguration() {
        return cabinConfiguration;
    }

    public void setCabinConfiguration(String cabinConfiguration) {
        this.cabinConfiguration = cabinConfiguration;
    }

    @Basic
    @Column(name = "CASE_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCaseNumber() {
        return caseNumber;
    }

    public void setCaseNumber(String caseNumber) {
        this.caseNumber = caseNumber;
    }

    @Basic
    @Column(name = "PRODUCING_PLACE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getProducingPlace() {
        return producingPlace;
    }

    public void setProducingPlace(String producingPlace) {
        this.producingPlace = producingPlace;
    }

    @Basic
    @Column(name = "CERTIFICATE_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCertificateNumber() {
        return certificateNumber;
    }

    public void setCertificateNumber(String certificateNumber) {
        this.certificateNumber = certificateNumber;
    }

    @Basic
    @Column(name = "IMPORT_CERTIFICATE_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getImportCertificateNumber() {
        return importCertificateNumber;
    }

    public void setImportCertificateNumber(String importCertificateNumber) {
        this.importCertificateNumber = importCertificateNumber;
    }

    @Basic
    @Column(name = "C_I_Q_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCiqNumber() {
        return ciqNumber;
    }

    public void setCiqNumber(String ciqNumber) {
        this.ciqNumber = ciqNumber;
    }

    @Basic
    @Column(name = "MOTOR_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMotorNumber() {
        return motorNumber;
    }

    public void setMotorNumber(String motorNumber) {
        this.motorNumber = motorNumber;
    }

    @Basic
    @Column(name = "V_I_N", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVin() {
        return vin;
    }

    public void setVin(String vin) {
        this.vin = vin;
    }

    @Basic
    @Column(name = "SUBTOTALFOR_FINAL_PAYMENT", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getSubtotalforFinalPayment() {
        return subtotalforFinalPayment;
    }

    public void setSubtotalforFinalPayment(BigDecimal subtotalforFinalPayment) {
        this.subtotalforFinalPayment = subtotalforFinalPayment;
    }

    @Basic
    @Column(name = "SUBTOTALFOR_FINAL_PAYMENT_C_H", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSubtotalforFinalPaymentCh() {
        return subtotalforFinalPaymentCh;
    }

    public void setSubtotalforFinalPaymentCh(String subtotalforFinalPaymentCh) {
        this.subtotalforFinalPaymentCh = subtotalforFinalPaymentCh;
    }

    @Basic
    @Column(name = "INVOICE_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceCode() {
        return invoiceCode;
    }

    public void setInvoiceCode(String invoiceCode) {
        this.invoiceCode = invoiceCode;
    }

    @Basic
    @Column(name = "INVOICE_NUMBER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getInvoiceNumber() {
        return invoiceNumber;
    }

    public void setInvoiceNumber(String invoiceNumber) {
        this.invoiceNumber = invoiceNumber;
    }

    @Basic
    @Column(name = "SALES_UNIT_NAME", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSalesUnitName() {
        return salesUnitName;
    }

    public void setSalesUnitName(String salesUnitName) {
        this.salesUnitName = salesUnitName;
    }

    @Basic
    @Column(name = "SALES_UNIT_PHONE_NUMBER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSalesUnitPhoneNumber() {
        return salesUnitPhoneNumber;
    }

    public void setSalesUnitPhoneNumber(String salesUnitPhoneNumber) {
        this.salesUnitPhoneNumber = salesUnitPhoneNumber;
    }

    @Basic
    @Column(name = "SALES_TAX_PAYER_NUMBER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSalesTaxPayerNumber() {
        return salesTaxPayerNumber;
    }

    public void setSalesTaxPayerNumber(String salesTaxPayerNumber) {
        this.salesTaxPayerNumber = salesTaxPayerNumber;
    }

    @Basic
    @Column(name = "SALES_ACCOUNT", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSalesAccount() {
        return salesAccount;
    }

    public void setSalesAccount(String salesAccount) {
        this.salesAccount = salesAccount;
    }

    @Basic
    @Column(name = "SALES_ADDRESS", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSalesAddress() {
        return salesAddress;
    }

    public void setSalesAddress(String salesAddress) {
        this.salesAddress = salesAddress;
    }

    @Basic
    @Column(name = "SALES_BANK_NAME", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSalesBankName() {
        return salesBankName;
    }

    public void setSalesBankName(String salesBankName) {
        this.salesBankName = salesBankName;
    }

    @Basic
    @Column(name = "V_A_T_RATEOR_LEVY_RATE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVatRateorLevyRate() {
        return vatRateorLevyRate;
    }

    public void setVatRateorLevyRate(String vatRateorLevyRate) {
        this.vatRateorLevyRate = vatRateorLevyRate;
    }

    @Basic
    @Column(name = "TAXABLE_SUBTOTAL", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxableSubtotal() {
        return taxableSubtotal;
    }

    public void setTaxableSubtotal(BigDecimal taxableSubtotal) {
        this.taxableSubtotal = taxableSubtotal;
    }

    @Basic
    @Column(name = "MAIN_TAX_AUTHORITIES_CODE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMainTaxAuthoritiesCode() {
        return mainTaxAuthoritiesCode;
    }

    public void setMainTaxAuthoritiesCode(String mainTaxAuthoritiesCode) {
        this.mainTaxAuthoritiesCode = mainTaxAuthoritiesCode;
    }

    @Basic
    @Column(name = "EXCLUDE_TAX_PRICE", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getExcludeTaxPrice() {
        return excludeTaxPrice;
    }

    public void setExcludeTaxPrice(BigDecimal excludeTaxPrice) {
        this.excludeTaxPrice = excludeTaxPrice;
    }

    @Basic
    @Column(name = "VAT_TAX", nullable = true, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getVatTax() {
        return vatTax;
    }

    public void setVatTax(BigDecimal vatTax) {
        this.vatTax = vatTax;
    }

    @Basic
    @Column(name = "TAX_PAYMENT_CERTIFICATE_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxPaymentCertificateNumber() {
        return taxPaymentCertificateNumber;
    }

    public void setTaxPaymentCertificateNumber(String taxPaymentCertificateNumber) {
        this.taxPaymentCertificateNumber = taxPaymentCertificateNumber;
    }

    @Basic
    @Column(name = "TONNAGE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTonnage() {
        return tonnage;
    }

    public void setTonnage(String tonnage) {
        this.tonnage = tonnage;
    }

    @Basic
    @Column(name = "INVOICE_STATUS", nullable = false)
    public Boolean getInvoiceStatus() {
        return invoiceStatus;
    }

    public void setInvoiceStatus(Boolean invoiceStatus) {
        this.invoiceStatus = invoiceStatus;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "BD_STATUS", nullable = true)
    public Boolean getBdStatus() {
        return bdStatus;
    }

    public void setBdStatus(Boolean bdStatus) {
        this.bdStatus = bdStatus;
    }

    @Basic
    @Column(name = "GD_BD_STATUS", nullable = true)
    public Boolean getGdBdStatus() {
        return gdBdStatus;
    }

    public void setGdBdStatus(Boolean gdBdStatus) {
        this.gdBdStatus = gdBdStatus;
    }

    @Basic
    @Column(name = "GD_ISSUED_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGdIssuedId() {
        return gdIssuedId;
    }

    public void setGdIssuedId(String gdIssuedId) {
        this.gdIssuedId = gdIssuedId;
    }

    @Basic
    @Column(name = "CASE_COLLECTION_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCaseCollectionDate() {
        return caseCollectionDate;
    }

    public void setCaseCollectionDate(Date caseCollectionDate) {
        this.caseCollectionDate = caseCollectionDate;
    }

    @Basic
    @Column(name = "B_D_ISSUED_DATE", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getBdIssuedDate() {
        return bdIssuedDate;
    }

    public void setBdIssuedDate(Date bdIssuedDate) {
        this.bdIssuedDate = bdIssuedDate;
    }

    @Basic
    @Column(name = "GOVERNMENT_CLASSIFICATION", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getGovernmentClassification() {
        return governmentClassification;
    }

    public void setGovernmentClassification(String governmentClassification) {
        this.governmentClassification = governmentClassification;
    }

    @Basic
    @Column(name = "CAPACITY", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCapacity() {
        return capacity;
    }

    public void setCapacity(String capacity) {
        this.capacity = capacity;
    }

    @Basic
    @Column(name = "MANUFACTURER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getManufacturer() {
        return manufacturer;
    }

    public void setManufacturer(String manufacturer) {
        this.manufacturer = manufacturer;
    }

    @Basic
    @Column(name = "BRANDAND_MODEL_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBrandandModelNumber() {
        return brandandModelNumber;
    }

    public void setBrandandModelNumber(String brandandModelNumber) {
        this.brandandModelNumber = brandandModelNumber;
    }

    @Basic
    @Column(name = "VEHICLEROUTINGLOCATION", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVehicleroutinglocation() {
        return vehicleroutinglocation;
    }

    public void setVehicleroutinglocation(String vehicleroutinglocation) {
        this.vehicleroutinglocation = vehicleroutinglocation;
    }

    @Basic
    @Column(name = "DELIVERY_STATUS", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDeliveryStatus() {
        return deliveryStatus;
    }

    public void setDeliveryStatus(String deliveryStatus) {
        this.deliveryStatus = deliveryStatus;
    }

    @Basic
    @Column(name = "PRINTED_TYPE", nullable = false)
    public Boolean getPrintedType() {
        return printedType;
    }

    public void setPrintedType(Boolean printedType) {
        this.printedType = printedType;
    }

    @Basic
    @Column(name = "TAX_CONTROL_DISK_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxControlDiskId() {
        return taxControlDiskId;
    }

    public void setTaxControlDiskId(String taxControlDiskId) {
        this.taxControlDiskId = taxControlDiskId;
    }

    @Basic
    @Column(name = "PRINTED_USER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPrintedUser() {
        return printedUser;
    }

    public void setPrintedUser(String printedUser) {
        this.printedUser = printedUser;
    }

    @Basic
    @Column(name = "MACHINE_NO", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMachineNo() {
        return machineNo;
    }

    public void setMachineNo(String machineNo) {
        this.machineNo = machineNo;
    }

    @Basic
    @Column(name = "IS_B_D_RED", nullable = false)
    public Boolean getIsBdRed() {
        return isBdRed;
    }

    public void setIsBdRed(Boolean isBdRed) {
        this.isBdRed = isBdRed;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputInvoicePrinted that = (OutputInvoicePrinted) o;
        return invoiceStatus == that.invoiceStatus &&
                printedType == that.printedType &&
                isBdRed == that.isBdRed &&
                Objects.equals(id, that.id) &&
                Objects.equals(bdFapiaoEntity, that.bdFapiaoEntity) &&
                Objects.equals(registrationLocalName, that.registrationLocalName) &&
                Objects.equals(buyerIdOrCode, that.buyerIdOrCode) &&
                Objects.equals(organizationCode, that.organizationCode) &&
                Objects.equals(companyVatidTaxId, that.companyVatidTaxId) &&
                Objects.equals(issuranceType, that.issuranceType) &&
                Objects.equals(category, that.category) &&
                Objects.equals(vehicleModel, that.vehicleModel) &&
                Objects.equals(cabinConfiguration, that.cabinConfiguration) &&
                Objects.equals(caseNumber, that.caseNumber) &&
                Objects.equals(producingPlace, that.producingPlace) &&
                Objects.equals(certificateNumber, that.certificateNumber) &&
                Objects.equals(importCertificateNumber, that.importCertificateNumber) &&
                Objects.equals(ciqNumber, that.ciqNumber) &&
                Objects.equals(motorNumber, that.motorNumber) &&
                Objects.equals(vin, that.vin) &&
                Objects.equals(subtotalforFinalPayment, that.subtotalforFinalPayment) &&
                Objects.equals(subtotalforFinalPaymentCh, that.subtotalforFinalPaymentCh) &&
                Objects.equals(invoiceCode, that.invoiceCode) &&
                Objects.equals(invoiceNumber, that.invoiceNumber) &&
                Objects.equals(salesUnitName, that.salesUnitName) &&
                Objects.equals(salesUnitPhoneNumber, that.salesUnitPhoneNumber) &&
                Objects.equals(salesTaxPayerNumber, that.salesTaxPayerNumber) &&
                Objects.equals(salesAccount, that.salesAccount) &&
                Objects.equals(salesAddress, that.salesAddress) &&
                Objects.equals(salesBankName, that.salesBankName) &&
                Objects.equals(vatRateorLevyRate, that.vatRateorLevyRate) &&
                Objects.equals(taxableSubtotal, that.taxableSubtotal) &&
                Objects.equals(mainTaxAuthoritiesCode, that.mainTaxAuthoritiesCode) &&
                Objects.equals(excludeTaxPrice, that.excludeTaxPrice) &&
                Objects.equals(vatTax, that.vatTax) &&
                Objects.equals(taxPaymentCertificateNumber, that.taxPaymentCertificateNumber) &&
                Objects.equals(tonnage, that.tonnage) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(bdStatus, that.bdStatus) &&
                Objects.equals(gdBdStatus, that.gdBdStatus) &&
                Objects.equals(gdIssuedId, that.gdIssuedId) &&
                Objects.equals(caseCollectionDate, that.caseCollectionDate) &&
                Objects.equals(bdIssuedDate, that.bdIssuedDate) &&
                Objects.equals(governmentClassification, that.governmentClassification) &&
                Objects.equals(capacity, that.capacity) &&
                Objects.equals(manufacturer, that.manufacturer) &&
                Objects.equals(brandandModelNumber, that.brandandModelNumber) &&
                Objects.equals(vehicleroutinglocation, that.vehicleroutinglocation) &&
                Objects.equals(deliveryStatus, that.deliveryStatus) &&
                Objects.equals(taxControlDiskId, that.taxControlDiskId) &&
                Objects.equals(printedUser, that.printedUser) &&
                Objects.equals(machineNo, that.machineNo);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, bdFapiaoEntity, registrationLocalName, buyerIdOrCode, organizationCode, companyVatidTaxId, issuranceType, category, vehicleModel, cabinConfiguration, caseNumber, producingPlace, certificateNumber, importCertificateNumber, ciqNumber, motorNumber, vin, subtotalforFinalPayment, subtotalforFinalPaymentCh, invoiceCode, invoiceNumber, salesUnitName, salesUnitPhoneNumber, salesTaxPayerNumber, salesAccount, salesAddress, salesBankName, vatRateorLevyRate, taxableSubtotal, mainTaxAuthoritiesCode, excludeTaxPrice, vatTax, taxPaymentCertificateNumber, tonnage, invoiceStatus, createTime, updateTime, bdStatus, gdBdStatus, gdIssuedId, caseCollectionDate, bdIssuedDate, governmentClassification, capacity, manufacturer, brandandModelNumber, vehicleroutinglocation, deliveryStatus, printedType, taxControlDiskId, printedUser, machineNo, isBdRed);
    }
}
