package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_INVOICE_PRINTED_REASON", schema = PROJECT_ADMIN, catalog = "")
public class OutputInvoicePrintedReason {
    private String id;
    private String outputInvoicePrintedId;
    private String outputInvoiceUpdateReasonId;
    private String createBy;
    private Date createTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "OUTPUT_INVOICE_PRINTED_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOutputInvoicePrintedId() {
        return outputInvoicePrintedId;
    }

    public void setOutputInvoicePrintedId(String outputInvoicePrintedId) {
        this.outputInvoicePrintedId = outputInvoicePrintedId;
    }

    @Basic
    @Column(name = "OUTINV_UPDATE_REASON_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOutputInvoiceUpdateReasonId() {
        return outputInvoiceUpdateReasonId;
    }

    public void setOutputInvoiceUpdateReasonId(String outputInvoiceUpdateReasonId) {
        this.outputInvoiceUpdateReasonId = outputInvoiceUpdateReasonId;
    }

    @Basic
    @Column(name = "CREATE_BY", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputInvoicePrintedReason that = (OutputInvoicePrintedReason) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(outputInvoicePrintedId, that.outputInvoicePrintedId) &&
                Objects.equals(outputInvoiceUpdateReasonId, that.outputInvoiceUpdateReasonId) &&
                Objects.equals(createBy, that.createBy) &&
                Objects.equals(createTime, that.createTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, outputInvoicePrintedId, outputInvoiceUpdateReasonId, createBy, createTime);
    }
}
