package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_INVOICE_REASON", schema = PROJECT_ADMIN, catalog = "")
public class OutputInvoiceReason {
    private String id;
    private String englishName;
    private String chineseName;
    private Boolean type;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ENGLISH_NAME", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getEnglishName() {
        return englishName;
    }

    public void setEnglishName(String englishName) {
        this.englishName = englishName;
    }

    @Basic
    @Column(name = "CHINESE_NAME", nullable = false, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getChineseName() {
        return chineseName;
    }

    public void setChineseName(String chineseName) {
        this.chineseName = chineseName;
    }

    @Basic
    @Column(name = "TYPE", nullable = false)
    public Boolean getType() {
        return type;
    }

    public void setType(Boolean type) {
        this.type = type;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputInvoiceReason that = (OutputInvoiceReason) o;
        return type == that.type &&
                Objects.equals(id, that.id) &&
                Objects.equals(englishName, that.englishName) &&
                Objects.equals(chineseName, that.chineseName);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, englishName, chineseName, type);
    }
}
