package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "OUTPUT_RECONCILIATION_CONFIG", schema = PROJECT_ADMIN, catalog = "")
public class OutputReconciliationConfig {
    private String id;
    private String ruleNo;
    private String category;
    private Boolean tag;
    private Boolean status;
    private String preVoucherNumber;
    private String journalKeywords;
    private String postedBy;
    private String vehicleNumber;
    private BigDecimal taxRate;
    private String fapiaoKeywords;
    private Boolean purchaserTesla;
    private Boolean sellerTesla;
    private BigDecimal fapiaoTaxRate;
    private String creator;
    private Date createTime;
    private String updater;
    private Date updateTime;
    private Date activeStartTime;
    private Date activeEndTime;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "RULE_N_O", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getRuleNo() {
        return ruleNo;
    }

    public void setRuleNo(String ruleNo) {
        this.ruleNo = ruleNo;
    }

    @Basic
    @Column(name = "CATEGORY", nullable = false, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    @Basic
    @Column(name = "TAG", nullable = false)
    public Boolean getTag() {
        return tag;
    }

    public void setTag(Boolean tag) {
        this.tag = tag;
    }

    @Basic
    @Column(name = "STATUS", nullable = false)
    public Boolean getStatus() {
        return status;
    }

    public void setStatus(Boolean status) {
        this.status = status;
    }

    @Basic
    @Column(name = "PRE_VOUCHER_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPreVoucherNumber() {
        return preVoucherNumber;
    }

    public void setPreVoucherNumber(String preVoucherNumber) {
        this.preVoucherNumber = preVoucherNumber;
    }

    @Basic
    @Column(name = "JOURNAL_KEYWORDS", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getJournalKeywords() {
        return journalKeywords;
    }

    public void setJournalKeywords(String journalKeywords) {
        this.journalKeywords = journalKeywords;
    }

    @Basic
    @Column(name = "POSTED_BY", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getPostedBy() {
        return postedBy;
    }

    public void setPostedBy(String postedBy) {
        this.postedBy = postedBy;
    }

    @Basic
    @Column(name = "VEHICLE_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getVehicleNumber() {
        return vehicleNumber;
    }

    public void setVehicleNumber(String vehicleNumber) {
        this.vehicleNumber = vehicleNumber;
    }

    @Basic
    @Column(name = "TAX_RATE", nullable = false, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getTaxRate() {
        return taxRate;
    }

    public void setTaxRate(BigDecimal taxRate) {
        this.taxRate = taxRate;
    }

    @Basic
    @Column(name = "FAPIAO_KEYWORDS", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFapiaoKeywords() {
        return fapiaoKeywords;
    }

    public void setFapiaoKeywords(String fapiaoKeywords) {
        this.fapiaoKeywords = fapiaoKeywords;
    }

    @Basic
    @Column(name = "PURCHASER_TESLA", nullable = true)
    public Boolean getPurchaserTesla() {
        return purchaserTesla;
    }

    public void setPurchaserTesla(Boolean purchaserTesla) {
        this.purchaserTesla = purchaserTesla;
    }

    @Basic
    @Column(name = "SELLER_TESLA", nullable = true)
    public Boolean getSellerTesla() {
        return sellerTesla;
    }

    public void setSellerTesla(Boolean sellerTesla) {
        this.sellerTesla = sellerTesla;
    }

    @Basic
    @Column(name = "FAPIAO_TAX_RATE", nullable = false, precision = 4)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiaoTaxRate() {
        return fapiaoTaxRate;
    }

    public void setFapiaoTaxRate(BigDecimal fapiaoTaxRate) {
        this.fapiaoTaxRate = fapiaoTaxRate;
    }

    @Basic
    @Column(name = "CREATOR", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATER", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getUpdater() {
        return updater;
    }

    public void setUpdater(String updater) {
        this.updater = updater;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "ACTIVE_START_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getActiveStartTime() {
        return activeStartTime;
    }

    public void setActiveStartTime(Date activeStartTime) {
        this.activeStartTime = activeStartTime;
    }

    @Basic
    @Column(name = "ACTIVE_END_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getActiveEndTime() {
        return activeEndTime;
    }

    public void setActiveEndTime(Date activeEndTime) {
        this.activeEndTime = activeEndTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        OutputReconciliationConfig that = (OutputReconciliationConfig) o;
        return tag == that.tag &&
                status == that.status &&
                Objects.equals(id, that.id) &&
                Objects.equals(ruleNo, that.ruleNo) &&
                Objects.equals(category, that.category) &&
                Objects.equals(preVoucherNumber, that.preVoucherNumber) &&
                Objects.equals(journalKeywords, that.journalKeywords) &&
                Objects.equals(postedBy, that.postedBy) &&
                Objects.equals(vehicleNumber, that.vehicleNumber) &&
                Objects.equals(taxRate, that.taxRate) &&
                Objects.equals(fapiaoKeywords, that.fapiaoKeywords) &&
                Objects.equals(purchaserTesla, that.purchaserTesla) &&
                Objects.equals(sellerTesla, that.sellerTesla) &&
                Objects.equals(fapiaoTaxRate, that.fapiaoTaxRate) &&
                Objects.equals(creator, that.creator) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updater, that.updater) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(activeStartTime, that.activeStartTime) &&
                Objects.equals(activeEndTime, that.activeEndTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, ruleNo, category, tag, status, preVoucherNumber, journalKeywords, postedBy, vehicleNumber, taxRate, fapiaoKeywords, purchaserTesla, sellerTesla, fapiaoTaxRate, creator, createTime, updater, updateTime, activeStartTime, activeEndTime);
    }
}
