package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "PRODUCT_ITEM", schema = PROJECT_ADMIN, catalog = "")
public class ProductItem {
    private String id;
    private String fSetCode;
    private String fSetName;
    private String fAcctCode;
    private String fAcctName;
    private String fAcctClass;
    private String fAcctAttr;
    private String fcjje;
    private String bjsjzye;
    private String fyszt;
    private String fStartYear;
    private String fStartMonth;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "F_SET_CODE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getfSetCode() {
        return fSetCode;
    }

    public void setfSetCode(String fSetCode) {
        this.fSetCode = fSetCode;
    }

    @Basic
    @Column(name = "F_SET_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getfSetName() {
        return fSetName;
    }

    public void setfSetName(String fSetName) {
        this.fSetName = fSetName;
    }

    @Basic
    @Column(name = "F_ACCT_CODE", nullable = true, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getfAcctCode() {
        return fAcctCode;
    }

    public void setfAcctCode(String fAcctCode) {
        this.fAcctCode = fAcctCode;
    }

    @Basic
    @Column(name = "F_ACCT_NAME", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getfAcctName() {
        return fAcctName;
    }

    public void setfAcctName(String fAcctName) {
        this.fAcctName = fAcctName;
    }

    @Basic
    @Column(name = "F_ACCT_CLASS", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getfAcctClass() {
        return fAcctClass;
    }

    public void setfAcctClass(String fAcctClass) {
        this.fAcctClass = fAcctClass;
    }

    @Basic
    @Column(name = "F_ACCT_ATTR", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getfAcctAttr() {
        return fAcctAttr;
    }

    public void setfAcctAttr(String fAcctAttr) {
        this.fAcctAttr = fAcctAttr;
    }

    @Basic
    @Column(name = "F_C_J_J_E", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFcjje() {
        return fcjje;
    }

    public void setFcjje(String fcjje) {
        this.fcjje = fcjje;
    }

    @Basic
    @Column(name = "B_J_S_J_Z_Y_E", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getBjsjzye() {
        return bjsjzye;
    }

    public void setBjsjzye(String bjsjzye) {
        this.bjsjzye = bjsjzye;
    }

    @Basic
    @Column(name = "F_Y_S_Z_T", nullable = true, length = 20)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getFyszt() {
        return fyszt;
    }

    public void setFyszt(String fyszt) {
        this.fyszt = fyszt;
    }

    @Basic
    @Column(name = "F_START_YEAR", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getfStartYear() {
        return fStartYear;
    }

    public void setfStartYear(String fStartYear) {
        this.fStartYear = fStartYear;
    }

    @Basic
    @Column(name = "F_START_MONTH", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getfStartMonth() {
        return fStartMonth;
    }

    public void setfStartMonth(String fStartMonth) {
        this.fStartMonth = fStartMonth;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ProductItem that = (ProductItem) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(fSetCode, that.fSetCode) &&
                Objects.equals(fSetName, that.fSetName) &&
                Objects.equals(fAcctCode, that.fAcctCode) &&
                Objects.equals(fAcctName, that.fAcctName) &&
                Objects.equals(fAcctClass, that.fAcctClass) &&
                Objects.equals(fAcctAttr, that.fAcctAttr) &&
                Objects.equals(fcjje, that.fcjje) &&
                Objects.equals(bjsjzye, that.bjsjzye) &&
                Objects.equals(fyszt, that.fyszt) &&
                Objects.equals(fStartYear, that.fStartYear) &&
                Objects.equals(fStartMonth, that.fStartMonth);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, fSetCode, fSetName, fAcctCode, fAcctName, fAcctClass, fAcctAttr, fcjje, bjsjzye, fyszt, fStartYear, fStartMonth);
    }
}
