package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "RECONCILIATION_ENTITY_OVERVIEW", schema = PROJECT_ADMIN, catalog = "")
public class ReconciliationEntityOverview {
    private String id;
    private String organizationId;
    private String organizationCode;
    private String organizationName;
    private BigDecimal axReportA1;
    private BigDecimal axReportA2;
    private BigDecimal axReportA3;
    private BigDecimal axReportA4;
    private BigDecimal axReportB1;
    private BigDecimal axReportB2;
    private BigDecimal axReportB3;
    private BigDecimal axReportB4;
    private BigDecimal axReportC1;
    private BigDecimal axReportC2;
    private BigDecimal axReportC3;
    private BigDecimal axReportC4;
    private BigDecimal axReportC5;
    private BigDecimal fapiao17A1;
    private BigDecimal fapiao6A1;
    private BigDecimal fapiao17A2;
    private BigDecimal fapiao6A2;
    private BigDecimal fapiao17E1;
    private BigDecimal fapiao6E2;
    private Boolean period;
    private Integer year;
    private Date updateTime;
    private BigDecimal fapiao17B;
    private BigDecimal fapiao6B;
    private BigDecimal fapiao17E;
    private BigDecimal fapiao6E;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "ORGANIZATION_CODE", nullable = false, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationCode() {
        return organizationCode;
    }

    public void setOrganizationCode(String organizationCode) {
        this.organizationCode = organizationCode;
    }

    @Basic
    @Column(name = "ORGANIZATION_NAME", nullable = false, length = 100)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationName() {
        return organizationName;
    }

    public void setOrganizationName(String organizationName) {
        this.organizationName = organizationName;
    }

    @Basic
    @Column(name = "A_X_REPORT_A1", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportA1() {
        return axReportA1;
    }

    public void setAxReportA1(BigDecimal axReportA1) {
        this.axReportA1 = axReportA1;
    }

    @Basic
    @Column(name = "A_X_REPORT_A2", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportA2() {
        return axReportA2;
    }

    public void setAxReportA2(BigDecimal axReportA2) {
        this.axReportA2 = axReportA2;
    }

    @Basic
    @Column(name = "A_X_REPORT_A3", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportA3() {
        return axReportA3;
    }

    public void setAxReportA3(BigDecimal axReportA3) {
        this.axReportA3 = axReportA3;
    }

    @Basic
    @Column(name = "A_X_REPORT_A4", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportA4() {
        return axReportA4;
    }

    public void setAxReportA4(BigDecimal axReportA4) {
        this.axReportA4 = axReportA4;
    }

    @Basic
    @Column(name = "A_X_REPORT_B1", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportB1() {
        return axReportB1;
    }

    public void setAxReportB1(BigDecimal axReportB1) {
        this.axReportB1 = axReportB1;
    }

    @Basic
    @Column(name = "A_X_REPORT_B2", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportB2() {
        return axReportB2;
    }

    public void setAxReportB2(BigDecimal axReportB2) {
        this.axReportB2 = axReportB2;
    }

    @Basic
    @Column(name = "A_X_REPORT_B3", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportB3() {
        return axReportB3;
    }

    public void setAxReportB3(BigDecimal axReportB3) {
        this.axReportB3 = axReportB3;
    }

    @Basic
    @Column(name = "A_X_REPORT_B4", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportB4() {
        return axReportB4;
    }

    public void setAxReportB4(BigDecimal axReportB4) {
        this.axReportB4 = axReportB4;
    }

    @Basic
    @Column(name = "A_X_REPORT_C1", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportC1() {
        return axReportC1;
    }

    public void setAxReportC1(BigDecimal axReportC1) {
        this.axReportC1 = axReportC1;
    }

    @Basic
    @Column(name = "A_X_REPORT_C2", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportC2() {
        return axReportC2;
    }

    public void setAxReportC2(BigDecimal axReportC2) {
        this.axReportC2 = axReportC2;
    }

    @Basic
    @Column(name = "A_X_REPORT_C3", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportC3() {
        return axReportC3;
    }

    public void setAxReportC3(BigDecimal axReportC3) {
        this.axReportC3 = axReportC3;
    }

    @Basic
    @Column(name = "A_X_REPORT_C4", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportC4() {
        return axReportC4;
    }

    public void setAxReportC4(BigDecimal axReportC4) {
        this.axReportC4 = axReportC4;
    }

    @Basic
    @Column(name = "A_X_REPORT_C5", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getAxReportC5() {
        return axReportC5;
    }

    public void setAxReportC5(BigDecimal axReportC5) {
        this.axReportC5 = axReportC5;
    }

    @Basic
    @Column(name = "FAPIAO17_A1", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao17A1() {
        return fapiao17A1;
    }

    public void setFapiao17A1(BigDecimal fapiao17A1) {
        this.fapiao17A1 = fapiao17A1;
    }

    @Basic
    @Column(name = "FAPIAO6_A1", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao6A1() {
        return fapiao6A1;
    }

    public void setFapiao6A1(BigDecimal fapiao6A1) {
        this.fapiao6A1 = fapiao6A1;
    }

    @Basic
    @Column(name = "FAPIAO17_A2", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao17A2() {
        return fapiao17A2;
    }

    public void setFapiao17A2(BigDecimal fapiao17A2) {
        this.fapiao17A2 = fapiao17A2;
    }

    @Basic
    @Column(name = "FAPIAO6_A2", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao6A2() {
        return fapiao6A2;
    }

    public void setFapiao6A2(BigDecimal fapiao6A2) {
        this.fapiao6A2 = fapiao6A2;
    }

    @Basic
    @Column(name = "FAPIAO17_E1", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao17E1() {
        return fapiao17E1;
    }

    public void setFapiao17E1(BigDecimal fapiao17E1) {
        this.fapiao17E1 = fapiao17E1;
    }

    @Basic
    @Column(name = "FAPIAO6_E2", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao6E2() {
        return fapiao6E2;
    }

    public void setFapiao6E2(BigDecimal fapiao6E2) {
        this.fapiao6E2 = fapiao6E2;
    }

    @Basic
    @Column(name = "PERIOD", nullable = false)
    public Boolean getPeriod() {
        return period;
    }

    public void setPeriod(Boolean period) {
        this.period = period;
    }

    @Basic
    @Column(name = "YEAR", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getYear() {
        return year;
    }

    public void setYear(Integer year) {
        this.year = year;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "FAPIAO17_B", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao17B() {
        return fapiao17B;
    }

    public void setFapiao17B(BigDecimal fapiao17B) {
        this.fapiao17B = fapiao17B;
    }

    @Basic
    @Column(name = "FAPIAO6_B", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao6B() {
        return fapiao6B;
    }

    public void setFapiao6B(BigDecimal fapiao6B) {
        this.fapiao6B = fapiao6B;
    }

    @Basic
    @Column(name = "FAPIAO17_E", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao17E() {
        return fapiao17E;
    }

    public void setFapiao17E(BigDecimal fapiao17E) {
        this.fapiao17E = fapiao17E;
    }

    @Basic
    @Column(name = "FAPIAO6_E", nullable = true, precision = 2)
    @ColumnDefault(DEF_DEFAULT_BIG_DECIMAL)
    public BigDecimal getFapiao6E() {
        return fapiao6E;
    }

    public void setFapiao6E(BigDecimal fapiao6E) {
        this.fapiao6E = fapiao6E;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ReconciliationEntityOverview that = (ReconciliationEntityOverview) o;
        return period == that.period &&
                year == that.year &&
                Objects.equals(id, that.id) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(organizationCode, that.organizationCode) &&
                Objects.equals(organizationName, that.organizationName) &&
                Objects.equals(axReportA1, that.axReportA1) &&
                Objects.equals(axReportA2, that.axReportA2) &&
                Objects.equals(axReportA3, that.axReportA3) &&
                Objects.equals(axReportA4, that.axReportA4) &&
                Objects.equals(axReportB1, that.axReportB1) &&
                Objects.equals(axReportB2, that.axReportB2) &&
                Objects.equals(axReportB3, that.axReportB3) &&
                Objects.equals(axReportB4, that.axReportB4) &&
                Objects.equals(axReportC1, that.axReportC1) &&
                Objects.equals(axReportC2, that.axReportC2) &&
                Objects.equals(axReportC3, that.axReportC3) &&
                Objects.equals(axReportC4, that.axReportC4) &&
                Objects.equals(axReportC5, that.axReportC5) &&
                Objects.equals(fapiao17A1, that.fapiao17A1) &&
                Objects.equals(fapiao6A1, that.fapiao6A1) &&
                Objects.equals(fapiao17A2, that.fapiao17A2) &&
                Objects.equals(fapiao6A2, that.fapiao6A2) &&
                Objects.equals(fapiao17E1, that.fapiao17E1) &&
                Objects.equals(fapiao6E2, that.fapiao6E2) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(fapiao17B, that.fapiao17B) &&
                Objects.equals(fapiao6B, that.fapiao6B) &&
                Objects.equals(fapiao17E, that.fapiao17E) &&
                Objects.equals(fapiao6E, that.fapiao6E);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, organizationId, organizationCode, organizationName, axReportA1, axReportA2, axReportA3, axReportA4, axReportB1, axReportB2, axReportB3, axReportB4, axReportC1, axReportC2, axReportC3, axReportC4, axReportC5, fapiao17A1, fapiao6A1, fapiao17A2, fapiao6A2, fapiao17E1, fapiao6E2, period, year, updateTime, fapiao17B, fapiao6B, fapiao17E, fapiao6E);
    }
}
