package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "REPORT_CONFIGURATION", schema = PROJECT_ADMIN, catalog = "")
public class ReportConfiguration {
    private String id;
    private String templateId;
    private Integer rowIndex;
    private String rowName;
    private Integer columnIndex;
    private Integer columnEndIndex;
    private String columnName;
    private String accountCode;
    private String comment;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "TEMPLATE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTemplateId() {
        return templateId;
    }

    public void setTemplateId(String templateId) {
        this.templateId = templateId;
    }

    @Basic
    @Column(name = "ROW_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getRowIndex() {
        return rowIndex;
    }

    public void setRowIndex(Integer rowIndex) {
        this.rowIndex = rowIndex;
    }

    @Basic
    @Column(name = "ROW_NAME", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getRowName() {
        return rowName;
    }

    public void setRowName(String rowName) {
        this.rowName = rowName;
    }

    @Basic
    @Column(name = "COLUMN_INDEX", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getColumnIndex() {
        return columnIndex;
    }

    public void setColumnIndex(Integer columnIndex) {
        this.columnIndex = columnIndex;
    }

    @Basic
    @Column(name = "COLUMN_END_INDEX", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getColumnEndIndex() {
        return columnEndIndex;
    }

    public void setColumnEndIndex(Integer columnEndIndex) {
        this.columnEndIndex = columnEndIndex;
    }

    @Basic
    @Column(name = "COLUMN_NAME", nullable = false, columnDefinition = DEF_BIG_STRING)
    public String getColumnName() {
        return columnName;
    }

    public void setColumnName(String columnName) {
        this.columnName = columnName;
    }

    @Basic
    @Column(name = "ACCOUNT_CODE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getAccountCode() {
        return accountCode;
    }

    public void setAccountCode(String accountCode) {
        this.accountCode = accountCode;
    }

    @Basic
    @Column(name = B_Delimiter + "COMMENT" + E_Delimiter, nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ReportConfiguration that = (ReportConfiguration) o;
        return rowIndex == that.rowIndex &&
                columnIndex == that.columnIndex &&
                Objects.equals(id, that.id) &&
                Objects.equals(templateId, that.templateId) &&
                Objects.equals(rowName, that.rowName) &&
                Objects.equals(columnEndIndex, that.columnEndIndex) &&
                Objects.equals(columnName, that.columnName) &&
                Objects.equals(accountCode, that.accountCode) &&
                Objects.equals(comment, that.comment);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, templateId, rowIndex, rowName, columnIndex, columnEndIndex, columnName, accountCode, comment);
    }
}
