package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Arrays;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_NUMBER;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "SYSDIAGRAMS", schema = PROJECT_ADMIN, catalog = "")
public class Sysdiagrams {
    private String name;
    private Integer principalId;
    private Integer diagramId;
    private Integer version;
    private Boolean[] definition;

    @Id
    @Column(name = "NAME", nullable = true, length = 128)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "PRINCIPAL_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPrincipalId() {
        return principalId;
    }

    public void setPrincipalId(Integer principalId) {
        this.principalId = principalId;
    }

    @Basic
    @Column(name = "DIAGRAM_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getDiagramId() {
        return diagramId;
    }

    public void setDiagramId(Integer diagramId) {
        this.diagramId = diagramId;
    }

    @Basic
    @Column(name = "VERSION", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    @Basic
    @Column(name = "DEFINITION", nullable = true)
    public Boolean[] getDefinition() {
        return definition;
    }

    public void setDefinition(Boolean[] definition) {
        this.definition = definition;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Sysdiagrams that = (Sysdiagrams) o;
        return Objects.equals(name, that.name) &&
                Objects.equals(principalId, that.principalId) &&
                Objects.equals(diagramId, that.diagramId) &&
                Objects.equals(version, that.version) &&
                Arrays.equals(definition, that.definition);
    }

    @Override
    public int hashCode() {
        Integer result = Objects.hash(name, principalId, diagramId, version);
        result = 31 * result + Arrays.hashCode(definition);
        return result;
    }
}
