package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "TAX_CONTROL_DISK", schema = PROJECT_ADMIN, catalog = "")
public class TaxControlDisk {
    private String id;
    private String kpjh;
    private String qymc;
    private String qysh;
    private String jmbbh;
    private String dzfpFlag;
    private String sfjyzs;
    private String swjgdm;
    private String jssz;
    private String jspbh;
    private String equipmentSupplier;
    private String organizationId;
    private String taxControlDiskSerialNumber;
    private String taxControlDiskNo;
    private String taxControlDiskDescribe;
    private String taxControlDiskUser;
    private String department;
    private String mobile;
    private String email;
    private String taxControlUrl;
    private String taxControlPwd;
    private Boolean taxControlStatus;
    private Boolean diskType;
    private Date createTime;
    private Date updateTime;
    private String keyPwd;
    private String taxPayerNumber;
    private Integer topMargin;
    private Integer leftMargin;
    private String failMsg;
    private String mainTaxAuthoritiesName;
    private String mainTaxAuthoritiesCode;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "K_P_J_H", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getKpjh() {
        return kpjh;
    }

    public void setKpjh(String kpjh) {
        this.kpjh = kpjh;
    }

    @Basic
    @Column(name = "Q_Y_M_C", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getQymc() {
        return qymc;
    }

    public void setQymc(String qymc) {
        this.qymc = qymc;
    }

    @Basic
    @Column(name = "Q_Y_S_H", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getQysh() {
        return qysh;
    }

    public void setQysh(String qysh) {
        this.qysh = qysh;
    }

    @Basic
    @Column(name = "J_M_B_B_H", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getJmbbh() {
        return jmbbh;
    }

    public void setJmbbh(String jmbbh) {
        this.jmbbh = jmbbh;
    }

    @Basic
    @Column(name = "D_Z_F_P_FLAG", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDzfpFlag() {
        return dzfpFlag;
    }

    public void setDzfpFlag(String dzfpFlag) {
        this.dzfpFlag = dzfpFlag;
    }

    @Basic
    @Column(name = "S_F_J_Y_Z_S", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSfjyzs() {
        return sfjyzs;
    }

    public void setSfjyzs(String sfjyzs) {
        this.sfjyzs = sfjyzs;
    }

    @Basic
    @Column(name = "S_W_J_G_D_M", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getSwjgdm() {
        return swjgdm;
    }

    public void setSwjgdm(String swjgdm) {
        this.swjgdm = swjgdm;
    }

    @Basic
    @Column(name = "J_S_S_Z", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getJssz() {
        return jssz;
    }

    public void setJssz(String jssz) {
        this.jssz = jssz;
    }

    @Basic
    @Column(name = "J_S_P_B_H", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getJspbh() {
        return jspbh;
    }

    public void setJspbh(String jspbh) {
        this.jspbh = jspbh;
    }

    @Basic
    @Column(name = "EQUIPMENT_SUPPLIER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEquipmentSupplier() {
        return equipmentSupplier;
    }

    public void setEquipmentSupplier(String equipmentSupplier) {
        this.equipmentSupplier = equipmentSupplier;
    }

    @Basic
    @Column(name = "ORGANIZATION_ID", nullable = true, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    @Basic
    @Column(name = "TAX_CONTROL_DISK_SERIAL_NUMBER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxControlDiskSerialNumber() {
        return taxControlDiskSerialNumber;
    }

    public void setTaxControlDiskSerialNumber(String taxControlDiskSerialNumber) {
        this.taxControlDiskSerialNumber = taxControlDiskSerialNumber;
    }

    @Basic
    @Column(name = "TAX_CONTROL_DISK_NO", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxControlDiskNo() {
        return taxControlDiskNo;
    }

    public void setTaxControlDiskNo(String taxControlDiskNo) {
        this.taxControlDiskNo = taxControlDiskNo;
    }

    @Basic
    @Column(name = "TAX_CONTROL_DISK_DESCRIBE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxControlDiskDescribe() {
        return taxControlDiskDescribe;
    }

    public void setTaxControlDiskDescribe(String taxControlDiskDescribe) {
        this.taxControlDiskDescribe = taxControlDiskDescribe;
    }

    @Basic
    @Column(name = "TAX_CONTROL_DISK_USER", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxControlDiskUser() {
        return taxControlDiskUser;
    }

    public void setTaxControlDiskUser(String taxControlDiskUser) {
        this.taxControlDiskUser = taxControlDiskUser;
    }

    @Basic
    @Column(name = "DEPARTMENT", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getDepartment() {
        return department;
    }

    public void setDepartment(String department) {
        this.department = department;
    }

    @Basic
    @Column(name = "MOBILE", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    @Basic
    @Column(name = "EMAIL", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    @Basic
    @Column(name = "TAX_CONTROL_URL", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getTaxControlUrl() {
        return taxControlUrl;
    }

    public void setTaxControlUrl(String taxControlUrl) {
        this.taxControlUrl = taxControlUrl;
    }

    @Basic
    @Column(name = "TAX_CONTROL_PWD", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getTaxControlPwd() {
        return taxControlPwd;
    }

    public void setTaxControlPwd(String taxControlPwd) {
        this.taxControlPwd = taxControlPwd;
    }

    @Basic
    @Column(name = "TAX_CONTROL_STATUS", nullable = true)
    public Boolean getTaxControlStatus() {
        return taxControlStatus;
    }

    public void setTaxControlStatus(Boolean taxControlStatus) {
        this.taxControlStatus = taxControlStatus;
    }

    @Basic
    @Column(name = "DISK_TYPE", nullable = true)
    public Boolean getDiskType() {
        return diskType;
    }

    public void setDiskType(Boolean diskType) {
        this.diskType = diskType;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = false, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "KEY_PWD", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getKeyPwd() {
        return keyPwd;
    }

    public void setKeyPwd(String keyPwd) {
        this.keyPwd = keyPwd;
    }

    @Basic
    @Column(name = "TAX_PAYER_NUMBER", nullable = true, length = 50)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getTaxPayerNumber() {
        return taxPayerNumber;
    }

    public void setTaxPayerNumber(String taxPayerNumber) {
        this.taxPayerNumber = taxPayerNumber;
    }

    @Basic
    @Column(name = "TOP_MARGIN", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getTopMargin() {
        return topMargin;
    }

    public void setTopMargin(Integer topMargin) {
        this.topMargin = topMargin;
    }

    @Basic
    @Column(name = "LEFT_MARGIN", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getLeftMargin() {
        return leftMargin;
    }

    public void setLeftMargin(Integer leftMargin) {
        this.leftMargin = leftMargin;
    }

    @Basic
    @Column(name = "FAIL_MSG", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getFailMsg() {
        return failMsg;
    }

    public void setFailMsg(String failMsg) {
        this.failMsg = failMsg;
    }

    @Basic
    @Column(name = "MAIN_TAX_AUTHORITIES_NAME", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMainTaxAuthoritiesName() {
        return mainTaxAuthoritiesName;
    }

    public void setMainTaxAuthoritiesName(String mainTaxAuthoritiesName) {
        this.mainTaxAuthoritiesName = mainTaxAuthoritiesName;
    }

    @Basic
    @Column(name = "MAIN_TAX_AUTHORITIES_CODE", nullable = true, length = 255)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getMainTaxAuthoritiesCode() {
        return mainTaxAuthoritiesCode;
    }

    public void setMainTaxAuthoritiesCode(String mainTaxAuthoritiesCode) {
        this.mainTaxAuthoritiesCode = mainTaxAuthoritiesCode;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        TaxControlDisk that = (TaxControlDisk) o;
        return topMargin == that.topMargin &&
                leftMargin == that.leftMargin &&
                Objects.equals(id, that.id) &&
                Objects.equals(kpjh, that.kpjh) &&
                Objects.equals(qymc, that.qymc) &&
                Objects.equals(qysh, that.qysh) &&
                Objects.equals(jmbbh, that.jmbbh) &&
                Objects.equals(dzfpFlag, that.dzfpFlag) &&
                Objects.equals(sfjyzs, that.sfjyzs) &&
                Objects.equals(swjgdm, that.swjgdm) &&
                Objects.equals(jssz, that.jssz) &&
                Objects.equals(jspbh, that.jspbh) &&
                Objects.equals(equipmentSupplier, that.equipmentSupplier) &&
                Objects.equals(organizationId, that.organizationId) &&
                Objects.equals(taxControlDiskSerialNumber, that.taxControlDiskSerialNumber) &&
                Objects.equals(taxControlDiskNo, that.taxControlDiskNo) &&
                Objects.equals(taxControlDiskDescribe, that.taxControlDiskDescribe) &&
                Objects.equals(taxControlDiskUser, that.taxControlDiskUser) &&
                Objects.equals(department, that.department) &&
                Objects.equals(mobile, that.mobile) &&
                Objects.equals(email, that.email) &&
                Objects.equals(taxControlUrl, that.taxControlUrl) &&
                Objects.equals(taxControlPwd, that.taxControlPwd) &&
                Objects.equals(taxControlStatus, that.taxControlStatus) &&
                Objects.equals(diskType, that.diskType) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(keyPwd, that.keyPwd) &&
                Objects.equals(taxPayerNumber, that.taxPayerNumber) &&
                Objects.equals(failMsg, that.failMsg) &&
                Objects.equals(mainTaxAuthoritiesName, that.mainTaxAuthoritiesName) &&
                Objects.equals(mainTaxAuthoritiesCode, that.mainTaxAuthoritiesCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, kpjh, qymc, qysh, jmbbh, dzfpFlag, sfjyzs, swjgdm, jssz, jspbh, equipmentSupplier, organizationId, taxControlDiskSerialNumber, taxControlDiskNo, taxControlDiskDescribe, taxControlDiskUser, department, mobile, email, taxControlUrl, taxControlPwd, taxControlStatus, diskType, createTime, updateTime, keyPwd, taxPayerNumber, topMargin, leftMargin, failMsg, mainTaxAuthoritiesName, mainTaxAuthoritiesCode);
    }
}
