package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "TAX_DOCUMENT_CATEGORY", schema = PROJECT_ADMIN, catalog = "")
public class TaxDocumentCategory {
    private String id;
    private String code;
    private String parentCode;
    private String name;
    private Integer codeLevel;
    private Boolean isActive;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "CODE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Basic
    @Column(name = "PARENT_CODE", nullable = true, length = 200)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getParentCode() {
        return parentCode;
    }

    public void setParentCode(String parentCode) {
        this.parentCode = parentCode;
    }

    @Basic
    @Column(name = "NAME", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "CODE_LEVEL", nullable = false)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getCodeLevel() {
        return codeLevel;
    }

    public void setCodeLevel(Integer codeLevel) {
        this.codeLevel = codeLevel;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        TaxDocumentCategory that = (TaxDocumentCategory) o;
        return codeLevel == that.codeLevel &&
                isActive == that.isActive &&
                Objects.equals(id, that.id) &&
                Objects.equals(code, that.code) &&
                Objects.equals(parentCode, that.parentCode) &&
                Objects.equals(name, that.name);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, code, parentCode, name, codeLevel, isActive);
    }
}
