package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "WORKFLOW_APPROVE_REPORT_LOG", schema = PROJECT_ADMIN, catalog = "")
public class WorkflowApproveReportLog {
    private String id;
    private String dbName;
    private Integer periodId;
    private Boolean orderIndex;
    private String remark;
    private Boolean operationTypeId;
    private String operationTypeName;
    private String templateCode;
    private String templateName;
    private String creatorId;
    private Date createTime;
    private Date updateTime;
    private String updatorId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "DB_NAME", nullable = true, length = 125)
    public String getDbName() {
        return dbName;
    }

    public void setDbName(String dbName) {
        this.dbName = dbName;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = true)
    public Boolean getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Boolean orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Basic
    @Column(name = "REMARK", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Basic
    @Column(name = "OPERATION_TYPE_ID", nullable = true)
    public Boolean getOperationTypeId() {
        return operationTypeId;
    }

    public void setOperationTypeId(Boolean operationTypeId) {
        this.operationTypeId = operationTypeId;
    }

    @Basic
    @Column(name = "OPERATION_TYPE_NAME", nullable = true, length = 100)
    public String getOperationTypeName() {
        return operationTypeName;
    }

    public void setOperationTypeName(String operationTypeName) {
        this.operationTypeName = operationTypeName;
    }

    @Basic
    @Column(name = "TEMPLATE_CODE", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getTemplateCode() {
        return templateCode;
    }

    public void setTemplateCode(String templateCode) {
        this.templateCode = templateCode;
    }

    @Basic
    @Column(name = "TEMPLATE_NAME", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getTemplateName() {
        return templateName;
    }

    public void setTemplateName(String templateName) {
        this.templateName = templateName;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "UPDATOR_ID", nullable = true, length = 128)
    public String getUpdatorId() {
        return updatorId;
    }

    public void setUpdatorId(String updatorId) {
        this.updatorId = updatorId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        WorkflowApproveReportLog that = (WorkflowApproveReportLog) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(dbName, that.dbName) &&
                Objects.equals(periodId, that.periodId) &&
                Objects.equals(orderIndex, that.orderIndex) &&
                Objects.equals(remark, that.remark) &&
                Objects.equals(operationTypeId, that.operationTypeId) &&
                Objects.equals(operationTypeName, that.operationTypeName) &&
                Objects.equals(templateCode, that.templateCode) &&
                Objects.equals(templateName, that.templateName) &&
                Objects.equals(creatorId, that.creatorId) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(updatorId, that.updatorId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, dbName, periodId, orderIndex, remark, operationTypeId, operationTypeName, templateCode, templateName, creatorId, createTime, updateTime, updatorId);
    }
}
