package pwc.taxtech.drop;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "WORKFLOW_AUDIT_REPORT_LEVEL", schema = PROJECT_ADMIN, catalog = "")
public class WorkflowAuditReportLevel {
    private String id;
    private String workflowNodeId;
    private String name;
    private Boolean isUserAccessible;
    private Boolean orderIndex;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "WORKFLOW_NODE_ID", nullable = false, length = 128)
    public String getWorkflowNodeId() {
        return workflowNodeId;
    }

    public void setWorkflowNodeId(String workflowNodeId) {
        this.workflowNodeId = workflowNodeId;
    }

    @Basic
    @Column(name = "NAME", nullable = false, length = 100)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "IS_USER_ACCESSIBLE", nullable = false)
    public Boolean getIsUserAccessible() {
        return isUserAccessible;
    }

    public void setIsUserAccessible(Boolean isUserAccessible) {
        this.isUserAccessible = isUserAccessible;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = false)
    public Boolean getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Boolean orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        WorkflowAuditReportLevel that = (WorkflowAuditReportLevel) o;
        return isUserAccessible == that.isUserAccessible &&
                orderIndex == that.orderIndex &&
                Objects.equals(id, that.id) &&
                Objects.equals(workflowNodeId, that.workflowNodeId) &&
                Objects.equals(name, that.name);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, workflowNodeId, name, isUserAccessible, orderIndex);
    }
}
