package pwc.taxtech.drop;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "WORKFLOW_MESSAGE", schema = PROJECT_ADMIN, catalog = "")
public class WorkflowMessage {
    private String id;
    private String workflowTaskId;
    private String messageCategoryId;
    private String workflowAuditReportLevelId;
    private Boolean priority;
    private Boolean offsetHours;
    private Boolean isUserAccessible;
    private Boolean isActive;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "WORKFLOW_TASK_ID", nullable = false, length = 128)
    public String getWorkflowTaskId() {
        return workflowTaskId;
    }

    public void setWorkflowTaskId(String workflowTaskId) {
        this.workflowTaskId = workflowTaskId;
    }

    @Basic
    @Column(name = "MESSAGE_CATEGORY_ID", nullable = false, length = 128)
    public String getMessageCategoryId() {
        return messageCategoryId;
    }

    public void setMessageCategoryId(String messageCategoryId) {
        this.messageCategoryId = messageCategoryId;
    }

    @Basic
    @Column(name = "WORKFLOW_AUDIT_REPORT_LEVEL_ID", nullable = true, length = 128)
    public String getWorkflowAuditReportLevelId() {
        return workflowAuditReportLevelId;
    }

    public void setWorkflowAuditReportLevelId(String workflowAuditReportLevelId) {
        this.workflowAuditReportLevelId = workflowAuditReportLevelId;
    }

    @Basic
    @Column(name = "PRIORITY", nullable = false)
    public Boolean getPriority() {
        return priority;
    }

    public void setPriority(Boolean priority) {
        this.priority = priority;
    }

    @Basic
    @Column(name = "OFFSET_HOURS", nullable = false)
    public Boolean getOffsetHours() {
        return offsetHours;
    }

    public void setOffsetHours(Boolean offsetHours) {
        this.offsetHours = offsetHours;
    }

    @Basic
    @Column(name = "IS_USER_ACCESSIBLE", nullable = false)
    public Boolean getIsUserAccessible() {
        return isUserAccessible;
    }

    public void setIsUserAccessible(Boolean isUserAccessible) {
        this.isUserAccessible = isUserAccessible;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        WorkflowMessage that = (WorkflowMessage) o;
        return priority == that.priority &&
                offsetHours == that.offsetHours &&
                isUserAccessible == that.isUserAccessible &&
                isActive == that.isActive &&
                Objects.equals(id, that.id) &&
                Objects.equals(workflowTaskId, that.workflowTaskId) &&
                Objects.equals(messageCategoryId, that.messageCategoryId) &&
                Objects.equals(workflowAuditReportLevelId, that.workflowAuditReportLevelId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, workflowTaskId, messageCategoryId, workflowAuditReportLevelId, priority, offsetHours, isUserAccessible, isActive);
    }
}
