package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.sql.Date;
import java.util.Objects;

import static pwc.taxtech.Const.*;

@Entity
@Table(name = "WORKFLOW_MESSAGE_RESULT", schema = PROJECT_ADMIN, catalog = "")
public class WorkflowMessageResult {
    private String id;
    private String dbName;
    private Integer periodId;
    private String messageCategoryId;
    private String messageTitle;
    private String messageDetail;
    private Date sendingDateTime;
    private Date deadlineDateTime;
    private String category;
    private String remarks;
    private Boolean priority;
    private Boolean isRead;
    private Boolean serviceTypeId;
    private String workflowNodeId;
    private String workflowTaskId;
    private String workflowMessageId;
    private Boolean offsetHours;
    private Date createTime;
    private Date updateTime;
    private String creatorId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "DB_NAME", nullable = true, length = 128)
    public String getDbName() {
        return dbName;
    }

    public void setDbName(String dbName) {
        this.dbName = dbName;
    }

    @Basic
    @Column(name = "PERIOD_ID", nullable = true)
    @ColumnDefault(DEF_DEFAULT_NUMBER)
    public Integer getPeriodId() {
        return periodId;
    }

    public void setPeriodId(Integer periodId) {
        this.periodId = periodId;
    }

    @Basic
    @Column(name = "MESSAGE_CATEGORY_ID", nullable = true, length = 128)
    public String getMessageCategoryId() {
        return messageCategoryId;
    }

    public void setMessageCategoryId(String messageCategoryId) {
        this.messageCategoryId = messageCategoryId;
    }

    @Basic
    @Column(name = "MESSAGE_TITLE", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getMessageTitle() {
        return messageTitle;
    }

    public void setMessageTitle(String messageTitle) {
        this.messageTitle = messageTitle;
    }

    @Basic
    @Column(name = "MESSAGE_DETAIL", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getMessageDetail() {
        return messageDetail;
    }

    public void setMessageDetail(String messageDetail) {
        this.messageDetail = messageDetail;
    }

    @Basic
    @Column(name = "SENDING_DATE_TIME", nullable = true, columnDefinition = DEF_DEFAULT_DATE)
    public Date getSendingDateTime() {
        return sendingDateTime;
    }

    public void setSendingDateTime(Date sendingDateTime) {
        this.sendingDateTime = sendingDateTime;
    }

    @Basic
    @Column(name = "DEADLINE_DATE_TIME", nullable = true)
    public Date getDeadlineDateTime() {
        return deadlineDateTime;
    }

    public void setDeadlineDateTime(Date deadlineDateTime) {
        this.deadlineDateTime = deadlineDateTime;
    }

    @Basic
    @Column(name = "CATEGORY", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    @Basic
    @Column(name = "REMARKS", nullable = true, columnDefinition = DEF_BIG_STRING)
    public String getRemarks() {
        return remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    @Basic
    @Column(name = "PRIORITY", nullable = true)
    public Boolean getPriority() {
        return priority;
    }

    public void setPriority(Boolean priority) {
        this.priority = priority;
    }

    @Basic
    @Column(name = "IS_READ", nullable = true)
    public Boolean getIsRead() {
        return isRead;
    }

    public void setIsRead(Boolean isRead) {
        this.isRead = isRead;
    }

    @Basic
    @Column(name = "SERVICE_TYPE_ID", nullable = true)
    public Boolean getServiceTypeId() {
        return serviceTypeId;
    }

    public void setServiceTypeId(Boolean serviceTypeId) {
        this.serviceTypeId = serviceTypeId;
    }

    @Basic
    @Column(name = "WORKFLOW_NODE_ID", nullable = true, length = 128)
    public String getWorkflowNodeId() {
        return workflowNodeId;
    }

    public void setWorkflowNodeId(String workflowNodeId) {
        this.workflowNodeId = workflowNodeId;
    }

    @Basic
    @Column(name = "WORKFLOW_TASK_ID", nullable = true, length = 128)
    public String getWorkflowTaskId() {
        return workflowTaskId;
    }

    public void setWorkflowTaskId(String workflowTaskId) {
        this.workflowTaskId = workflowTaskId;
    }

    @Basic
    @Column(name = "WORKFLOW_MESSAGE_ID", nullable = true, length = 128)
    public String getWorkflowMessageId() {
        return workflowMessageId;
    }

    public void setWorkflowMessageId(String workflowMessageId) {
        this.workflowMessageId = workflowMessageId;
    }

    @Basic
    @Column(name = "OFFSET_HOURS", nullable = true)
    public Boolean getOffsetHours() {
        return offsetHours;
    }

    public void setOffsetHours(Boolean offsetHours) {
        this.offsetHours = offsetHours;
    }

    @Basic
    @Column(name = "CREATE_TIME", nullable = true)
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "UPDATE_TIME", nullable = true)
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Basic
    @Column(name = "CREATOR_ID", nullable = true, length = 128)
    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        WorkflowMessageResult that = (WorkflowMessageResult) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(dbName, that.dbName) &&
                Objects.equals(periodId, that.periodId) &&
                Objects.equals(messageCategoryId, that.messageCategoryId) &&
                Objects.equals(messageTitle, that.messageTitle) &&
                Objects.equals(messageDetail, that.messageDetail) &&
                Objects.equals(sendingDateTime, that.sendingDateTime) &&
                Objects.equals(deadlineDateTime, that.deadlineDateTime) &&
                Objects.equals(category, that.category) &&
                Objects.equals(remarks, that.remarks) &&
                Objects.equals(priority, that.priority) &&
                Objects.equals(isRead, that.isRead) &&
                Objects.equals(serviceTypeId, that.serviceTypeId) &&
                Objects.equals(workflowNodeId, that.workflowNodeId) &&
                Objects.equals(workflowTaskId, that.workflowTaskId) &&
                Objects.equals(workflowMessageId, that.workflowMessageId) &&
                Objects.equals(offsetHours, that.offsetHours) &&
                Objects.equals(createTime, that.createTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(creatorId, that.creatorId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, dbName, periodId, messageCategoryId, messageTitle, messageDetail, sendingDateTime, deadlineDateTime, category, remarks, priority, isRead, serviceTypeId, workflowNodeId, workflowTaskId, workflowMessageId, offsetHours, createTime, updateTime, creatorId);
    }
}
