package pwc.taxtech.drop;

import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.DEF_DEFAULT_STRING;
import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "WORKFLOW_MESSAGE_USER", schema = PROJECT_ADMIN, catalog = "")
public class WorkflowMessageUser {
    private String id;
    private String workflowMessageId;
    private String userId;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "WORKFLOW_MESSAGE_ID", nullable = false, length = 128)
    @ColumnDefault(DEF_DEFAULT_STRING)
    public String getWorkflowMessageId() {
        return workflowMessageId;
    }

    public void setWorkflowMessageId(String workflowMessageId) {
        this.workflowMessageId = workflowMessageId;
    }

    @Basic
    @Column(name = "USER_ID", nullable = false, length = 128)
    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        WorkflowMessageUser that = (WorkflowMessageUser) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(workflowMessageId, that.workflowMessageId) &&
                Objects.equals(userId, that.userId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, workflowMessageId, userId);
    }
}
