package pwc.taxtech.drop;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "WORKFLOW_NODE", schema = PROJECT_ADMIN, catalog = "")
public class WorkflowNode {
    private String id;
    private String workflowId;
    private String dictionaryNodeNameId;
    private Boolean isFixedType;
    private Boolean fixedDateType;
    private Boolean month;
    private Boolean day;
    private String referenceNode;
    private String referenceOffsetType;
    private Boolean referenceOffset;
    private Boolean isActive;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "WORKFLOW_ID", nullable = false, length = 128)
    public String getWorkflowId() {
        return workflowId;
    }

    public void setWorkflowId(String workflowId) {
        this.workflowId = workflowId;
    }

    @Basic
    @Column(name = "DICTIONARY_NODE_NAME_ID", nullable = false, length = 128)
    public String getDictionaryNodeNameId() {
        return dictionaryNodeNameId;
    }

    public void setDictionaryNodeNameId(String dictionaryNodeNameId) {
        this.dictionaryNodeNameId = dictionaryNodeNameId;
    }

    @Basic
    @Column(name = "IS_FIXED_TYPE", nullable = false)
    public Boolean getIsFixedType() {
        return isFixedType;
    }

    public void setIsFixedType(Boolean isFixedType) {
        this.isFixedType = isFixedType;
    }

    @Basic
    @Column(name = "FIXED_DATE_TYPE", nullable = false)
    public Boolean getFixedDateType() {
        return fixedDateType;
    }

    public void setFixedDateType(Boolean fixedDateType) {
        this.fixedDateType = fixedDateType;
    }

    @Basic
    @Column(name = "MONTH", nullable = true)
    public Boolean getMonth() {
        return month;
    }

    public void setMonth(Boolean month) {
        this.month = month;
    }

    @Basic
    @Column(name = "DAY", nullable = true)
    public Boolean getDay() {
        return day;
    }

    public void setDay(Boolean day) {
        this.day = day;
    }

    @Basic
    @Column(name = "REFERENCE_NODE", nullable = true, length = 128)
    public String getReferenceNode() {
        return referenceNode;
    }

    public void setReferenceNode(String referenceNode) {
        this.referenceNode = referenceNode;
    }

    @Basic
    @Column(name = "REFERENCE_OFFSET_TYPE", nullable = true, length = 50)
    public String getReferenceOffsetType() {
        return referenceOffsetType;
    }

    public void setReferenceOffsetType(String referenceOffsetType) {
        this.referenceOffsetType = referenceOffsetType;
    }

    @Basic
    @Column(name = "REFERENCE_OFFSET", nullable = true)
    public Boolean getReferenceOffset() {
        return referenceOffset;
    }

    public void setReferenceOffset(Boolean referenceOffset) {
        this.referenceOffset = referenceOffset;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        WorkflowNode that = (WorkflowNode) o;
        return isFixedType == that.isFixedType &&
                fixedDateType == that.fixedDateType &&
                isActive == that.isActive &&
                Objects.equals(id, that.id) &&
                Objects.equals(workflowId, that.workflowId) &&
                Objects.equals(dictionaryNodeNameId, that.dictionaryNodeNameId) &&
                Objects.equals(month, that.month) &&
                Objects.equals(day, that.day) &&
                Objects.equals(referenceNode, that.referenceNode) &&
                Objects.equals(referenceOffsetType, that.referenceOffsetType) &&
                Objects.equals(referenceOffset, that.referenceOffset);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, workflowId, dictionaryNodeNameId, isFixedType, fixedDateType, month, day, referenceNode, referenceOffsetType, referenceOffset, isActive);
    }
}
