package pwc.taxtech.drop;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Objects;

import static pwc.taxtech.Const.PROJECT_ADMIN;

@Entity
@Table(name = "WORKFLOW_TASK", schema = PROJECT_ADMIN, catalog = "")
public class WorkflowTask {
    private String id;
    private String dictionaryTaskNameId;
    private String workflowNodeId;
    private String workflowAuditReportLevelId;
    private Boolean orderIndex;
    private Boolean isActive;
    private Boolean isMandatory;

    @Id
    @Column(name = "ID", nullable = false, length = 128)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "DICTIONARY_TASK_NAME_ID", nullable = false, length = 128)
    public String getDictionaryTaskNameId() {
        return dictionaryTaskNameId;
    }

    public void setDictionaryTaskNameId(String dictionaryTaskNameId) {
        this.dictionaryTaskNameId = dictionaryTaskNameId;
    }

    @Basic
    @Column(name = "WORKFLOW_NODE_ID", nullable = false, length = 128)
    public String getWorkflowNodeId() {
        return workflowNodeId;
    }

    public void setWorkflowNodeId(String workflowNodeId) {
        this.workflowNodeId = workflowNodeId;
    }

    @Basic
    @Column(name = "WORKFLOW_AUDIT_REPORT_LEVEL_ID", nullable = true, length = 128)
    public String getWorkflowAuditReportLevelId() {
        return workflowAuditReportLevelId;
    }

    public void setWorkflowAuditReportLevelId(String workflowAuditReportLevelId) {
        this.workflowAuditReportLevelId = workflowAuditReportLevelId;
    }

    @Basic
    @Column(name = "ORDER_INDEX", nullable = false)
    public Boolean getOrderIndex() {
        return orderIndex;
    }

    public void setOrderIndex(Boolean orderIndex) {
        this.orderIndex = orderIndex;
    }

    @Basic
    @Column(name = "IS_ACTIVE", nullable = false)
    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    @Basic
    @Column(name = "IS_MANDATORY", nullable = false)
    public Boolean getIsMandatory() {
        return isMandatory;
    }

    public void setIsMandatory(Boolean isMandatory) {
        this.isMandatory = isMandatory;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        WorkflowTask that = (WorkflowTask) o;
        return orderIndex == that.orderIndex &&
                isActive == that.isActive &&
                isMandatory == that.isMandatory &&
                Objects.equals(id, that.id) &&
                Objects.equals(dictionaryTaskNameId, that.dictionaryTaskNameId) &&
                Objects.equals(workflowNodeId, that.workflowNodeId) &&
                Objects.equals(workflowAuditReportLevelId, that.workflowAuditReportLevelId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, dictionaryTaskNameId, workflowNodeId, workflowAuditReportLevelId, orderIndex, isActive, isMandatory);
    }
}
