package com.neo;

import pwc.taxtech.atms.vat.entity.Account;

import javax.persistence.Id;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.lang.reflect.Method;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;

public class GenRepository {
    public static void main(String[] args) throws URISyntaxException, ClassNotFoundException, IOException {
        Class clazz = Account.class;
        String key = "line.separator";
        String res = System.getProperty(key);
        String repositoryPath = "";
        URL url = clazz.getResource("");
        URI uri = url.toURI();
        File file = new File(uri);
        if (repositoryPath.isEmpty()) {
            String basePath = file.getPath().split("target")[0];
            repositoryPath = basePath + "src"
                    + File.separator + "main"
                    + File.separator + "java"
                    + File.separator + "pwc"
                    + File.separator + "taxtech"
                    + File.separator + "vat"
                    + File.separator + "repository" + File.separator;
            System.out.println(repositoryPath);
        }
        File[] files = file.listFiles();
        for (File f : files) {
            String fName = f.getName();
            if (!fName.endsWith(".class")) {
                continue;
            }
            fName = fName.substring(0, fName.length() - 6);
            String className = "pwc.taxtech.vat.entity." + fName;
            clazz = Class.forName(className);
            Method[] methods = clazz.getMethods();
            String idType = "";
            for (Method method : methods) {
                if (method.isAnnotationPresent(Id.class)) {
                    idType = method.getReturnType().getName();
                    break;
                }
            }


            String repositoryFileName = repositoryPath + fName + "Repository.java";
            File repFile = new File(repositoryFileName);
            if (repFile.exists()) {
                repFile.delete();
                repFile.createNewFile();
            }

            try (FileWriter writer = new FileWriter(repFile);) {
                writer.write("package pwc.taxtech.vat.repository;");
                writer.write(res);
                writer.write(res);
                writer.write("import org.springframework.data.repository.CrudRepository;");
                writer.write(res);
                writer.write("import pwc.taxtech.vat.entity." + fName + ";");
                writer.write(res);
                writer.write(res);
                String idString = "";
                if (idType.contains("String")) idString = "String";
                else if (idType.contains("long")) idString = "Long";
                else {
                    System.out.println(fName + " not surpport id type" + idType);
                    idString = "String";
                }
                writer.write("public interface " + fName + "Repository" + " extends CrudRepository<" + fName + ", " + idString + "> {}");
            }
        }
    }
}
